<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayDadosPA ArrayType
 * @subpackage Arrays
 */
class ArrayDadosPA extends AbstractStructArrayBase
{
    /**
     * The dadosPA
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfDadosPA
     */
    public $dadosPA;
    /**
     * Constructor method for ArrayDadosPA
     * @uses ArrayDadosPA::setDadosPA()
     * @param \ArrayType\ArrayOfDadosPA $dadosPA
     */
    public function __construct(\ArrayType\ArrayOfDadosPA $dadosPA = null)
    {
        $this
            ->setDadosPA($dadosPA);
    }
    /**
     * Get dadosPA value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfDadosPA|null
     */
    public function getDadosPA()
    {
        return isset($this->dadosPA) ? $this->dadosPA : null;
    }
    /**
     * Set dadosPA value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfDadosPA $dadosPA
     * @return \ArrayType\ArrayDadosPA
     */
    public function setDadosPA(\ArrayType\ArrayOfDadosPA $dadosPA = null)
    {
        if (is_null($dadosPA) || (is_array($dadosPA) && empty($dadosPA))) {
            unset($this->dadosPA);
        } else {
            $this->dadosPA = $dadosPA;
        }
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \ArrayType\ArrayOfDadosPA|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \ArrayType\ArrayOfDadosPA|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \ArrayType\ArrayOfDadosPA|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \ArrayType\ArrayOfDadosPA|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \ArrayType\ArrayOfDadosPA|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string dadosPA
     */
    public function getAttributeName()
    {
        return 'dadosPA';
    }
}
