<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAlimentadosPA ArrayType
 * @subpackage Arrays
 */
class ArrayOfAlimentadosPA extends AbstractStructArrayBase
{
    /**
     * The AlimentadosPA
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AlimentadosPA[]
     */
    public $AlimentadosPA;
    /**
     * Constructor method for ArrayOfAlimentadosPA
     * @uses ArrayOfAlimentadosPA::setAlimentadosPA()
     * @param \StructType\AlimentadosPA[] $alimentadosPA
     */
    public function __construct(array $alimentadosPA = array())
    {
        $this
            ->setAlimentadosPA($alimentadosPA);
    }
    /**
     * Get AlimentadosPA value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AlimentadosPA[]|null
     */
    public function getAlimentadosPA()
    {
        return isset($this->AlimentadosPA) ? $this->AlimentadosPA : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAlimentadosPA method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAlimentadosPA method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAlimentadosPAForArrayConstraintsFromSetAlimentadosPA(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAlimentadosPAAlimentadosPAItem) {
            // validation for constraint: itemType
            if (!$arrayOfAlimentadosPAAlimentadosPAItem instanceof \StructType\AlimentadosPA) {
                $invalidValues[] = is_object($arrayOfAlimentadosPAAlimentadosPAItem) ? get_class($arrayOfAlimentadosPAAlimentadosPAItem) : sprintf('%s(%s)', gettype($arrayOfAlimentadosPAAlimentadosPAItem), var_export($arrayOfAlimentadosPAAlimentadosPAItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AlimentadosPA property can only contain items of type \StructType\AlimentadosPA, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AlimentadosPA value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AlimentadosPA[] $alimentadosPA
     * @return \ArrayType\ArrayOfAlimentadosPA
     */
    public function setAlimentadosPA(array $alimentadosPA = array())
    {
        // validation for constraint: array
        if ('' !== ($alimentadosPAArrayErrorMessage = self::validateAlimentadosPAForArrayConstraintsFromSetAlimentadosPA($alimentadosPA))) {
            throw new \InvalidArgumentException($alimentadosPAArrayErrorMessage, __LINE__);
        }
        if (is_null($alimentadosPA) || (is_array($alimentadosPA) && empty($alimentadosPA))) {
            unset($this->AlimentadosPA);
        } else {
            $this->AlimentadosPA = $alimentadosPA;
        }
        return $this;
    }
    /**
     * Add item to AlimentadosPA value
     * @throws \InvalidArgumentException
     * @param \StructType\AlimentadosPA $item
     * @return \ArrayType\ArrayOfAlimentadosPA
     */
    public function addToAlimentadosPA(\StructType\AlimentadosPA $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AlimentadosPA) {
            throw new \InvalidArgumentException(sprintf('The AlimentadosPA property can only contain items of type \StructType\AlimentadosPA, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AlimentadosPA[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AlimentadosPA|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AlimentadosPA|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AlimentadosPA|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AlimentadosPA|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AlimentadosPA|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AlimentadosPA
     */
    public function getAttributeName()
    {
        return 'AlimentadosPA';
    }
}
