<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfArrayContribuicoesPSS ArrayType
 * @subpackage Arrays
 */
class ArrayOfArrayContribuicoesPSS extends AbstractStructArrayBase
{
    /**
     * The ArrayContribuicoesPSS
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayContribuicoesPSS[]
     */
    public $ArrayContribuicoesPSS;
    /**
     * Constructor method for ArrayOfArrayContribuicoesPSS
     * @uses ArrayOfArrayContribuicoesPSS::setArrayContribuicoesPSS()
     * @param \ArrayType\ArrayContribuicoesPSS[] $arrayContribuicoesPSS
     */
    public function __construct(array $arrayContribuicoesPSS = array())
    {
        $this
            ->setArrayContribuicoesPSS($arrayContribuicoesPSS);
    }
    /**
     * Get ArrayContribuicoesPSS value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayContribuicoesPSS[]|null
     */
    public function getArrayContribuicoesPSS()
    {
        return isset($this->ArrayContribuicoesPSS) ? $this->ArrayContribuicoesPSS : null;
    }
    /**
     * This method is responsible for validating the values passed to the setArrayContribuicoesPSS method
     * This method is willingly generated in order to preserve the one-line inline validation within the setArrayContribuicoesPSS method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateArrayContribuicoesPSSForArrayConstraintsFromSetArrayContribuicoesPSS(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfArrayContribuicoesPSSArrayContribuicoesPSSItem) {
            // validation for constraint: itemType
            if (!$arrayOfArrayContribuicoesPSSArrayContribuicoesPSSItem instanceof \ArrayType\ArrayContribuicoesPSS) {
                $invalidValues[] = is_object($arrayOfArrayContribuicoesPSSArrayContribuicoesPSSItem) ? get_class($arrayOfArrayContribuicoesPSSArrayContribuicoesPSSItem) : sprintf('%s(%s)', gettype($arrayOfArrayContribuicoesPSSArrayContribuicoesPSSItem), var_export($arrayOfArrayContribuicoesPSSArrayContribuicoesPSSItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ArrayContribuicoesPSS property can only contain items of type \ArrayType\ArrayContribuicoesPSS, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ArrayContribuicoesPSS value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \ArrayType\ArrayContribuicoesPSS[] $arrayContribuicoesPSS
     * @return \ArrayType\ArrayOfArrayContribuicoesPSS
     */
    public function setArrayContribuicoesPSS(array $arrayContribuicoesPSS = array())
    {
        // validation for constraint: array
        if ('' !== ($arrayContribuicoesPSSArrayErrorMessage = self::validateArrayContribuicoesPSSForArrayConstraintsFromSetArrayContribuicoesPSS($arrayContribuicoesPSS))) {
            throw new \InvalidArgumentException($arrayContribuicoesPSSArrayErrorMessage, __LINE__);
        }
        if (is_null($arrayContribuicoesPSS) || (is_array($arrayContribuicoesPSS) && empty($arrayContribuicoesPSS))) {
            unset($this->ArrayContribuicoesPSS);
        } else {
            $this->ArrayContribuicoesPSS = $arrayContribuicoesPSS;
        }
        return $this;
    }
    /**
     * Add item to ArrayContribuicoesPSS value
     * @throws \InvalidArgumentException
     * @param \ArrayType\ArrayContribuicoesPSS $item
     * @return \ArrayType\ArrayOfArrayContribuicoesPSS
     */
    public function addToArrayContribuicoesPSS(\ArrayType\ArrayContribuicoesPSS $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \ArrayType\ArrayContribuicoesPSS) {
            throw new \InvalidArgumentException(sprintf('The ArrayContribuicoesPSS property can only contain items of type \ArrayType\ArrayContribuicoesPSS, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ArrayContribuicoesPSS[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \ArrayType\ArrayContribuicoesPSS|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \ArrayType\ArrayContribuicoesPSS|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \ArrayType\ArrayContribuicoesPSS|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \ArrayType\ArrayContribuicoesPSS|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \ArrayType\ArrayContribuicoesPSS|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ArrayContribuicoesPSS
     */
    public function getAttributeName()
    {
        return 'ArrayContribuicoesPSS';
    }
}
