<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfArrayDadosAfastamento ArrayType
 * @subpackage Arrays
 */
class ArrayOfArrayDadosAfastamento extends AbstractStructArrayBase
{
    /**
     * The ArrayDadosAfastamento
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ArrayDadosAfastamento[]
     */
    public $ArrayDadosAfastamento;
    /**
     * Constructor method for ArrayOfArrayDadosAfastamento
     * @uses ArrayOfArrayDadosAfastamento::setArrayDadosAfastamento()
     * @param \StructType\ArrayDadosAfastamento[] $arrayDadosAfastamento
     */
    public function __construct(array $arrayDadosAfastamento = array())
    {
        $this
            ->setArrayDadosAfastamento($arrayDadosAfastamento);
    }
    /**
     * Get ArrayDadosAfastamento value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ArrayDadosAfastamento[]|null
     */
    public function getArrayDadosAfastamento()
    {
        return isset($this->ArrayDadosAfastamento) ? $this->ArrayDadosAfastamento : null;
    }
    /**
     * This method is responsible for validating the values passed to the setArrayDadosAfastamento method
     * This method is willingly generated in order to preserve the one-line inline validation within the setArrayDadosAfastamento method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateArrayDadosAfastamentoForArrayConstraintsFromSetArrayDadosAfastamento(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfArrayDadosAfastamentoArrayDadosAfastamentoItem) {
            // validation for constraint: itemType
            if (!$arrayOfArrayDadosAfastamentoArrayDadosAfastamentoItem instanceof \StructType\ArrayDadosAfastamento) {
                $invalidValues[] = is_object($arrayOfArrayDadosAfastamentoArrayDadosAfastamentoItem) ? get_class($arrayOfArrayDadosAfastamentoArrayDadosAfastamentoItem) : sprintf('%s(%s)', gettype($arrayOfArrayDadosAfastamentoArrayDadosAfastamentoItem), var_export($arrayOfArrayDadosAfastamentoArrayDadosAfastamentoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ArrayDadosAfastamento property can only contain items of type \StructType\ArrayDadosAfastamento, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ArrayDadosAfastamento value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ArrayDadosAfastamento[] $arrayDadosAfastamento
     * @return \ArrayType\ArrayOfArrayDadosAfastamento
     */
    public function setArrayDadosAfastamento(array $arrayDadosAfastamento = array())
    {
        // validation for constraint: array
        if ('' !== ($arrayDadosAfastamentoArrayErrorMessage = self::validateArrayDadosAfastamentoForArrayConstraintsFromSetArrayDadosAfastamento($arrayDadosAfastamento))) {
            throw new \InvalidArgumentException($arrayDadosAfastamentoArrayErrorMessage, __LINE__);
        }
        if (is_null($arrayDadosAfastamento) || (is_array($arrayDadosAfastamento) && empty($arrayDadosAfastamento))) {
            unset($this->ArrayDadosAfastamento);
        } else {
            $this->ArrayDadosAfastamento = $arrayDadosAfastamento;
        }
        return $this;
    }
    /**
     * Add item to ArrayDadosAfastamento value
     * @throws \InvalidArgumentException
     * @param \StructType\ArrayDadosAfastamento $item
     * @return \ArrayType\ArrayOfArrayDadosAfastamento
     */
    public function addToArrayDadosAfastamento(\StructType\ArrayDadosAfastamento $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ArrayDadosAfastamento) {
            throw new \InvalidArgumentException(sprintf('The ArrayDadosAfastamento property can only contain items of type \StructType\ArrayDadosAfastamento, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ArrayDadosAfastamento[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ArrayDadosAfastamento|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ArrayDadosAfastamento|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ArrayDadosAfastamento|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ArrayDadosAfastamento|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ArrayDadosAfastamento|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ArrayDadosAfastamento
     */
    public function getAttributeName()
    {
        return 'ArrayDadosAfastamento';
    }
}
