<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfArrayDadosFinanceiros ArrayType
 * @subpackage Arrays
 */
class ArrayOfArrayDadosFinanceiros extends AbstractStructArrayBase
{
    /**
     * The ArrayDadosFinanceiros
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ArrayDadosFinanceiros[]
     */
    public $ArrayDadosFinanceiros;
    /**
     * Constructor method for ArrayOfArrayDadosFinanceiros
     * @uses ArrayOfArrayDadosFinanceiros::setArrayDadosFinanceiros()
     * @param \StructType\ArrayDadosFinanceiros[] $arrayDadosFinanceiros
     */
    public function __construct(array $arrayDadosFinanceiros = array())
    {
        $this
            ->setArrayDadosFinanceiros($arrayDadosFinanceiros);
    }
    /**
     * Get ArrayDadosFinanceiros value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ArrayDadosFinanceiros[]|null
     */
    public function getArrayDadosFinanceiros()
    {
        return isset($this->ArrayDadosFinanceiros) ? $this->ArrayDadosFinanceiros : null;
    }
    /**
     * This method is responsible for validating the values passed to the setArrayDadosFinanceiros method
     * This method is willingly generated in order to preserve the one-line inline validation within the setArrayDadosFinanceiros method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateArrayDadosFinanceirosForArrayConstraintsFromSetArrayDadosFinanceiros(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfArrayDadosFinanceirosArrayDadosFinanceirosItem) {
            // validation for constraint: itemType
            if (!$arrayOfArrayDadosFinanceirosArrayDadosFinanceirosItem instanceof \StructType\ArrayDadosFinanceiros) {
                $invalidValues[] = is_object($arrayOfArrayDadosFinanceirosArrayDadosFinanceirosItem) ? get_class($arrayOfArrayDadosFinanceirosArrayDadosFinanceirosItem) : sprintf('%s(%s)', gettype($arrayOfArrayDadosFinanceirosArrayDadosFinanceirosItem), var_export($arrayOfArrayDadosFinanceirosArrayDadosFinanceirosItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ArrayDadosFinanceiros property can only contain items of type \StructType\ArrayDadosFinanceiros, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ArrayDadosFinanceiros value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ArrayDadosFinanceiros[] $arrayDadosFinanceiros
     * @return \ArrayType\ArrayOfArrayDadosFinanceiros
     */
    public function setArrayDadosFinanceiros(array $arrayDadosFinanceiros = array())
    {
        // validation for constraint: array
        if ('' !== ($arrayDadosFinanceirosArrayErrorMessage = self::validateArrayDadosFinanceirosForArrayConstraintsFromSetArrayDadosFinanceiros($arrayDadosFinanceiros))) {
            throw new \InvalidArgumentException($arrayDadosFinanceirosArrayErrorMessage, __LINE__);
        }
        if (is_null($arrayDadosFinanceiros) || (is_array($arrayDadosFinanceiros) && empty($arrayDadosFinanceiros))) {
            unset($this->ArrayDadosFinanceiros);
        } else {
            $this->ArrayDadosFinanceiros = $arrayDadosFinanceiros;
        }
        return $this;
    }
    /**
     * Add item to ArrayDadosFinanceiros value
     * @throws \InvalidArgumentException
     * @param \StructType\ArrayDadosFinanceiros $item
     * @return \ArrayType\ArrayOfArrayDadosFinanceiros
     */
    public function addToArrayDadosFinanceiros(\StructType\ArrayDadosFinanceiros $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ArrayDadosFinanceiros) {
            throw new \InvalidArgumentException(sprintf('The ArrayDadosFinanceiros property can only contain items of type \StructType\ArrayDadosFinanceiros, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ArrayDadosFinanceiros[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ArrayDadosFinanceiros|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ArrayDadosFinanceiros|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ArrayDadosFinanceiros|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ArrayDadosFinanceiros|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ArrayDadosFinanceiros|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ArrayDadosFinanceiros
     */
    public function getAttributeName()
    {
        return 'ArrayDadosFinanceiros';
    }
}
