<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCargoPca ArrayType
 * @subpackage Arrays
 */
class ArrayOfCargoPca extends AbstractStructArrayBase
{
    /**
     * The CargoPca
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CargoPca[]
     */
    public $CargoPca;
    /**
     * Constructor method for ArrayOfCargoPca
     * @uses ArrayOfCargoPca::setCargoPca()
     * @param \StructType\CargoPca[] $cargoPca
     */
    public function __construct(array $cargoPca = array())
    {
        $this
            ->setCargoPca($cargoPca);
    }
    /**
     * Get CargoPca value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CargoPca[]|null
     */
    public function getCargoPca()
    {
        return isset($this->CargoPca) ? $this->CargoPca : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCargoPca method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCargoPca method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCargoPcaForArrayConstraintsFromSetCargoPca(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCargoPcaCargoPcaItem) {
            // validation for constraint: itemType
            if (!$arrayOfCargoPcaCargoPcaItem instanceof \StructType\CargoPca) {
                $invalidValues[] = is_object($arrayOfCargoPcaCargoPcaItem) ? get_class($arrayOfCargoPcaCargoPcaItem) : sprintf('%s(%s)', gettype($arrayOfCargoPcaCargoPcaItem), var_export($arrayOfCargoPcaCargoPcaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CargoPca property can only contain items of type \StructType\CargoPca, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CargoPca value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CargoPca[] $cargoPca
     * @return \ArrayType\ArrayOfCargoPca
     */
    public function setCargoPca(array $cargoPca = array())
    {
        // validation for constraint: array
        if ('' !== ($cargoPcaArrayErrorMessage = self::validateCargoPcaForArrayConstraintsFromSetCargoPca($cargoPca))) {
            throw new \InvalidArgumentException($cargoPcaArrayErrorMessage, __LINE__);
        }
        if (is_null($cargoPca) || (is_array($cargoPca) && empty($cargoPca))) {
            unset($this->CargoPca);
        } else {
            $this->CargoPca = $cargoPca;
        }
        return $this;
    }
    /**
     * Add item to CargoPca value
     * @throws \InvalidArgumentException
     * @param \StructType\CargoPca $item
     * @return \ArrayType\ArrayOfCargoPca
     */
    public function addToCargoPca(\StructType\CargoPca $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CargoPca) {
            throw new \InvalidArgumentException(sprintf('The CargoPca property can only contain items of type \StructType\CargoPca, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CargoPca[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CargoPca|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CargoPca|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CargoPca|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CargoPca|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CargoPca|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CargoPca
     */
    public function getAttributeName()
    {
        return 'CargoPca';
    }
}
