<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDadosAfastamentoPorCpf ArrayType
 * @subpackage Arrays
 */
class ArrayOfDadosAfastamentoPorCpf extends AbstractStructArrayBase
{
    /**
     * The DadosAfastamentoPorCpf
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DadosAfastamentoPorCpf[]
     */
    public $DadosAfastamentoPorCpf;
    /**
     * Constructor method for ArrayOfDadosAfastamentoPorCpf
     * @uses ArrayOfDadosAfastamentoPorCpf::setDadosAfastamentoPorCpf()
     * @param \StructType\DadosAfastamentoPorCpf[] $dadosAfastamentoPorCpf
     */
    public function __construct(array $dadosAfastamentoPorCpf = array())
    {
        $this
            ->setDadosAfastamentoPorCpf($dadosAfastamentoPorCpf);
    }
    /**
     * Get DadosAfastamentoPorCpf value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DadosAfastamentoPorCpf[]|null
     */
    public function getDadosAfastamentoPorCpf()
    {
        return isset($this->DadosAfastamentoPorCpf) ? $this->DadosAfastamentoPorCpf : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDadosAfastamentoPorCpf method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDadosAfastamentoPorCpf method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDadosAfastamentoPorCpfForArrayConstraintsFromSetDadosAfastamentoPorCpf(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDadosAfastamentoPorCpfDadosAfastamentoPorCpfItem) {
            // validation for constraint: itemType
            if (!$arrayOfDadosAfastamentoPorCpfDadosAfastamentoPorCpfItem instanceof \StructType\DadosAfastamentoPorCpf) {
                $invalidValues[] = is_object($arrayOfDadosAfastamentoPorCpfDadosAfastamentoPorCpfItem) ? get_class($arrayOfDadosAfastamentoPorCpfDadosAfastamentoPorCpfItem) : sprintf('%s(%s)', gettype($arrayOfDadosAfastamentoPorCpfDadosAfastamentoPorCpfItem), var_export($arrayOfDadosAfastamentoPorCpfDadosAfastamentoPorCpfItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DadosAfastamentoPorCpf property can only contain items of type \StructType\DadosAfastamentoPorCpf, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DadosAfastamentoPorCpf value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DadosAfastamentoPorCpf[] $dadosAfastamentoPorCpf
     * @return \ArrayType\ArrayOfDadosAfastamentoPorCpf
     */
    public function setDadosAfastamentoPorCpf(array $dadosAfastamentoPorCpf = array())
    {
        // validation for constraint: array
        if ('' !== ($dadosAfastamentoPorCpfArrayErrorMessage = self::validateDadosAfastamentoPorCpfForArrayConstraintsFromSetDadosAfastamentoPorCpf($dadosAfastamentoPorCpf))) {
            throw new \InvalidArgumentException($dadosAfastamentoPorCpfArrayErrorMessage, __LINE__);
        }
        if (is_null($dadosAfastamentoPorCpf) || (is_array($dadosAfastamentoPorCpf) && empty($dadosAfastamentoPorCpf))) {
            unset($this->DadosAfastamentoPorCpf);
        } else {
            $this->DadosAfastamentoPorCpf = $dadosAfastamentoPorCpf;
        }
        return $this;
    }
    /**
     * Add item to DadosAfastamentoPorCpf value
     * @throws \InvalidArgumentException
     * @param \StructType\DadosAfastamentoPorCpf $item
     * @return \ArrayType\ArrayOfDadosAfastamentoPorCpf
     */
    public function addToDadosAfastamentoPorCpf(\StructType\DadosAfastamentoPorCpf $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DadosAfastamentoPorCpf) {
            throw new \InvalidArgumentException(sprintf('The DadosAfastamentoPorCpf property can only contain items of type \StructType\DadosAfastamentoPorCpf, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DadosAfastamentoPorCpf[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DadosAfastamentoPorCpf|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DadosAfastamentoPorCpf|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DadosAfastamentoPorCpf|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DadosAfastamentoPorCpf|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DadosAfastamentoPorCpf|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DadosAfastamentoPorCpf
     */
    public function getAttributeName()
    {
        return 'DadosAfastamentoPorCpf';
    }
}
