<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDadosAfastamentoPorMatricula ArrayType
 * @subpackage Arrays
 */
class ArrayOfDadosAfastamentoPorMatricula extends AbstractStructArrayBase
{
    /**
     * The DadosAfastamentoPorMatricula
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DadosAfastamentoPorMatricula[]
     */
    public $DadosAfastamentoPorMatricula;
    /**
     * Constructor method for ArrayOfDadosAfastamentoPorMatricula
     * @uses ArrayOfDadosAfastamentoPorMatricula::setDadosAfastamentoPorMatricula()
     * @param \StructType\DadosAfastamentoPorMatricula[] $dadosAfastamentoPorMatricula
     */
    public function __construct(array $dadosAfastamentoPorMatricula = array())
    {
        $this
            ->setDadosAfastamentoPorMatricula($dadosAfastamentoPorMatricula);
    }
    /**
     * Get DadosAfastamentoPorMatricula value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DadosAfastamentoPorMatricula[]|null
     */
    public function getDadosAfastamentoPorMatricula()
    {
        return isset($this->DadosAfastamentoPorMatricula) ? $this->DadosAfastamentoPorMatricula : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDadosAfastamentoPorMatricula method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDadosAfastamentoPorMatricula method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDadosAfastamentoPorMatriculaForArrayConstraintsFromSetDadosAfastamentoPorMatricula(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDadosAfastamentoPorMatriculaDadosAfastamentoPorMatriculaItem) {
            // validation for constraint: itemType
            if (!$arrayOfDadosAfastamentoPorMatriculaDadosAfastamentoPorMatriculaItem instanceof \StructType\DadosAfastamentoPorMatricula) {
                $invalidValues[] = is_object($arrayOfDadosAfastamentoPorMatriculaDadosAfastamentoPorMatriculaItem) ? get_class($arrayOfDadosAfastamentoPorMatriculaDadosAfastamentoPorMatriculaItem) : sprintf('%s(%s)', gettype($arrayOfDadosAfastamentoPorMatriculaDadosAfastamentoPorMatriculaItem), var_export($arrayOfDadosAfastamentoPorMatriculaDadosAfastamentoPorMatriculaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DadosAfastamentoPorMatricula property can only contain items of type \StructType\DadosAfastamentoPorMatricula, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DadosAfastamentoPorMatricula value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DadosAfastamentoPorMatricula[] $dadosAfastamentoPorMatricula
     * @return \ArrayType\ArrayOfDadosAfastamentoPorMatricula
     */
    public function setDadosAfastamentoPorMatricula(array $dadosAfastamentoPorMatricula = array())
    {
        // validation for constraint: array
        if ('' !== ($dadosAfastamentoPorMatriculaArrayErrorMessage = self::validateDadosAfastamentoPorMatriculaForArrayConstraintsFromSetDadosAfastamentoPorMatricula($dadosAfastamentoPorMatricula))) {
            throw new \InvalidArgumentException($dadosAfastamentoPorMatriculaArrayErrorMessage, __LINE__);
        }
        if (is_null($dadosAfastamentoPorMatricula) || (is_array($dadosAfastamentoPorMatricula) && empty($dadosAfastamentoPorMatricula))) {
            unset($this->DadosAfastamentoPorMatricula);
        } else {
            $this->DadosAfastamentoPorMatricula = $dadosAfastamentoPorMatricula;
        }
        return $this;
    }
    /**
     * Add item to DadosAfastamentoPorMatricula value
     * @throws \InvalidArgumentException
     * @param \StructType\DadosAfastamentoPorMatricula $item
     * @return \ArrayType\ArrayOfDadosAfastamentoPorMatricula
     */
    public function addToDadosAfastamentoPorMatricula(\StructType\DadosAfastamentoPorMatricula $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DadosAfastamentoPorMatricula) {
            throw new \InvalidArgumentException(sprintf('The DadosAfastamentoPorMatricula property can only contain items of type \StructType\DadosAfastamentoPorMatricula, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DadosAfastamentoPorMatricula[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DadosAfastamentoPorMatricula|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DadosAfastamentoPorMatricula|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DadosAfastamentoPorMatricula|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DadosAfastamentoPorMatricula|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DadosAfastamentoPorMatricula|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DadosAfastamentoPorMatricula
     */
    public function getAttributeName()
    {
        return 'DadosAfastamentoPorMatricula';
    }
}
