<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDadosBancarios ArrayType
 * @subpackage Arrays
 */
class ArrayOfDadosBancarios extends AbstractStructArrayBase
{
    /**
     * The DadosBancarios
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DadosBancarios[]
     */
    public $DadosBancarios;
    /**
     * Constructor method for ArrayOfDadosBancarios
     * @uses ArrayOfDadosBancarios::setDadosBancarios()
     * @param \StructType\DadosBancarios[] $dadosBancarios
     */
    public function __construct(array $dadosBancarios = array())
    {
        $this
            ->setDadosBancarios($dadosBancarios);
    }
    /**
     * Get DadosBancarios value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DadosBancarios[]|null
     */
    public function getDadosBancarios()
    {
        return isset($this->DadosBancarios) ? $this->DadosBancarios : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDadosBancarios method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDadosBancarios method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDadosBancariosForArrayConstraintsFromSetDadosBancarios(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDadosBancariosDadosBancariosItem) {
            // validation for constraint: itemType
            if (!$arrayOfDadosBancariosDadosBancariosItem instanceof \StructType\DadosBancarios) {
                $invalidValues[] = is_object($arrayOfDadosBancariosDadosBancariosItem) ? get_class($arrayOfDadosBancariosDadosBancariosItem) : sprintf('%s(%s)', gettype($arrayOfDadosBancariosDadosBancariosItem), var_export($arrayOfDadosBancariosDadosBancariosItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DadosBancarios property can only contain items of type \StructType\DadosBancarios, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DadosBancarios value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DadosBancarios[] $dadosBancarios
     * @return \ArrayType\ArrayOfDadosBancarios
     */
    public function setDadosBancarios(array $dadosBancarios = array())
    {
        // validation for constraint: array
        if ('' !== ($dadosBancariosArrayErrorMessage = self::validateDadosBancariosForArrayConstraintsFromSetDadosBancarios($dadosBancarios))) {
            throw new \InvalidArgumentException($dadosBancariosArrayErrorMessage, __LINE__);
        }
        if (is_null($dadosBancarios) || (is_array($dadosBancarios) && empty($dadosBancarios))) {
            unset($this->DadosBancarios);
        } else {
            $this->DadosBancarios = $dadosBancarios;
        }
        return $this;
    }
    /**
     * Add item to DadosBancarios value
     * @throws \InvalidArgumentException
     * @param \StructType\DadosBancarios $item
     * @return \ArrayType\ArrayOfDadosBancarios
     */
    public function addToDadosBancarios(\StructType\DadosBancarios $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DadosBancarios) {
            throw new \InvalidArgumentException(sprintf('The DadosBancarios property can only contain items of type \StructType\DadosBancarios, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DadosBancarios[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DadosBancarios|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DadosBancarios|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DadosBancarios|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DadosBancarios|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DadosBancarios|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DadosBancarios
     */
    public function getAttributeName()
    {
        return 'DadosBancarios';
    }
}
