<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDadosCurso ArrayType
 * @subpackage Arrays
 */
class ArrayOfDadosCurso extends AbstractStructArrayBase
{
    /**
     * The DadosCurso
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DadosCurso[]
     */
    public $DadosCurso;
    /**
     * Constructor method for ArrayOfDadosCurso
     * @uses ArrayOfDadosCurso::setDadosCurso()
     * @param \StructType\DadosCurso[] $dadosCurso
     */
    public function __construct(array $dadosCurso = array())
    {
        $this
            ->setDadosCurso($dadosCurso);
    }
    /**
     * Get DadosCurso value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DadosCurso[]|null
     */
    public function getDadosCurso()
    {
        return isset($this->DadosCurso) ? $this->DadosCurso : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDadosCurso method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDadosCurso method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDadosCursoForArrayConstraintsFromSetDadosCurso(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDadosCursoDadosCursoItem) {
            // validation for constraint: itemType
            if (!$arrayOfDadosCursoDadosCursoItem instanceof \StructType\DadosCurso) {
                $invalidValues[] = is_object($arrayOfDadosCursoDadosCursoItem) ? get_class($arrayOfDadosCursoDadosCursoItem) : sprintf('%s(%s)', gettype($arrayOfDadosCursoDadosCursoItem), var_export($arrayOfDadosCursoDadosCursoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DadosCurso property can only contain items of type \StructType\DadosCurso, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DadosCurso value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DadosCurso[] $dadosCurso
     * @return \ArrayType\ArrayOfDadosCurso
     */
    public function setDadosCurso(array $dadosCurso = array())
    {
        // validation for constraint: array
        if ('' !== ($dadosCursoArrayErrorMessage = self::validateDadosCursoForArrayConstraintsFromSetDadosCurso($dadosCurso))) {
            throw new \InvalidArgumentException($dadosCursoArrayErrorMessage, __LINE__);
        }
        if (is_null($dadosCurso) || (is_array($dadosCurso) && empty($dadosCurso))) {
            unset($this->DadosCurso);
        } else {
            $this->DadosCurso = $dadosCurso;
        }
        return $this;
    }
    /**
     * Add item to DadosCurso value
     * @throws \InvalidArgumentException
     * @param \StructType\DadosCurso $item
     * @return \ArrayType\ArrayOfDadosCurso
     */
    public function addToDadosCurso(\StructType\DadosCurso $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DadosCurso) {
            throw new \InvalidArgumentException(sprintf('The DadosCurso property can only contain items of type \StructType\DadosCurso, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DadosCurso[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DadosCurso|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DadosCurso|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DadosCurso|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DadosCurso|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DadosCurso|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DadosCurso
     */
    public function getAttributeName()
    {
        return 'DadosCurso';
    }
}
