<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDadosDDP ArrayType
 * @subpackage Arrays
 */
class ArrayOfDadosDDP extends AbstractStructArrayBase
{
    /**
     * The DadosDDP
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DadosDDP[]
     */
    public $DadosDDP;
    /**
     * Constructor method for ArrayOfDadosDDP
     * @uses ArrayOfDadosDDP::setDadosDDP()
     * @param \StructType\DadosDDP[] $dadosDDP
     */
    public function __construct(array $dadosDDP = array())
    {
        $this
            ->setDadosDDP($dadosDDP);
    }
    /**
     * Get DadosDDP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DadosDDP[]|null
     */
    public function getDadosDDP()
    {
        return isset($this->DadosDDP) ? $this->DadosDDP : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDadosDDP method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDadosDDP method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDadosDDPForArrayConstraintsFromSetDadosDDP(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDadosDDPDadosDDPItem) {
            // validation for constraint: itemType
            if (!$arrayOfDadosDDPDadosDDPItem instanceof \StructType\DadosDDP) {
                $invalidValues[] = is_object($arrayOfDadosDDPDadosDDPItem) ? get_class($arrayOfDadosDDPDadosDDPItem) : sprintf('%s(%s)', gettype($arrayOfDadosDDPDadosDDPItem), var_export($arrayOfDadosDDPDadosDDPItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DadosDDP property can only contain items of type \StructType\DadosDDP, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DadosDDP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DadosDDP[] $dadosDDP
     * @return \ArrayType\ArrayOfDadosDDP
     */
    public function setDadosDDP(array $dadosDDP = array())
    {
        // validation for constraint: array
        if ('' !== ($dadosDDPArrayErrorMessage = self::validateDadosDDPForArrayConstraintsFromSetDadosDDP($dadosDDP))) {
            throw new \InvalidArgumentException($dadosDDPArrayErrorMessage, __LINE__);
        }
        if (is_null($dadosDDP) || (is_array($dadosDDP) && empty($dadosDDP))) {
            unset($this->DadosDDP);
        } else {
            $this->DadosDDP = $dadosDDP;
        }
        return $this;
    }
    /**
     * Add item to DadosDDP value
     * @throws \InvalidArgumentException
     * @param \StructType\DadosDDP $item
     * @return \ArrayType\ArrayOfDadosDDP
     */
    public function addToDadosDDP(\StructType\DadosDDP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DadosDDP) {
            throw new \InvalidArgumentException(sprintf('The DadosDDP property can only contain items of type \StructType\DadosDDP, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DadosDDP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DadosDDP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DadosDDP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DadosDDP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DadosDDP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DadosDDP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DadosDDP
     */
    public function getAttributeName()
    {
        return 'DadosDDP';
    }
}
