<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDadosDependentes ArrayType
 * @subpackage Arrays
 */
class ArrayOfDadosDependentes extends AbstractStructArrayBase
{
    /**
     * The DadosDependentes
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DadosDependentes[]
     */
    public $DadosDependentes;
    /**
     * Constructor method for ArrayOfDadosDependentes
     * @uses ArrayOfDadosDependentes::setDadosDependentes()
     * @param \StructType\DadosDependentes[] $dadosDependentes
     */
    public function __construct(array $dadosDependentes = array())
    {
        $this
            ->setDadosDependentes($dadosDependentes);
    }
    /**
     * Get DadosDependentes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DadosDependentes[]|null
     */
    public function getDadosDependentes()
    {
        return isset($this->DadosDependentes) ? $this->DadosDependentes : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDadosDependentes method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDadosDependentes method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDadosDependentesForArrayConstraintsFromSetDadosDependentes(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDadosDependentesDadosDependentesItem) {
            // validation for constraint: itemType
            if (!$arrayOfDadosDependentesDadosDependentesItem instanceof \StructType\DadosDependentes) {
                $invalidValues[] = is_object($arrayOfDadosDependentesDadosDependentesItem) ? get_class($arrayOfDadosDependentesDadosDependentesItem) : sprintf('%s(%s)', gettype($arrayOfDadosDependentesDadosDependentesItem), var_export($arrayOfDadosDependentesDadosDependentesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DadosDependentes property can only contain items of type \StructType\DadosDependentes, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DadosDependentes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DadosDependentes[] $dadosDependentes
     * @return \ArrayType\ArrayOfDadosDependentes
     */
    public function setDadosDependentes(array $dadosDependentes = array())
    {
        // validation for constraint: array
        if ('' !== ($dadosDependentesArrayErrorMessage = self::validateDadosDependentesForArrayConstraintsFromSetDadosDependentes($dadosDependentes))) {
            throw new \InvalidArgumentException($dadosDependentesArrayErrorMessage, __LINE__);
        }
        if (is_null($dadosDependentes) || (is_array($dadosDependentes) && empty($dadosDependentes))) {
            unset($this->DadosDependentes);
        } else {
            $this->DadosDependentes = $dadosDependentes;
        }
        return $this;
    }
    /**
     * Add item to DadosDependentes value
     * @throws \InvalidArgumentException
     * @param \StructType\DadosDependentes $item
     * @return \ArrayType\ArrayOfDadosDependentes
     */
    public function addToDadosDependentes(\StructType\DadosDependentes $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DadosDependentes) {
            throw new \InvalidArgumentException(sprintf('The DadosDependentes property can only contain items of type \StructType\DadosDependentes, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DadosDependentes[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DadosDependentes|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DadosDependentes|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DadosDependentes|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DadosDependentes|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DadosDependentes|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DadosDependentes
     */
    public function getAttributeName()
    {
        return 'DadosDependentes';
    }
}
