<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDadosFerias ArrayType
 * @subpackage Arrays
 */
class ArrayOfDadosFerias extends AbstractStructArrayBase
{
    /**
     * The DadosFerias
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DadosFerias[]
     */
    public $DadosFerias;
    /**
     * Constructor method for ArrayOfDadosFerias
     * @uses ArrayOfDadosFerias::setDadosFerias()
     * @param \StructType\DadosFerias[] $dadosFerias
     */
    public function __construct(array $dadosFerias = array())
    {
        $this
            ->setDadosFerias($dadosFerias);
    }
    /**
     * Get DadosFerias value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DadosFerias[]|null
     */
    public function getDadosFerias()
    {
        return isset($this->DadosFerias) ? $this->DadosFerias : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDadosFerias method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDadosFerias method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDadosFeriasForArrayConstraintsFromSetDadosFerias(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDadosFeriasDadosFeriasItem) {
            // validation for constraint: itemType
            if (!$arrayOfDadosFeriasDadosFeriasItem instanceof \StructType\DadosFerias) {
                $invalidValues[] = is_object($arrayOfDadosFeriasDadosFeriasItem) ? get_class($arrayOfDadosFeriasDadosFeriasItem) : sprintf('%s(%s)', gettype($arrayOfDadosFeriasDadosFeriasItem), var_export($arrayOfDadosFeriasDadosFeriasItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DadosFerias property can only contain items of type \StructType\DadosFerias, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DadosFerias value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DadosFerias[] $dadosFerias
     * @return \ArrayType\ArrayOfDadosFerias
     */
    public function setDadosFerias(array $dadosFerias = array())
    {
        // validation for constraint: array
        if ('' !== ($dadosFeriasArrayErrorMessage = self::validateDadosFeriasForArrayConstraintsFromSetDadosFerias($dadosFerias))) {
            throw new \InvalidArgumentException($dadosFeriasArrayErrorMessage, __LINE__);
        }
        if (is_null($dadosFerias) || (is_array($dadosFerias) && empty($dadosFerias))) {
            unset($this->DadosFerias);
        } else {
            $this->DadosFerias = $dadosFerias;
        }
        return $this;
    }
    /**
     * Add item to DadosFerias value
     * @throws \InvalidArgumentException
     * @param \StructType\DadosFerias $item
     * @return \ArrayType\ArrayOfDadosFerias
     */
    public function addToDadosFerias(\StructType\DadosFerias $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DadosFerias) {
            throw new \InvalidArgumentException(sprintf('The DadosFerias property can only contain items of type \StructType\DadosFerias, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DadosFerias[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DadosFerias|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DadosFerias|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DadosFerias|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DadosFerias|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DadosFerias|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DadosFerias
     */
    public function getAttributeName()
    {
        return 'DadosFerias';
    }
}
