<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDadosFinanceiros ArrayType
 * @subpackage Arrays
 */
class ArrayOfDadosFinanceiros extends AbstractStructArrayBase
{
    /**
     * The DadosFinanceiros
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DadosFinanceiros[]
     */
    public $DadosFinanceiros;
    /**
     * Constructor method for ArrayOfDadosFinanceiros
     * @uses ArrayOfDadosFinanceiros::setDadosFinanceiros()
     * @param \StructType\DadosFinanceiros[] $dadosFinanceiros
     */
    public function __construct(array $dadosFinanceiros = array())
    {
        $this
            ->setDadosFinanceiros($dadosFinanceiros);
    }
    /**
     * Get DadosFinanceiros value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DadosFinanceiros[]|null
     */
    public function getDadosFinanceiros()
    {
        return isset($this->DadosFinanceiros) ? $this->DadosFinanceiros : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDadosFinanceiros method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDadosFinanceiros method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDadosFinanceirosForArrayConstraintsFromSetDadosFinanceiros(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDadosFinanceirosDadosFinanceirosItem) {
            // validation for constraint: itemType
            if (!$arrayOfDadosFinanceirosDadosFinanceirosItem instanceof \StructType\DadosFinanceiros) {
                $invalidValues[] = is_object($arrayOfDadosFinanceirosDadosFinanceirosItem) ? get_class($arrayOfDadosFinanceirosDadosFinanceirosItem) : sprintf('%s(%s)', gettype($arrayOfDadosFinanceirosDadosFinanceirosItem), var_export($arrayOfDadosFinanceirosDadosFinanceirosItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DadosFinanceiros property can only contain items of type \StructType\DadosFinanceiros, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DadosFinanceiros value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DadosFinanceiros[] $dadosFinanceiros
     * @return \ArrayType\ArrayOfDadosFinanceiros
     */
    public function setDadosFinanceiros(array $dadosFinanceiros = array())
    {
        // validation for constraint: array
        if ('' !== ($dadosFinanceirosArrayErrorMessage = self::validateDadosFinanceirosForArrayConstraintsFromSetDadosFinanceiros($dadosFinanceiros))) {
            throw new \InvalidArgumentException($dadosFinanceirosArrayErrorMessage, __LINE__);
        }
        if (is_null($dadosFinanceiros) || (is_array($dadosFinanceiros) && empty($dadosFinanceiros))) {
            unset($this->DadosFinanceiros);
        } else {
            $this->DadosFinanceiros = $dadosFinanceiros;
        }
        return $this;
    }
    /**
     * Add item to DadosFinanceiros value
     * @throws \InvalidArgumentException
     * @param \StructType\DadosFinanceiros $item
     * @return \ArrayType\ArrayOfDadosFinanceiros
     */
    public function addToDadosFinanceiros(\StructType\DadosFinanceiros $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DadosFinanceiros) {
            throw new \InvalidArgumentException(sprintf('The DadosFinanceiros property can only contain items of type \StructType\DadosFinanceiros, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DadosFinanceiros[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DadosFinanceiros|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DadosFinanceiros|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DadosFinanceiros|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DadosFinanceiros|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DadosFinanceiros|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DadosFinanceiros
     */
    public function getAttributeName()
    {
        return 'DadosFinanceiros';
    }
}
