<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDadosFuncionais ArrayType
 * @subpackage Arrays
 */
class ArrayOfDadosFuncionais extends AbstractStructArrayBase
{
    /**
     * The DadosFuncionais
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DadosFuncionais[]
     */
    public $DadosFuncionais;
    /**
     * Constructor method for ArrayOfDadosFuncionais
     * @uses ArrayOfDadosFuncionais::setDadosFuncionais()
     * @param \StructType\DadosFuncionais[] $dadosFuncionais
     */
    public function __construct(array $dadosFuncionais = array())
    {
        $this
            ->setDadosFuncionais($dadosFuncionais);
    }
    /**
     * Get DadosFuncionais value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DadosFuncionais[]|null
     */
    public function getDadosFuncionais()
    {
        return isset($this->DadosFuncionais) ? $this->DadosFuncionais : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDadosFuncionais method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDadosFuncionais method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDadosFuncionaisForArrayConstraintsFromSetDadosFuncionais(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDadosFuncionaisDadosFuncionaisItem) {
            // validation for constraint: itemType
            if (!$arrayOfDadosFuncionaisDadosFuncionaisItem instanceof \StructType\DadosFuncionais) {
                $invalidValues[] = is_object($arrayOfDadosFuncionaisDadosFuncionaisItem) ? get_class($arrayOfDadosFuncionaisDadosFuncionaisItem) : sprintf('%s(%s)', gettype($arrayOfDadosFuncionaisDadosFuncionaisItem), var_export($arrayOfDadosFuncionaisDadosFuncionaisItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DadosFuncionais property can only contain items of type \StructType\DadosFuncionais, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DadosFuncionais value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DadosFuncionais[] $dadosFuncionais
     * @return \ArrayType\ArrayOfDadosFuncionais
     */
    public function setDadosFuncionais(array $dadosFuncionais = array())
    {
        // validation for constraint: array
        if ('' !== ($dadosFuncionaisArrayErrorMessage = self::validateDadosFuncionaisForArrayConstraintsFromSetDadosFuncionais($dadosFuncionais))) {
            throw new \InvalidArgumentException($dadosFuncionaisArrayErrorMessage, __LINE__);
        }
        if (is_null($dadosFuncionais) || (is_array($dadosFuncionais) && empty($dadosFuncionais))) {
            unset($this->DadosFuncionais);
        } else {
            $this->DadosFuncionais = $dadosFuncionais;
        }
        return $this;
    }
    /**
     * Add item to DadosFuncionais value
     * @throws \InvalidArgumentException
     * @param \StructType\DadosFuncionais $item
     * @return \ArrayType\ArrayOfDadosFuncionais
     */
    public function addToDadosFuncionais(\StructType\DadosFuncionais $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DadosFuncionais) {
            throw new \InvalidArgumentException(sprintf('The DadosFuncionais property can only contain items of type \StructType\DadosFuncionais, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DadosFuncionais[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DadosFuncionais|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DadosFuncionais|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DadosFuncionais|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DadosFuncionais|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DadosFuncionais|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DadosFuncionais
     */
    public function getAttributeName()
    {
        return 'DadosFuncionais';
    }
}
