<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDadosLpa ArrayType
 * @subpackage Arrays
 */
class ArrayOfDadosLpa extends AbstractStructArrayBase
{
    /**
     * The DadosLpa
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DadosLpa[]
     */
    public $DadosLpa;
    /**
     * Constructor method for ArrayOfDadosLpa
     * @uses ArrayOfDadosLpa::setDadosLpa()
     * @param \StructType\DadosLpa[] $dadosLpa
     */
    public function __construct(array $dadosLpa = array())
    {
        $this
            ->setDadosLpa($dadosLpa);
    }
    /**
     * Get DadosLpa value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DadosLpa[]|null
     */
    public function getDadosLpa()
    {
        return isset($this->DadosLpa) ? $this->DadosLpa : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDadosLpa method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDadosLpa method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDadosLpaForArrayConstraintsFromSetDadosLpa(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDadosLpaDadosLpaItem) {
            // validation for constraint: itemType
            if (!$arrayOfDadosLpaDadosLpaItem instanceof \StructType\DadosLpa) {
                $invalidValues[] = is_object($arrayOfDadosLpaDadosLpaItem) ? get_class($arrayOfDadosLpaDadosLpaItem) : sprintf('%s(%s)', gettype($arrayOfDadosLpaDadosLpaItem), var_export($arrayOfDadosLpaDadosLpaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DadosLpa property can only contain items of type \StructType\DadosLpa, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DadosLpa value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DadosLpa[] $dadosLpa
     * @return \ArrayType\ArrayOfDadosLpa
     */
    public function setDadosLpa(array $dadosLpa = array())
    {
        // validation for constraint: array
        if ('' !== ($dadosLpaArrayErrorMessage = self::validateDadosLpaForArrayConstraintsFromSetDadosLpa($dadosLpa))) {
            throw new \InvalidArgumentException($dadosLpaArrayErrorMessage, __LINE__);
        }
        if (is_null($dadosLpa) || (is_array($dadosLpa) && empty($dadosLpa))) {
            unset($this->DadosLpa);
        } else {
            $this->DadosLpa = $dadosLpa;
        }
        return $this;
    }
    /**
     * Add item to DadosLpa value
     * @throws \InvalidArgumentException
     * @param \StructType\DadosLpa $item
     * @return \ArrayType\ArrayOfDadosLpa
     */
    public function addToDadosLpa(\StructType\DadosLpa $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DadosLpa) {
            throw new \InvalidArgumentException(sprintf('The DadosLpa property can only contain items of type \StructType\DadosLpa, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DadosLpa[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DadosLpa|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DadosLpa|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DadosLpa|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DadosLpa|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DadosLpa|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DadosLpa
     */
    public function getAttributeName()
    {
        return 'DadosLpa';
    }
}
