<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDadosOcorrencias ArrayType
 * @subpackage Arrays
 */
class ArrayOfDadosOcorrencias extends AbstractStructArrayBase
{
    /**
     * The DadosOcorrencias
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DadosOcorrencias[]
     */
    public $DadosOcorrencias;
    /**
     * Constructor method for ArrayOfDadosOcorrencias
     * @uses ArrayOfDadosOcorrencias::setDadosOcorrencias()
     * @param \StructType\DadosOcorrencias[] $dadosOcorrencias
     */
    public function __construct(array $dadosOcorrencias = array())
    {
        $this
            ->setDadosOcorrencias($dadosOcorrencias);
    }
    /**
     * Get DadosOcorrencias value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DadosOcorrencias[]|null
     */
    public function getDadosOcorrencias()
    {
        return isset($this->DadosOcorrencias) ? $this->DadosOcorrencias : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDadosOcorrencias method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDadosOcorrencias method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDadosOcorrenciasForArrayConstraintsFromSetDadosOcorrencias(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDadosOcorrenciasDadosOcorrenciasItem) {
            // validation for constraint: itemType
            if (!$arrayOfDadosOcorrenciasDadosOcorrenciasItem instanceof \StructType\DadosOcorrencias) {
                $invalidValues[] = is_object($arrayOfDadosOcorrenciasDadosOcorrenciasItem) ? get_class($arrayOfDadosOcorrenciasDadosOcorrenciasItem) : sprintf('%s(%s)', gettype($arrayOfDadosOcorrenciasDadosOcorrenciasItem), var_export($arrayOfDadosOcorrenciasDadosOcorrenciasItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DadosOcorrencias property can only contain items of type \StructType\DadosOcorrencias, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DadosOcorrencias value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DadosOcorrencias[] $dadosOcorrencias
     * @return \ArrayType\ArrayOfDadosOcorrencias
     */
    public function setDadosOcorrencias(array $dadosOcorrencias = array())
    {
        // validation for constraint: array
        if ('' !== ($dadosOcorrenciasArrayErrorMessage = self::validateDadosOcorrenciasForArrayConstraintsFromSetDadosOcorrencias($dadosOcorrencias))) {
            throw new \InvalidArgumentException($dadosOcorrenciasArrayErrorMessage, __LINE__);
        }
        if (is_null($dadosOcorrencias) || (is_array($dadosOcorrencias) && empty($dadosOcorrencias))) {
            unset($this->DadosOcorrencias);
        } else {
            $this->DadosOcorrencias = $dadosOcorrencias;
        }
        return $this;
    }
    /**
     * Add item to DadosOcorrencias value
     * @throws \InvalidArgumentException
     * @param \StructType\DadosOcorrencias $item
     * @return \ArrayType\ArrayOfDadosOcorrencias
     */
    public function addToDadosOcorrencias(\StructType\DadosOcorrencias $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DadosOcorrencias) {
            throw new \InvalidArgumentException(sprintf('The DadosOcorrencias property can only contain items of type \StructType\DadosOcorrencias, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DadosOcorrencias[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DadosOcorrencias|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DadosOcorrencias|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DadosOcorrencias|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DadosOcorrencias|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DadosOcorrencias|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DadosOcorrencias
     */
    public function getAttributeName()
    {
        return 'DadosOcorrencias';
    }
}
