<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDadosPA ArrayType
 * @subpackage Arrays
 */
class ArrayOfDadosPA extends AbstractStructArrayBase
{
    /**
     * The DadosPA
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DadosPA[]
     */
    public $DadosPA;
    /**
     * Constructor method for ArrayOfDadosPA
     * @uses ArrayOfDadosPA::setDadosPA()
     * @param \StructType\DadosPA[] $dadosPA
     */
    public function __construct(array $dadosPA = array())
    {
        $this
            ->setDadosPA($dadosPA);
    }
    /**
     * Get DadosPA value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DadosPA[]|null
     */
    public function getDadosPA()
    {
        return isset($this->DadosPA) ? $this->DadosPA : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDadosPA method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDadosPA method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDadosPAForArrayConstraintsFromSetDadosPA(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDadosPADadosPAItem) {
            // validation for constraint: itemType
            if (!$arrayOfDadosPADadosPAItem instanceof \StructType\DadosPA) {
                $invalidValues[] = is_object($arrayOfDadosPADadosPAItem) ? get_class($arrayOfDadosPADadosPAItem) : sprintf('%s(%s)', gettype($arrayOfDadosPADadosPAItem), var_export($arrayOfDadosPADadosPAItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DadosPA property can only contain items of type \StructType\DadosPA, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DadosPA value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DadosPA[] $dadosPA
     * @return \ArrayType\ArrayOfDadosPA
     */
    public function setDadosPA(array $dadosPA = array())
    {
        // validation for constraint: array
        if ('' !== ($dadosPAArrayErrorMessage = self::validateDadosPAForArrayConstraintsFromSetDadosPA($dadosPA))) {
            throw new \InvalidArgumentException($dadosPAArrayErrorMessage, __LINE__);
        }
        if (is_null($dadosPA) || (is_array($dadosPA) && empty($dadosPA))) {
            unset($this->DadosPA);
        } else {
            $this->DadosPA = $dadosPA;
        }
        return $this;
    }
    /**
     * Add item to DadosPA value
     * @throws \InvalidArgumentException
     * @param \StructType\DadosPA $item
     * @return \ArrayType\ArrayOfDadosPA
     */
    public function addToDadosPA(\StructType\DadosPA $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DadosPA) {
            throw new \InvalidArgumentException(sprintf('The DadosPA property can only contain items of type \StructType\DadosPA, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DadosPA[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DadosPA|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DadosPA|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DadosPA|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DadosPA|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DadosPA|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DadosPA
     */
    public function getAttributeName()
    {
        return 'DadosPA';
    }
}
