<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDadosReclusao ArrayType
 * @subpackage Arrays
 */
class ArrayOfDadosReclusao extends AbstractStructArrayBase
{
    /**
     * The DadosReclusao
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DadosReclusao[]
     */
    public $DadosReclusao;
    /**
     * Constructor method for ArrayOfDadosReclusao
     * @uses ArrayOfDadosReclusao::setDadosReclusao()
     * @param \StructType\DadosReclusao[] $dadosReclusao
     */
    public function __construct(array $dadosReclusao = array())
    {
        $this
            ->setDadosReclusao($dadosReclusao);
    }
    /**
     * Get DadosReclusao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DadosReclusao[]|null
     */
    public function getDadosReclusao()
    {
        return isset($this->DadosReclusao) ? $this->DadosReclusao : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDadosReclusao method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDadosReclusao method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDadosReclusaoForArrayConstraintsFromSetDadosReclusao(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDadosReclusaoDadosReclusaoItem) {
            // validation for constraint: itemType
            if (!$arrayOfDadosReclusaoDadosReclusaoItem instanceof \StructType\DadosReclusao) {
                $invalidValues[] = is_object($arrayOfDadosReclusaoDadosReclusaoItem) ? get_class($arrayOfDadosReclusaoDadosReclusaoItem) : sprintf('%s(%s)', gettype($arrayOfDadosReclusaoDadosReclusaoItem), var_export($arrayOfDadosReclusaoDadosReclusaoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DadosReclusao property can only contain items of type \StructType\DadosReclusao, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DadosReclusao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DadosReclusao[] $dadosReclusao
     * @return \ArrayType\ArrayOfDadosReclusao
     */
    public function setDadosReclusao(array $dadosReclusao = array())
    {
        // validation for constraint: array
        if ('' !== ($dadosReclusaoArrayErrorMessage = self::validateDadosReclusaoForArrayConstraintsFromSetDadosReclusao($dadosReclusao))) {
            throw new \InvalidArgumentException($dadosReclusaoArrayErrorMessage, __LINE__);
        }
        if (is_null($dadosReclusao) || (is_array($dadosReclusao) && empty($dadosReclusao))) {
            unset($this->DadosReclusao);
        } else {
            $this->DadosReclusao = $dadosReclusao;
        }
        return $this;
    }
    /**
     * Add item to DadosReclusao value
     * @throws \InvalidArgumentException
     * @param \StructType\DadosReclusao $item
     * @return \ArrayType\ArrayOfDadosReclusao
     */
    public function addToDadosReclusao(\StructType\DadosReclusao $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DadosReclusao) {
            throw new \InvalidArgumentException(sprintf('The DadosReclusao property can only contain items of type \StructType\DadosReclusao, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DadosReclusao[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DadosReclusao|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DadosReclusao|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DadosReclusao|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DadosReclusao|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DadosReclusao|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DadosReclusao
     */
    public function getAttributeName()
    {
        return 'DadosReclusao';
    }
}
