<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDadosRepresentanteLegal ArrayType
 * @subpackage Arrays
 */
class ArrayOfDadosRepresentanteLegal extends AbstractStructArrayBase
{
    /**
     * The DadosRepresentanteLegal
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DadosRepresentanteLegal[]
     */
    public $DadosRepresentanteLegal;
    /**
     * Constructor method for ArrayOfDadosRepresentanteLegal
     * @uses ArrayOfDadosRepresentanteLegal::setDadosRepresentanteLegal()
     * @param \StructType\DadosRepresentanteLegal[] $dadosRepresentanteLegal
     */
    public function __construct(array $dadosRepresentanteLegal = array())
    {
        $this
            ->setDadosRepresentanteLegal($dadosRepresentanteLegal);
    }
    /**
     * Get DadosRepresentanteLegal value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DadosRepresentanteLegal[]|null
     */
    public function getDadosRepresentanteLegal()
    {
        return isset($this->DadosRepresentanteLegal) ? $this->DadosRepresentanteLegal : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDadosRepresentanteLegal method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDadosRepresentanteLegal method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDadosRepresentanteLegalForArrayConstraintsFromSetDadosRepresentanteLegal(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDadosRepresentanteLegalDadosRepresentanteLegalItem) {
            // validation for constraint: itemType
            if (!$arrayOfDadosRepresentanteLegalDadosRepresentanteLegalItem instanceof \StructType\DadosRepresentanteLegal) {
                $invalidValues[] = is_object($arrayOfDadosRepresentanteLegalDadosRepresentanteLegalItem) ? get_class($arrayOfDadosRepresentanteLegalDadosRepresentanteLegalItem) : sprintf('%s(%s)', gettype($arrayOfDadosRepresentanteLegalDadosRepresentanteLegalItem), var_export($arrayOfDadosRepresentanteLegalDadosRepresentanteLegalItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DadosRepresentanteLegal property can only contain items of type \StructType\DadosRepresentanteLegal, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DadosRepresentanteLegal value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DadosRepresentanteLegal[] $dadosRepresentanteLegal
     * @return \ArrayType\ArrayOfDadosRepresentanteLegal
     */
    public function setDadosRepresentanteLegal(array $dadosRepresentanteLegal = array())
    {
        // validation for constraint: array
        if ('' !== ($dadosRepresentanteLegalArrayErrorMessage = self::validateDadosRepresentanteLegalForArrayConstraintsFromSetDadosRepresentanteLegal($dadosRepresentanteLegal))) {
            throw new \InvalidArgumentException($dadosRepresentanteLegalArrayErrorMessage, __LINE__);
        }
        if (is_null($dadosRepresentanteLegal) || (is_array($dadosRepresentanteLegal) && empty($dadosRepresentanteLegal))) {
            unset($this->DadosRepresentanteLegal);
        } else {
            $this->DadosRepresentanteLegal = $dadosRepresentanteLegal;
        }
        return $this;
    }
    /**
     * Add item to DadosRepresentanteLegal value
     * @throws \InvalidArgumentException
     * @param \StructType\DadosRepresentanteLegal $item
     * @return \ArrayType\ArrayOfDadosRepresentanteLegal
     */
    public function addToDadosRepresentanteLegal(\StructType\DadosRepresentanteLegal $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DadosRepresentanteLegal) {
            throw new \InvalidArgumentException(sprintf('The DadosRepresentanteLegal property can only contain items of type \StructType\DadosRepresentanteLegal, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DadosRepresentanteLegal[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DadosRepresentanteLegal|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DadosRepresentanteLegal|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DadosRepresentanteLegal|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DadosRepresentanteLegal|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DadosRepresentanteLegal|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DadosRepresentanteLegal
     */
    public function getAttributeName()
    {
        return 'DadosRepresentanteLegal';
    }
}
