<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDadosSICAJ ArrayType
 * @subpackage Arrays
 */
class ArrayOfDadosSICAJ extends AbstractStructArrayBase
{
    /**
     * The DadosSICAJ
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DadosSICAJ[]
     */
    public $DadosSICAJ;
    /**
     * Constructor method for ArrayOfDadosSICAJ
     * @uses ArrayOfDadosSICAJ::setDadosSICAJ()
     * @param \StructType\DadosSICAJ[] $dadosSICAJ
     */
    public function __construct(array $dadosSICAJ = array())
    {
        $this
            ->setDadosSICAJ($dadosSICAJ);
    }
    /**
     * Get DadosSICAJ value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DadosSICAJ[]|null
     */
    public function getDadosSICAJ()
    {
        return isset($this->DadosSICAJ) ? $this->DadosSICAJ : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDadosSICAJ method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDadosSICAJ method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDadosSICAJForArrayConstraintsFromSetDadosSICAJ(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDadosSICAJDadosSICAJItem) {
            // validation for constraint: itemType
            if (!$arrayOfDadosSICAJDadosSICAJItem instanceof \StructType\DadosSICAJ) {
                $invalidValues[] = is_object($arrayOfDadosSICAJDadosSICAJItem) ? get_class($arrayOfDadosSICAJDadosSICAJItem) : sprintf('%s(%s)', gettype($arrayOfDadosSICAJDadosSICAJItem), var_export($arrayOfDadosSICAJDadosSICAJItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DadosSICAJ property can only contain items of type \StructType\DadosSICAJ, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DadosSICAJ value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DadosSICAJ[] $dadosSICAJ
     * @return \ArrayType\ArrayOfDadosSICAJ
     */
    public function setDadosSICAJ(array $dadosSICAJ = array())
    {
        // validation for constraint: array
        if ('' !== ($dadosSICAJArrayErrorMessage = self::validateDadosSICAJForArrayConstraintsFromSetDadosSICAJ($dadosSICAJ))) {
            throw new \InvalidArgumentException($dadosSICAJArrayErrorMessage, __LINE__);
        }
        if (is_null($dadosSICAJ) || (is_array($dadosSICAJ) && empty($dadosSICAJ))) {
            unset($this->DadosSICAJ);
        } else {
            $this->DadosSICAJ = $dadosSICAJ;
        }
        return $this;
    }
    /**
     * Add item to DadosSICAJ value
     * @throws \InvalidArgumentException
     * @param \StructType\DadosSICAJ $item
     * @return \ArrayType\ArrayOfDadosSICAJ
     */
    public function addToDadosSICAJ(\StructType\DadosSICAJ $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DadosSICAJ) {
            throw new \InvalidArgumentException(sprintf('The DadosSICAJ property can only contain items of type \StructType\DadosSICAJ, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DadosSICAJ[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DadosSICAJ|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DadosSICAJ|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DadosSICAJ|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DadosSICAJ|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DadosSICAJ|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DadosSICAJ
     */
    public function getAttributeName()
    {
        return 'DadosSICAJ';
    }
}
