<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDadosTitulacao ArrayType
 * @subpackage Arrays
 */
class ArrayOfDadosTitulacao extends AbstractStructArrayBase
{
    /**
     * The DadosTitulacao
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DadosTitulacao[]
     */
    public $DadosTitulacao;
    /**
     * Constructor method for ArrayOfDadosTitulacao
     * @uses ArrayOfDadosTitulacao::setDadosTitulacao()
     * @param \StructType\DadosTitulacao[] $dadosTitulacao
     */
    public function __construct(array $dadosTitulacao = array())
    {
        $this
            ->setDadosTitulacao($dadosTitulacao);
    }
    /**
     * Get DadosTitulacao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DadosTitulacao[]|null
     */
    public function getDadosTitulacao()
    {
        return isset($this->DadosTitulacao) ? $this->DadosTitulacao : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDadosTitulacao method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDadosTitulacao method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDadosTitulacaoForArrayConstraintsFromSetDadosTitulacao(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDadosTitulacaoDadosTitulacaoItem) {
            // validation for constraint: itemType
            if (!$arrayOfDadosTitulacaoDadosTitulacaoItem instanceof \StructType\DadosTitulacao) {
                $invalidValues[] = is_object($arrayOfDadosTitulacaoDadosTitulacaoItem) ? get_class($arrayOfDadosTitulacaoDadosTitulacaoItem) : sprintf('%s(%s)', gettype($arrayOfDadosTitulacaoDadosTitulacaoItem), var_export($arrayOfDadosTitulacaoDadosTitulacaoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DadosTitulacao property can only contain items of type \StructType\DadosTitulacao, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DadosTitulacao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DadosTitulacao[] $dadosTitulacao
     * @return \ArrayType\ArrayOfDadosTitulacao
     */
    public function setDadosTitulacao(array $dadosTitulacao = array())
    {
        // validation for constraint: array
        if ('' !== ($dadosTitulacaoArrayErrorMessage = self::validateDadosTitulacaoForArrayConstraintsFromSetDadosTitulacao($dadosTitulacao))) {
            throw new \InvalidArgumentException($dadosTitulacaoArrayErrorMessage, __LINE__);
        }
        if (is_null($dadosTitulacao) || (is_array($dadosTitulacao) && empty($dadosTitulacao))) {
            unset($this->DadosTitulacao);
        } else {
            $this->DadosTitulacao = $dadosTitulacao;
        }
        return $this;
    }
    /**
     * Add item to DadosTitulacao value
     * @throws \InvalidArgumentException
     * @param \StructType\DadosTitulacao $item
     * @return \ArrayType\ArrayOfDadosTitulacao
     */
    public function addToDadosTitulacao(\StructType\DadosTitulacao $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DadosTitulacao) {
            throw new \InvalidArgumentException(sprintf('The DadosTitulacao property can only contain items of type \StructType\DadosTitulacao, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DadosTitulacao[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DadosTitulacao|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DadosTitulacao|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DadosTitulacao|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DadosTitulacao|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DadosTitulacao|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DadosTitulacao
     */
    public function getAttributeName()
    {
        return 'DadosTitulacao';
    }
}
