<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDadosUorg ArrayType
 * @subpackage Arrays
 */
class ArrayOfDadosUorg extends AbstractStructArrayBase
{
    /**
     * The DadosUorg
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DadosUorg[]
     */
    public $DadosUorg;
    /**
     * Constructor method for ArrayOfDadosUorg
     * @uses ArrayOfDadosUorg::setDadosUorg()
     * @param \StructType\DadosUorg[] $dadosUorg
     */
    public function __construct(array $dadosUorg = array())
    {
        $this
            ->setDadosUorg($dadosUorg);
    }
    /**
     * Get DadosUorg value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DadosUorg[]|null
     */
    public function getDadosUorg()
    {
        return isset($this->DadosUorg) ? $this->DadosUorg : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDadosUorg method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDadosUorg method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDadosUorgForArrayConstraintsFromSetDadosUorg(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDadosUorgDadosUorgItem) {
            // validation for constraint: itemType
            if (!$arrayOfDadosUorgDadosUorgItem instanceof \StructType\DadosUorg) {
                $invalidValues[] = is_object($arrayOfDadosUorgDadosUorgItem) ? get_class($arrayOfDadosUorgDadosUorgItem) : sprintf('%s(%s)', gettype($arrayOfDadosUorgDadosUorgItem), var_export($arrayOfDadosUorgDadosUorgItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DadosUorg property can only contain items of type \StructType\DadosUorg, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DadosUorg value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DadosUorg[] $dadosUorg
     * @return \ArrayType\ArrayOfDadosUorg
     */
    public function setDadosUorg(array $dadosUorg = array())
    {
        // validation for constraint: array
        if ('' !== ($dadosUorgArrayErrorMessage = self::validateDadosUorgForArrayConstraintsFromSetDadosUorg($dadosUorg))) {
            throw new \InvalidArgumentException($dadosUorgArrayErrorMessage, __LINE__);
        }
        if (is_null($dadosUorg) || (is_array($dadosUorg) && empty($dadosUorg))) {
            unset($this->DadosUorg);
        } else {
            $this->DadosUorg = $dadosUorg;
        }
        return $this;
    }
    /**
     * Add item to DadosUorg value
     * @throws \InvalidArgumentException
     * @param \StructType\DadosUorg $item
     * @return \ArrayType\ArrayOfDadosUorg
     */
    public function addToDadosUorg(\StructType\DadosUorg $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DadosUorg) {
            throw new \InvalidArgumentException(sprintf('The DadosUorg property can only contain items of type \StructType\DadosUorg, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DadosUorg[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DadosUorg|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DadosUorg|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DadosUorg|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DadosUorg|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DadosUorg|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DadosUorg
     */
    public function getAttributeName()
    {
        return 'DadosUorg';
    }
}
