<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDadosVinculo ArrayType
 * @subpackage Arrays
 */
class ArrayOfDadosVinculo extends AbstractStructArrayBase
{
    /**
     * The DadosVinculo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DadosVinculo[]
     */
    public $DadosVinculo;
    /**
     * Constructor method for ArrayOfDadosVinculo
     * @uses ArrayOfDadosVinculo::setDadosVinculo()
     * @param \StructType\DadosVinculo[] $dadosVinculo
     */
    public function __construct(array $dadosVinculo = array())
    {
        $this
            ->setDadosVinculo($dadosVinculo);
    }
    /**
     * Get DadosVinculo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DadosVinculo[]|null
     */
    public function getDadosVinculo()
    {
        return isset($this->DadosVinculo) ? $this->DadosVinculo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDadosVinculo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDadosVinculo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDadosVinculoForArrayConstraintsFromSetDadosVinculo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDadosVinculoDadosVinculoItem) {
            // validation for constraint: itemType
            if (!$arrayOfDadosVinculoDadosVinculoItem instanceof \StructType\DadosVinculo) {
                $invalidValues[] = is_object($arrayOfDadosVinculoDadosVinculoItem) ? get_class($arrayOfDadosVinculoDadosVinculoItem) : sprintf('%s(%s)', gettype($arrayOfDadosVinculoDadosVinculoItem), var_export($arrayOfDadosVinculoDadosVinculoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DadosVinculo property can only contain items of type \StructType\DadosVinculo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DadosVinculo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DadosVinculo[] $dadosVinculo
     * @return \ArrayType\ArrayOfDadosVinculo
     */
    public function setDadosVinculo(array $dadosVinculo = array())
    {
        // validation for constraint: array
        if ('' !== ($dadosVinculoArrayErrorMessage = self::validateDadosVinculoForArrayConstraintsFromSetDadosVinculo($dadosVinculo))) {
            throw new \InvalidArgumentException($dadosVinculoArrayErrorMessage, __LINE__);
        }
        if (is_null($dadosVinculo) || (is_array($dadosVinculo) && empty($dadosVinculo))) {
            unset($this->DadosVinculo);
        } else {
            $this->DadosVinculo = $dadosVinculo;
        }
        return $this;
    }
    /**
     * Add item to DadosVinculo value
     * @throws \InvalidArgumentException
     * @param \StructType\DadosVinculo $item
     * @return \ArrayType\ArrayOfDadosVinculo
     */
    public function addToDadosVinculo(\StructType\DadosVinculo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DadosVinculo) {
            throw new \InvalidArgumentException(sprintf('The DadosVinculo property can only contain items of type \StructType\DadosVinculo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DadosVinculo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DadosVinculo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DadosVinculo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DadosVinculo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DadosVinculo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DadosVinculo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DadosVinculo
     */
    public function getAttributeName()
    {
        return 'DadosVinculo';
    }
}
