<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfExperienciaProfissional ArrayType
 * @subpackage Arrays
 */
class ArrayOfExperienciaProfissional extends AbstractStructArrayBase
{
    /**
     * The ExperienciaProfissional
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ExperienciaProfissional[]
     */
    public $ExperienciaProfissional;
    /**
     * Constructor method for ArrayOfExperienciaProfissional
     * @uses ArrayOfExperienciaProfissional::setExperienciaProfissional()
     * @param \StructType\ExperienciaProfissional[] $experienciaProfissional
     */
    public function __construct(array $experienciaProfissional = array())
    {
        $this
            ->setExperienciaProfissional($experienciaProfissional);
    }
    /**
     * Get ExperienciaProfissional value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ExperienciaProfissional[]|null
     */
    public function getExperienciaProfissional()
    {
        return isset($this->ExperienciaProfissional) ? $this->ExperienciaProfissional : null;
    }
    /**
     * This method is responsible for validating the values passed to the setExperienciaProfissional method
     * This method is willingly generated in order to preserve the one-line inline validation within the setExperienciaProfissional method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateExperienciaProfissionalForArrayConstraintsFromSetExperienciaProfissional(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfExperienciaProfissionalExperienciaProfissionalItem) {
            // validation for constraint: itemType
            if (!$arrayOfExperienciaProfissionalExperienciaProfissionalItem instanceof \StructType\ExperienciaProfissional) {
                $invalidValues[] = is_object($arrayOfExperienciaProfissionalExperienciaProfissionalItem) ? get_class($arrayOfExperienciaProfissionalExperienciaProfissionalItem) : sprintf('%s(%s)', gettype($arrayOfExperienciaProfissionalExperienciaProfissionalItem), var_export($arrayOfExperienciaProfissionalExperienciaProfissionalItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ExperienciaProfissional property can only contain items of type \StructType\ExperienciaProfissional, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ExperienciaProfissional value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ExperienciaProfissional[] $experienciaProfissional
     * @return \ArrayType\ArrayOfExperienciaProfissional
     */
    public function setExperienciaProfissional(array $experienciaProfissional = array())
    {
        // validation for constraint: array
        if ('' !== ($experienciaProfissionalArrayErrorMessage = self::validateExperienciaProfissionalForArrayConstraintsFromSetExperienciaProfissional($experienciaProfissional))) {
            throw new \InvalidArgumentException($experienciaProfissionalArrayErrorMessage, __LINE__);
        }
        if (is_null($experienciaProfissional) || (is_array($experienciaProfissional) && empty($experienciaProfissional))) {
            unset($this->ExperienciaProfissional);
        } else {
            $this->ExperienciaProfissional = $experienciaProfissional;
        }
        return $this;
    }
    /**
     * Add item to ExperienciaProfissional value
     * @throws \InvalidArgumentException
     * @param \StructType\ExperienciaProfissional $item
     * @return \ArrayType\ArrayOfExperienciaProfissional
     */
    public function addToExperienciaProfissional(\StructType\ExperienciaProfissional $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ExperienciaProfissional) {
            throw new \InvalidArgumentException(sprintf('The ExperienciaProfissional property can only contain items of type \StructType\ExperienciaProfissional, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ExperienciaProfissional[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ExperienciaProfissional|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ExperienciaProfissional|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ExperienciaProfissional|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ExperienciaProfissional|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ExperienciaProfissional|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ExperienciaProfissional
     */
    public function getAttributeName()
    {
        return 'ExperienciaProfissional';
    }
}
