<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFichaFinaceiraBeneficiario ArrayType
 * @subpackage Arrays
 */
class ArrayOfFichaFinaceiraBeneficiario extends AbstractStructArrayBase
{
    /**
     * The FichaFinaceiraBeneficiario
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FichaFinaceiraBeneficiario[]
     */
    public $FichaFinaceiraBeneficiario;
    /**
     * Constructor method for ArrayOfFichaFinaceiraBeneficiario
     * @uses ArrayOfFichaFinaceiraBeneficiario::setFichaFinaceiraBeneficiario()
     * @param \StructType\FichaFinaceiraBeneficiario[] $fichaFinaceiraBeneficiario
     */
    public function __construct(array $fichaFinaceiraBeneficiario = array())
    {
        $this
            ->setFichaFinaceiraBeneficiario($fichaFinaceiraBeneficiario);
    }
    /**
     * Get FichaFinaceiraBeneficiario value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FichaFinaceiraBeneficiario[]|null
     */
    public function getFichaFinaceiraBeneficiario()
    {
        return isset($this->FichaFinaceiraBeneficiario) ? $this->FichaFinaceiraBeneficiario : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFichaFinaceiraBeneficiario method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFichaFinaceiraBeneficiario method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFichaFinaceiraBeneficiarioForArrayConstraintsFromSetFichaFinaceiraBeneficiario(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFichaFinaceiraBeneficiarioFichaFinaceiraBeneficiarioItem) {
            // validation for constraint: itemType
            if (!$arrayOfFichaFinaceiraBeneficiarioFichaFinaceiraBeneficiarioItem instanceof \StructType\FichaFinaceiraBeneficiario) {
                $invalidValues[] = is_object($arrayOfFichaFinaceiraBeneficiarioFichaFinaceiraBeneficiarioItem) ? get_class($arrayOfFichaFinaceiraBeneficiarioFichaFinaceiraBeneficiarioItem) : sprintf('%s(%s)', gettype($arrayOfFichaFinaceiraBeneficiarioFichaFinaceiraBeneficiarioItem), var_export($arrayOfFichaFinaceiraBeneficiarioFichaFinaceiraBeneficiarioItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FichaFinaceiraBeneficiario property can only contain items of type \StructType\FichaFinaceiraBeneficiario, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FichaFinaceiraBeneficiario value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FichaFinaceiraBeneficiario[] $fichaFinaceiraBeneficiario
     * @return \ArrayType\ArrayOfFichaFinaceiraBeneficiario
     */
    public function setFichaFinaceiraBeneficiario(array $fichaFinaceiraBeneficiario = array())
    {
        // validation for constraint: array
        if ('' !== ($fichaFinaceiraBeneficiarioArrayErrorMessage = self::validateFichaFinaceiraBeneficiarioForArrayConstraintsFromSetFichaFinaceiraBeneficiario($fichaFinaceiraBeneficiario))) {
            throw new \InvalidArgumentException($fichaFinaceiraBeneficiarioArrayErrorMessage, __LINE__);
        }
        if (is_null($fichaFinaceiraBeneficiario) || (is_array($fichaFinaceiraBeneficiario) && empty($fichaFinaceiraBeneficiario))) {
            unset($this->FichaFinaceiraBeneficiario);
        } else {
            $this->FichaFinaceiraBeneficiario = $fichaFinaceiraBeneficiario;
        }
        return $this;
    }
    /**
     * Add item to FichaFinaceiraBeneficiario value
     * @throws \InvalidArgumentException
     * @param \StructType\FichaFinaceiraBeneficiario $item
     * @return \ArrayType\ArrayOfFichaFinaceiraBeneficiario
     */
    public function addToFichaFinaceiraBeneficiario(\StructType\FichaFinaceiraBeneficiario $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FichaFinaceiraBeneficiario) {
            throw new \InvalidArgumentException(sprintf('The FichaFinaceiraBeneficiario property can only contain items of type \StructType\FichaFinaceiraBeneficiario, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FichaFinaceiraBeneficiario[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FichaFinaceiraBeneficiario|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FichaFinaceiraBeneficiario|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FichaFinaceiraBeneficiario|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FichaFinaceiraBeneficiario|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FichaFinaceiraBeneficiario|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FichaFinaceiraBeneficiario
     */
    public function getAttributeName()
    {
        return 'FichaFinaceiraBeneficiario';
    }
}
