<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFormacaoAcademica ArrayType
 * @subpackage Arrays
 */
class ArrayOfFormacaoAcademica extends AbstractStructArrayBase
{
    /**
     * The FormacaoAcademica
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FormacaoAcademica[]
     */
    public $FormacaoAcademica;
    /**
     * Constructor method for ArrayOfFormacaoAcademica
     * @uses ArrayOfFormacaoAcademica::setFormacaoAcademica()
     * @param \StructType\FormacaoAcademica[] $formacaoAcademica
     */
    public function __construct(array $formacaoAcademica = array())
    {
        $this
            ->setFormacaoAcademica($formacaoAcademica);
    }
    /**
     * Get FormacaoAcademica value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FormacaoAcademica[]|null
     */
    public function getFormacaoAcademica()
    {
        return isset($this->FormacaoAcademica) ? $this->FormacaoAcademica : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFormacaoAcademica method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFormacaoAcademica method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFormacaoAcademicaForArrayConstraintsFromSetFormacaoAcademica(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFormacaoAcademicaFormacaoAcademicaItem) {
            // validation for constraint: itemType
            if (!$arrayOfFormacaoAcademicaFormacaoAcademicaItem instanceof \StructType\FormacaoAcademica) {
                $invalidValues[] = is_object($arrayOfFormacaoAcademicaFormacaoAcademicaItem) ? get_class($arrayOfFormacaoAcademicaFormacaoAcademicaItem) : sprintf('%s(%s)', gettype($arrayOfFormacaoAcademicaFormacaoAcademicaItem), var_export($arrayOfFormacaoAcademicaFormacaoAcademicaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FormacaoAcademica property can only contain items of type \StructType\FormacaoAcademica, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FormacaoAcademica value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FormacaoAcademica[] $formacaoAcademica
     * @return \ArrayType\ArrayOfFormacaoAcademica
     */
    public function setFormacaoAcademica(array $formacaoAcademica = array())
    {
        // validation for constraint: array
        if ('' !== ($formacaoAcademicaArrayErrorMessage = self::validateFormacaoAcademicaForArrayConstraintsFromSetFormacaoAcademica($formacaoAcademica))) {
            throw new \InvalidArgumentException($formacaoAcademicaArrayErrorMessage, __LINE__);
        }
        if (is_null($formacaoAcademica) || (is_array($formacaoAcademica) && empty($formacaoAcademica))) {
            unset($this->FormacaoAcademica);
        } else {
            $this->FormacaoAcademica = $formacaoAcademica;
        }
        return $this;
    }
    /**
     * Add item to FormacaoAcademica value
     * @throws \InvalidArgumentException
     * @param \StructType\FormacaoAcademica $item
     * @return \ArrayType\ArrayOfFormacaoAcademica
     */
    public function addToFormacaoAcademica(\StructType\FormacaoAcademica $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FormacaoAcademica) {
            throw new \InvalidArgumentException(sprintf('The FormacaoAcademica property can only contain items of type \StructType\FormacaoAcademica, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FormacaoAcademica[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FormacaoAcademica|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FormacaoAcademica|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FormacaoAcademica|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FormacaoAcademica|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FormacaoAcademica|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FormacaoAcademica
     */
    public function getAttributeName()
    {
        return 'FormacaoAcademica';
    }
}
