<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInformacoesAposentadoria ArrayType
 * @subpackage Arrays
 */
class ArrayOfInformacoesAposentadoria extends AbstractStructArrayBase
{
    /**
     * The InformacoesAposentadoria
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InformacoesAposentadoria[]
     */
    public $InformacoesAposentadoria;
    /**
     * Constructor method for ArrayOfInformacoesAposentadoria
     * @uses ArrayOfInformacoesAposentadoria::setInformacoesAposentadoria()
     * @param \StructType\InformacoesAposentadoria[] $informacoesAposentadoria
     */
    public function __construct(array $informacoesAposentadoria = array())
    {
        $this
            ->setInformacoesAposentadoria($informacoesAposentadoria);
    }
    /**
     * Get InformacoesAposentadoria value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InformacoesAposentadoria[]|null
     */
    public function getInformacoesAposentadoria()
    {
        return isset($this->InformacoesAposentadoria) ? $this->InformacoesAposentadoria : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInformacoesAposentadoria method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInformacoesAposentadoria method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInformacoesAposentadoriaForArrayConstraintsFromSetInformacoesAposentadoria(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInformacoesAposentadoriaInformacoesAposentadoriaItem) {
            // validation for constraint: itemType
            if (!$arrayOfInformacoesAposentadoriaInformacoesAposentadoriaItem instanceof \StructType\InformacoesAposentadoria) {
                $invalidValues[] = is_object($arrayOfInformacoesAposentadoriaInformacoesAposentadoriaItem) ? get_class($arrayOfInformacoesAposentadoriaInformacoesAposentadoriaItem) : sprintf('%s(%s)', gettype($arrayOfInformacoesAposentadoriaInformacoesAposentadoriaItem), var_export($arrayOfInformacoesAposentadoriaInformacoesAposentadoriaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InformacoesAposentadoria property can only contain items of type \StructType\InformacoesAposentadoria, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InformacoesAposentadoria value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InformacoesAposentadoria[] $informacoesAposentadoria
     * @return \ArrayType\ArrayOfInformacoesAposentadoria
     */
    public function setInformacoesAposentadoria(array $informacoesAposentadoria = array())
    {
        // validation for constraint: array
        if ('' !== ($informacoesAposentadoriaArrayErrorMessage = self::validateInformacoesAposentadoriaForArrayConstraintsFromSetInformacoesAposentadoria($informacoesAposentadoria))) {
            throw new \InvalidArgumentException($informacoesAposentadoriaArrayErrorMessage, __LINE__);
        }
        if (is_null($informacoesAposentadoria) || (is_array($informacoesAposentadoria) && empty($informacoesAposentadoria))) {
            unset($this->InformacoesAposentadoria);
        } else {
            $this->InformacoesAposentadoria = $informacoesAposentadoria;
        }
        return $this;
    }
    /**
     * Add item to InformacoesAposentadoria value
     * @throws \InvalidArgumentException
     * @param \StructType\InformacoesAposentadoria $item
     * @return \ArrayType\ArrayOfInformacoesAposentadoria
     */
    public function addToInformacoesAposentadoria(\StructType\InformacoesAposentadoria $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InformacoesAposentadoria) {
            throw new \InvalidArgumentException(sprintf('The InformacoesAposentadoria property can only contain items of type \StructType\InformacoesAposentadoria, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InformacoesAposentadoria[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InformacoesAposentadoria|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InformacoesAposentadoria|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InformacoesAposentadoria|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InformacoesAposentadoria|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InformacoesAposentadoria|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InformacoesAposentadoria
     */
    public function getAttributeName()
    {
        return 'InformacoesAposentadoria';
    }
}
