<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfParticipacaoComissoes ArrayType
 * @subpackage Arrays
 */
class ArrayOfParticipacaoComissoes extends AbstractStructArrayBase
{
    /**
     * The ParticipacaoComissoes
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ParticipacaoComissoes[]
     */
    public $ParticipacaoComissoes;
    /**
     * Constructor method for ArrayOfParticipacaoComissoes
     * @uses ArrayOfParticipacaoComissoes::setParticipacaoComissoes()
     * @param \StructType\ParticipacaoComissoes[] $participacaoComissoes
     */
    public function __construct(array $participacaoComissoes = array())
    {
        $this
            ->setParticipacaoComissoes($participacaoComissoes);
    }
    /**
     * Get ParticipacaoComissoes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ParticipacaoComissoes[]|null
     */
    public function getParticipacaoComissoes()
    {
        return isset($this->ParticipacaoComissoes) ? $this->ParticipacaoComissoes : null;
    }
    /**
     * This method is responsible for validating the values passed to the setParticipacaoComissoes method
     * This method is willingly generated in order to preserve the one-line inline validation within the setParticipacaoComissoes method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateParticipacaoComissoesForArrayConstraintsFromSetParticipacaoComissoes(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfParticipacaoComissoesParticipacaoComissoesItem) {
            // validation for constraint: itemType
            if (!$arrayOfParticipacaoComissoesParticipacaoComissoesItem instanceof \StructType\ParticipacaoComissoes) {
                $invalidValues[] = is_object($arrayOfParticipacaoComissoesParticipacaoComissoesItem) ? get_class($arrayOfParticipacaoComissoesParticipacaoComissoesItem) : sprintf('%s(%s)', gettype($arrayOfParticipacaoComissoesParticipacaoComissoesItem), var_export($arrayOfParticipacaoComissoesParticipacaoComissoesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ParticipacaoComissoes property can only contain items of type \StructType\ParticipacaoComissoes, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ParticipacaoComissoes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ParticipacaoComissoes[] $participacaoComissoes
     * @return \ArrayType\ArrayOfParticipacaoComissoes
     */
    public function setParticipacaoComissoes(array $participacaoComissoes = array())
    {
        // validation for constraint: array
        if ('' !== ($participacaoComissoesArrayErrorMessage = self::validateParticipacaoComissoesForArrayConstraintsFromSetParticipacaoComissoes($participacaoComissoes))) {
            throw new \InvalidArgumentException($participacaoComissoesArrayErrorMessage, __LINE__);
        }
        if (is_null($participacaoComissoes) || (is_array($participacaoComissoes) && empty($participacaoComissoes))) {
            unset($this->ParticipacaoComissoes);
        } else {
            $this->ParticipacaoComissoes = $participacaoComissoes;
        }
        return $this;
    }
    /**
     * Add item to ParticipacaoComissoes value
     * @throws \InvalidArgumentException
     * @param \StructType\ParticipacaoComissoes $item
     * @return \ArrayType\ArrayOfParticipacaoComissoes
     */
    public function addToParticipacaoComissoes(\StructType\ParticipacaoComissoes $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ParticipacaoComissoes) {
            throw new \InvalidArgumentException(sprintf('The ParticipacaoComissoes property can only contain items of type \StructType\ParticipacaoComissoes, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ParticipacaoComissoes[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ParticipacaoComissoes|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ParticipacaoComissoes|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ParticipacaoComissoes|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ParticipacaoComissoes|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ParticipacaoComissoes|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ParticipacaoComissoes
     */
    public function getAttributeName()
    {
        return 'ParticipacaoComissoes';
    }
}
