<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPensaoRecebida ArrayType
 * @subpackage Arrays
 */
class ArrayOfPensaoRecebida extends AbstractStructArrayBase
{
    /**
     * The PensaoRecebida
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PensaoRecebida[]
     */
    public $PensaoRecebida;
    /**
     * Constructor method for ArrayOfPensaoRecebida
     * @uses ArrayOfPensaoRecebida::setPensaoRecebida()
     * @param \StructType\PensaoRecebida[] $pensaoRecebida
     */
    public function __construct(array $pensaoRecebida = array())
    {
        $this
            ->setPensaoRecebida($pensaoRecebida);
    }
    /**
     * Get PensaoRecebida value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PensaoRecebida[]|null
     */
    public function getPensaoRecebida()
    {
        return isset($this->PensaoRecebida) ? $this->PensaoRecebida : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPensaoRecebida method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPensaoRecebida method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePensaoRecebidaForArrayConstraintsFromSetPensaoRecebida(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPensaoRecebidaPensaoRecebidaItem) {
            // validation for constraint: itemType
            if (!$arrayOfPensaoRecebidaPensaoRecebidaItem instanceof \StructType\PensaoRecebida) {
                $invalidValues[] = is_object($arrayOfPensaoRecebidaPensaoRecebidaItem) ? get_class($arrayOfPensaoRecebidaPensaoRecebidaItem) : sprintf('%s(%s)', gettype($arrayOfPensaoRecebidaPensaoRecebidaItem), var_export($arrayOfPensaoRecebidaPensaoRecebidaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PensaoRecebida property can only contain items of type \StructType\PensaoRecebida, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PensaoRecebida value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PensaoRecebida[] $pensaoRecebida
     * @return \ArrayType\ArrayOfPensaoRecebida
     */
    public function setPensaoRecebida(array $pensaoRecebida = array())
    {
        // validation for constraint: array
        if ('' !== ($pensaoRecebidaArrayErrorMessage = self::validatePensaoRecebidaForArrayConstraintsFromSetPensaoRecebida($pensaoRecebida))) {
            throw new \InvalidArgumentException($pensaoRecebidaArrayErrorMessage, __LINE__);
        }
        if (is_null($pensaoRecebida) || (is_array($pensaoRecebida) && empty($pensaoRecebida))) {
            unset($this->PensaoRecebida);
        } else {
            $this->PensaoRecebida = $pensaoRecebida;
        }
        return $this;
    }
    /**
     * Add item to PensaoRecebida value
     * @throws \InvalidArgumentException
     * @param \StructType\PensaoRecebida $item
     * @return \ArrayType\ArrayOfPensaoRecebida
     */
    public function addToPensaoRecebida(\StructType\PensaoRecebida $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PensaoRecebida) {
            throw new \InvalidArgumentException(sprintf('The PensaoRecebida property can only contain items of type \StructType\PensaoRecebida, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PensaoRecebida[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PensaoRecebida|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PensaoRecebida|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PensaoRecebida|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PensaoRecebida|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PensaoRecebida|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PensaoRecebida
     */
    public function getAttributeName()
    {
        return 'PensaoRecebida';
    }
}
