<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPensoesInstituidas ArrayType
 * @subpackage Arrays
 */
class ArrayOfPensoesInstituidas extends AbstractStructArrayBase
{
    /**
     * The PensoesInstituidas
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PensoesInstituidas[]
     */
    public $PensoesInstituidas;
    /**
     * Constructor method for ArrayOfPensoesInstituidas
     * @uses ArrayOfPensoesInstituidas::setPensoesInstituidas()
     * @param \StructType\PensoesInstituidas[] $pensoesInstituidas
     */
    public function __construct(array $pensoesInstituidas = array())
    {
        $this
            ->setPensoesInstituidas($pensoesInstituidas);
    }
    /**
     * Get PensoesInstituidas value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PensoesInstituidas[]|null
     */
    public function getPensoesInstituidas()
    {
        return isset($this->PensoesInstituidas) ? $this->PensoesInstituidas : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPensoesInstituidas method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPensoesInstituidas method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePensoesInstituidasForArrayConstraintsFromSetPensoesInstituidas(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPensoesInstituidasPensoesInstituidasItem) {
            // validation for constraint: itemType
            if (!$arrayOfPensoesInstituidasPensoesInstituidasItem instanceof \StructType\PensoesInstituidas) {
                $invalidValues[] = is_object($arrayOfPensoesInstituidasPensoesInstituidasItem) ? get_class($arrayOfPensoesInstituidasPensoesInstituidasItem) : sprintf('%s(%s)', gettype($arrayOfPensoesInstituidasPensoesInstituidasItem), var_export($arrayOfPensoesInstituidasPensoesInstituidasItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PensoesInstituidas property can only contain items of type \StructType\PensoesInstituidas, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PensoesInstituidas value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PensoesInstituidas[] $pensoesInstituidas
     * @return \ArrayType\ArrayOfPensoesInstituidas
     */
    public function setPensoesInstituidas(array $pensoesInstituidas = array())
    {
        // validation for constraint: array
        if ('' !== ($pensoesInstituidasArrayErrorMessage = self::validatePensoesInstituidasForArrayConstraintsFromSetPensoesInstituidas($pensoesInstituidas))) {
            throw new \InvalidArgumentException($pensoesInstituidasArrayErrorMessage, __LINE__);
        }
        if (is_null($pensoesInstituidas) || (is_array($pensoesInstituidas) && empty($pensoesInstituidas))) {
            unset($this->PensoesInstituidas);
        } else {
            $this->PensoesInstituidas = $pensoesInstituidas;
        }
        return $this;
    }
    /**
     * Add item to PensoesInstituidas value
     * @throws \InvalidArgumentException
     * @param \StructType\PensoesInstituidas $item
     * @return \ArrayType\ArrayOfPensoesInstituidas
     */
    public function addToPensoesInstituidas(\StructType\PensoesInstituidas $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PensoesInstituidas) {
            throw new \InvalidArgumentException(sprintf('The PensoesInstituidas property can only contain items of type \StructType\PensoesInstituidas, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PensoesInstituidas[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PensoesInstituidas|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PensoesInstituidas|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PensoesInstituidas|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PensoesInstituidas|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PensoesInstituidas|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PensoesInstituidas
     */
    public function getAttributeName()
    {
        return 'PensoesInstituidas';
    }
}
