<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVagasOrgao ArrayType
 * @subpackage Arrays
 */
class ArrayOfVagasOrgao extends AbstractStructArrayBase
{
    /**
     * The VagasOrgao
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VagasOrgao[]
     */
    public $VagasOrgao;
    /**
     * Constructor method for ArrayOfVagasOrgao
     * @uses ArrayOfVagasOrgao::setVagasOrgao()
     * @param \StructType\VagasOrgao[] $vagasOrgao
     */
    public function __construct(array $vagasOrgao = array())
    {
        $this
            ->setVagasOrgao($vagasOrgao);
    }
    /**
     * Get VagasOrgao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VagasOrgao[]|null
     */
    public function getVagasOrgao()
    {
        return isset($this->VagasOrgao) ? $this->VagasOrgao : null;
    }
    /**
     * This method is responsible for validating the values passed to the setVagasOrgao method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVagasOrgao method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVagasOrgaoForArrayConstraintsFromSetVagasOrgao(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVagasOrgaoVagasOrgaoItem) {
            // validation for constraint: itemType
            if (!$arrayOfVagasOrgaoVagasOrgaoItem instanceof \StructType\VagasOrgao) {
                $invalidValues[] = is_object($arrayOfVagasOrgaoVagasOrgaoItem) ? get_class($arrayOfVagasOrgaoVagasOrgaoItem) : sprintf('%s(%s)', gettype($arrayOfVagasOrgaoVagasOrgaoItem), var_export($arrayOfVagasOrgaoVagasOrgaoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VagasOrgao property can only contain items of type \StructType\VagasOrgao, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VagasOrgao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\VagasOrgao[] $vagasOrgao
     * @return \ArrayType\ArrayOfVagasOrgao
     */
    public function setVagasOrgao(array $vagasOrgao = array())
    {
        // validation for constraint: array
        if ('' !== ($vagasOrgaoArrayErrorMessage = self::validateVagasOrgaoForArrayConstraintsFromSetVagasOrgao($vagasOrgao))) {
            throw new \InvalidArgumentException($vagasOrgaoArrayErrorMessage, __LINE__);
        }
        if (is_null($vagasOrgao) || (is_array($vagasOrgao) && empty($vagasOrgao))) {
            unset($this->VagasOrgao);
        } else {
            $this->VagasOrgao = $vagasOrgao;
        }
        return $this;
    }
    /**
     * Add item to VagasOrgao value
     * @throws \InvalidArgumentException
     * @param \StructType\VagasOrgao $item
     * @return \ArrayType\ArrayOfVagasOrgao
     */
    public function addToVagasOrgao(\StructType\VagasOrgao $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VagasOrgao) {
            throw new \InvalidArgumentException(sprintf('The VagasOrgao property can only contain items of type \StructType\VagasOrgao, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VagasOrgao[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\VagasOrgao|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\VagasOrgao|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\VagasOrgao|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\VagasOrgao|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\VagasOrgao|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VagasOrgao
     */
    public function getAttributeName()
    {
        return 'VagasOrgao';
    }
}
