<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AlimentadosPA StructType
 * @subpackage Structs
 */
class AlimentadosPA extends AbstractStructBase
{
    /**
     * The codVinculoServidor
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $codVinculoServidor;
    /**
     * The nomeAlimentado
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nomeAlimentado;
    /**
     * The nomeVinculoServidor
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nomeVinculoServidor;
    /**
     * Constructor method for AlimentadosPA
     * @uses AlimentadosPA::setCodVinculoServidor()
     * @uses AlimentadosPA::setNomeAlimentado()
     * @uses AlimentadosPA::setNomeVinculoServidor()
     * @param string $codVinculoServidor
     * @param string $nomeAlimentado
     * @param string $nomeVinculoServidor
     */
    public function __construct($codVinculoServidor = null, $nomeAlimentado = null, $nomeVinculoServidor = null)
    {
        $this
            ->setCodVinculoServidor($codVinculoServidor)
            ->setNomeAlimentado($nomeAlimentado)
            ->setNomeVinculoServidor($nomeVinculoServidor);
    }
    /**
     * Get codVinculoServidor value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodVinculoServidor()
    {
        return isset($this->codVinculoServidor) ? $this->codVinculoServidor : null;
    }
    /**
     * Set codVinculoServidor value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codVinculoServidor
     * @return \StructType\AlimentadosPA
     */
    public function setCodVinculoServidor($codVinculoServidor = null)
    {
        // validation for constraint: string
        if (!is_null($codVinculoServidor) && !is_string($codVinculoServidor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codVinculoServidor, true), gettype($codVinculoServidor)), __LINE__);
        }
        if (is_null($codVinculoServidor) || (is_array($codVinculoServidor) && empty($codVinculoServidor))) {
            unset($this->codVinculoServidor);
        } else {
            $this->codVinculoServidor = $codVinculoServidor;
        }
        return $this;
    }
    /**
     * Get nomeAlimentado value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNomeAlimentado()
    {
        return isset($this->nomeAlimentado) ? $this->nomeAlimentado : null;
    }
    /**
     * Set nomeAlimentado value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nomeAlimentado
     * @return \StructType\AlimentadosPA
     */
    public function setNomeAlimentado($nomeAlimentado = null)
    {
        // validation for constraint: string
        if (!is_null($nomeAlimentado) && !is_string($nomeAlimentado)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nomeAlimentado, true), gettype($nomeAlimentado)), __LINE__);
        }
        if (is_null($nomeAlimentado) || (is_array($nomeAlimentado) && empty($nomeAlimentado))) {
            unset($this->nomeAlimentado);
        } else {
            $this->nomeAlimentado = $nomeAlimentado;
        }
        return $this;
    }
    /**
     * Get nomeVinculoServidor value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNomeVinculoServidor()
    {
        return isset($this->nomeVinculoServidor) ? $this->nomeVinculoServidor : null;
    }
    /**
     * Set nomeVinculoServidor value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nomeVinculoServidor
     * @return \StructType\AlimentadosPA
     */
    public function setNomeVinculoServidor($nomeVinculoServidor = null)
    {
        // validation for constraint: string
        if (!is_null($nomeVinculoServidor) && !is_string($nomeVinculoServidor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nomeVinculoServidor, true), gettype($nomeVinculoServidor)), __LINE__);
        }
        if (is_null($nomeVinculoServidor) || (is_array($nomeVinculoServidor) && empty($nomeVinculoServidor))) {
            unset($this->nomeVinculoServidor);
        } else {
            $this->nomeVinculoServidor = $nomeVinculoServidor;
        }
        return $this;
    }
}
