<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Beneficio StructType
 * @subpackage Structs
 */
class Beneficio extends AbstractStructBase
{
    /**
     * The codBeneficio
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $codBeneficio;
    /**
     * The dataFim
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dataFim;
    /**
     * The dataInicio
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dataInicio;
    /**
     * The nomeBeneficio
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nomeBeneficio;
    /**
     * Constructor method for Beneficio
     * @uses Beneficio::setCodBeneficio()
     * @uses Beneficio::setDataFim()
     * @uses Beneficio::setDataInicio()
     * @uses Beneficio::setNomeBeneficio()
     * @param string $codBeneficio
     * @param string $dataFim
     * @param string $dataInicio
     * @param string $nomeBeneficio
     */
    public function __construct($codBeneficio = null, $dataFim = null, $dataInicio = null, $nomeBeneficio = null)
    {
        $this
            ->setCodBeneficio($codBeneficio)
            ->setDataFim($dataFim)
            ->setDataInicio($dataInicio)
            ->setNomeBeneficio($nomeBeneficio);
    }
    /**
     * Get codBeneficio value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodBeneficio()
    {
        return isset($this->codBeneficio) ? $this->codBeneficio : null;
    }
    /**
     * Set codBeneficio value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codBeneficio
     * @return \StructType\Beneficio
     */
    public function setCodBeneficio($codBeneficio = null)
    {
        // validation for constraint: string
        if (!is_null($codBeneficio) && !is_string($codBeneficio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codBeneficio, true), gettype($codBeneficio)), __LINE__);
        }
        if (is_null($codBeneficio) || (is_array($codBeneficio) && empty($codBeneficio))) {
            unset($this->codBeneficio);
        } else {
            $this->codBeneficio = $codBeneficio;
        }
        return $this;
    }
    /**
     * Get dataFim value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataFim()
    {
        return isset($this->dataFim) ? $this->dataFim : null;
    }
    /**
     * Set dataFim value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataFim
     * @return \StructType\Beneficio
     */
    public function setDataFim($dataFim = null)
    {
        // validation for constraint: string
        if (!is_null($dataFim) && !is_string($dataFim)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataFim, true), gettype($dataFim)), __LINE__);
        }
        if (is_null($dataFim) || (is_array($dataFim) && empty($dataFim))) {
            unset($this->dataFim);
        } else {
            $this->dataFim = $dataFim;
        }
        return $this;
    }
    /**
     * Get dataInicio value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataInicio()
    {
        return isset($this->dataInicio) ? $this->dataInicio : null;
    }
    /**
     * Set dataInicio value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataInicio
     * @return \StructType\Beneficio
     */
    public function setDataInicio($dataInicio = null)
    {
        // validation for constraint: string
        if (!is_null($dataInicio) && !is_string($dataInicio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataInicio, true), gettype($dataInicio)), __LINE__);
        }
        if (is_null($dataInicio) || (is_array($dataInicio) && empty($dataInicio))) {
            unset($this->dataInicio);
        } else {
            $this->dataInicio = $dataInicio;
        }
        return $this;
    }
    /**
     * Get nomeBeneficio value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNomeBeneficio()
    {
        return isset($this->nomeBeneficio) ? $this->nomeBeneficio : null;
    }
    /**
     * Set nomeBeneficio value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nomeBeneficio
     * @return \StructType\Beneficio
     */
    public function setNomeBeneficio($nomeBeneficio = null)
    {
        // validation for constraint: string
        if (!is_null($nomeBeneficio) && !is_string($nomeBeneficio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nomeBeneficio, true), gettype($nomeBeneficio)), __LINE__);
        }
        if (is_null($nomeBeneficio) || (is_array($nomeBeneficio) && empty($nomeBeneficio))) {
            unset($this->nomeBeneficio);
        } else {
            $this->nomeBeneficio = $nomeBeneficio;
        }
        return $this;
    }
}
