<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContribuicoesPSS StructType
 * @subpackage Structs
 */
class ContribuicoesPSS extends AbstractStructBase
{
    /**
     * The indiceReajuste
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $indiceReajuste;
    /**
     * The pssApurado
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $pssApurado;
    /**
     * The pssInformado
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $pssInformado;
    /**
     * The remuneracaoPss
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $remuneracaoPss;
    /**
     * The remuneracaoPssAjustada
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $remuneracaoPssAjustada;
    /**
     * Constructor method for ContribuicoesPSS
     * @uses ContribuicoesPSS::setIndiceReajuste()
     * @uses ContribuicoesPSS::setPssApurado()
     * @uses ContribuicoesPSS::setPssInformado()
     * @uses ContribuicoesPSS::setRemuneracaoPss()
     * @uses ContribuicoesPSS::setRemuneracaoPssAjustada()
     * @param string $indiceReajuste
     * @param string $pssApurado
     * @param string $pssInformado
     * @param string $remuneracaoPss
     * @param string $remuneracaoPssAjustada
     */
    public function __construct($indiceReajuste = null, $pssApurado = null, $pssInformado = null, $remuneracaoPss = null, $remuneracaoPssAjustada = null)
    {
        $this
            ->setIndiceReajuste($indiceReajuste)
            ->setPssApurado($pssApurado)
            ->setPssInformado($pssInformado)
            ->setRemuneracaoPss($remuneracaoPss)
            ->setRemuneracaoPssAjustada($remuneracaoPssAjustada);
    }
    /**
     * Get indiceReajuste value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIndiceReajuste()
    {
        return isset($this->indiceReajuste) ? $this->indiceReajuste : null;
    }
    /**
     * Set indiceReajuste value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $indiceReajuste
     * @return \StructType\ContribuicoesPSS
     */
    public function setIndiceReajuste($indiceReajuste = null)
    {
        // validation for constraint: string
        if (!is_null($indiceReajuste) && !is_string($indiceReajuste)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($indiceReajuste, true), gettype($indiceReajuste)), __LINE__);
        }
        if (is_null($indiceReajuste) || (is_array($indiceReajuste) && empty($indiceReajuste))) {
            unset($this->indiceReajuste);
        } else {
            $this->indiceReajuste = $indiceReajuste;
        }
        return $this;
    }
    /**
     * Get pssApurado value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPssApurado()
    {
        return isset($this->pssApurado) ? $this->pssApurado : null;
    }
    /**
     * Set pssApurado value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $pssApurado
     * @return \StructType\ContribuicoesPSS
     */
    public function setPssApurado($pssApurado = null)
    {
        // validation for constraint: string
        if (!is_null($pssApurado) && !is_string($pssApurado)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pssApurado, true), gettype($pssApurado)), __LINE__);
        }
        if (is_null($pssApurado) || (is_array($pssApurado) && empty($pssApurado))) {
            unset($this->pssApurado);
        } else {
            $this->pssApurado = $pssApurado;
        }
        return $this;
    }
    /**
     * Get pssInformado value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPssInformado()
    {
        return isset($this->pssInformado) ? $this->pssInformado : null;
    }
    /**
     * Set pssInformado value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $pssInformado
     * @return \StructType\ContribuicoesPSS
     */
    public function setPssInformado($pssInformado = null)
    {
        // validation for constraint: string
        if (!is_null($pssInformado) && !is_string($pssInformado)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pssInformado, true), gettype($pssInformado)), __LINE__);
        }
        if (is_null($pssInformado) || (is_array($pssInformado) && empty($pssInformado))) {
            unset($this->pssInformado);
        } else {
            $this->pssInformado = $pssInformado;
        }
        return $this;
    }
    /**
     * Get remuneracaoPss value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRemuneracaoPss()
    {
        return isset($this->remuneracaoPss) ? $this->remuneracaoPss : null;
    }
    /**
     * Set remuneracaoPss value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $remuneracaoPss
     * @return \StructType\ContribuicoesPSS
     */
    public function setRemuneracaoPss($remuneracaoPss = null)
    {
        // validation for constraint: string
        if (!is_null($remuneracaoPss) && !is_string($remuneracaoPss)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($remuneracaoPss, true), gettype($remuneracaoPss)), __LINE__);
        }
        if (is_null($remuneracaoPss) || (is_array($remuneracaoPss) && empty($remuneracaoPss))) {
            unset($this->remuneracaoPss);
        } else {
            $this->remuneracaoPss = $remuneracaoPss;
        }
        return $this;
    }
    /**
     * Get remuneracaoPssAjustada value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRemuneracaoPssAjustada()
    {
        return isset($this->remuneracaoPssAjustada) ? $this->remuneracaoPssAjustada : null;
    }
    /**
     * Set remuneracaoPssAjustada value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $remuneracaoPssAjustada
     * @return \StructType\ContribuicoesPSS
     */
    public function setRemuneracaoPssAjustada($remuneracaoPssAjustada = null)
    {
        // validation for constraint: string
        if (!is_null($remuneracaoPssAjustada) && !is_string($remuneracaoPssAjustada)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($remuneracaoPssAjustada, true), gettype($remuneracaoPssAjustada)), __LINE__);
        }
        if (is_null($remuneracaoPssAjustada) || (is_array($remuneracaoPssAjustada) && empty($remuneracaoPssAjustada))) {
            unset($this->remuneracaoPssAjustada);
        } else {
            $this->remuneracaoPssAjustada = $remuneracaoPssAjustada;
        }
        return $this;
    }
}
