<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Curso StructType
 * @subpackage Structs
 */
class Curso extends AbstractStructBase
{
    /**
     * The codCurso
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $codCurso;
    /**
     * The nomeCurso
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nomeCurso;
    /**
     * Constructor method for Curso
     * @uses Curso::setCodCurso()
     * @uses Curso::setNomeCurso()
     * @param int $codCurso
     * @param string $nomeCurso
     */
    public function __construct($codCurso = null, $nomeCurso = null)
    {
        $this
            ->setCodCurso($codCurso)
            ->setNomeCurso($nomeCurso);
    }
    /**
     * Get codCurso value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getCodCurso()
    {
        return isset($this->codCurso) ? $this->codCurso : null;
    }
    /**
     * Set codCurso value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $codCurso
     * @return \StructType\Curso
     */
    public function setCodCurso($codCurso = null)
    {
        // validation for constraint: int
        if (!is_null($codCurso) && !(is_int($codCurso) || ctype_digit($codCurso))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($codCurso, true), gettype($codCurso)), __LINE__);
        }
        if (is_null($codCurso) || (is_array($codCurso) && empty($codCurso))) {
            unset($this->codCurso);
        } else {
            $this->codCurso = $codCurso;
        }
        return $this;
    }
    /**
     * Get nomeCurso value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNomeCurso()
    {
        return isset($this->nomeCurso) ? $this->nomeCurso : null;
    }
    /**
     * Set nomeCurso value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nomeCurso
     * @return \StructType\Curso
     */
    public function setNomeCurso($nomeCurso = null)
    {
        // validation for constraint: string
        if (!is_null($nomeCurso) && !is_string($nomeCurso)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nomeCurso, true), gettype($nomeCurso)), __LINE__);
        }
        if (is_null($nomeCurso) || (is_array($nomeCurso) && empty($nomeCurso))) {
            unset($this->nomeCurso);
        } else {
            $this->nomeCurso = $nomeCurso;
        }
        return $this;
    }
}
