<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Cursos StructType
 * @subpackage Structs
 */
class Cursos extends AbstractStructBase
{
    /**
     * The area
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Area
     */
    public $area;
    /**
     * The cargaHoraria
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $cargaHoraria;
    /**
     * The codCurso
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $codCurso;
    /**
     * The dataConclusao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dataConclusao;
    /**
     * The instituicao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $instituicao;
    /**
     * The nomeCurso
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nomeCurso;
    /**
     * The tipoEvento
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipoEvento
     */
    public $tipoEvento;
    /**
     * Constructor method for Cursos
     * @uses Cursos::setArea()
     * @uses Cursos::setCargaHoraria()
     * @uses Cursos::setCodCurso()
     * @uses Cursos::setDataConclusao()
     * @uses Cursos::setInstituicao()
     * @uses Cursos::setNomeCurso()
     * @uses Cursos::setTipoEvento()
     * @param \StructType\Area $area
     * @param int $cargaHoraria
     * @param int $codCurso
     * @param string $dataConclusao
     * @param string $instituicao
     * @param string $nomeCurso
     * @param \StructType\TipoEvento $tipoEvento
     */
    public function __construct(\StructType\Area $area = null, $cargaHoraria = null, $codCurso = null, $dataConclusao = null, $instituicao = null, $nomeCurso = null, \StructType\TipoEvento $tipoEvento = null)
    {
        $this
            ->setArea($area)
            ->setCargaHoraria($cargaHoraria)
            ->setCodCurso($codCurso)
            ->setDataConclusao($dataConclusao)
            ->setInstituicao($instituicao)
            ->setNomeCurso($nomeCurso)
            ->setTipoEvento($tipoEvento);
    }
    /**
     * Get area value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Area|null
     */
    public function getArea()
    {
        return isset($this->area) ? $this->area : null;
    }
    /**
     * Set area value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Area $area
     * @return \StructType\Cursos
     */
    public function setArea(\StructType\Area $area = null)
    {
        if (is_null($area) || (is_array($area) && empty($area))) {
            unset($this->area);
        } else {
            $this->area = $area;
        }
        return $this;
    }
    /**
     * Get cargaHoraria value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getCargaHoraria()
    {
        return isset($this->cargaHoraria) ? $this->cargaHoraria : null;
    }
    /**
     * Set cargaHoraria value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $cargaHoraria
     * @return \StructType\Cursos
     */
    public function setCargaHoraria($cargaHoraria = null)
    {
        // validation for constraint: int
        if (!is_null($cargaHoraria) && !(is_int($cargaHoraria) || ctype_digit($cargaHoraria))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($cargaHoraria, true), gettype($cargaHoraria)), __LINE__);
        }
        if (is_null($cargaHoraria) || (is_array($cargaHoraria) && empty($cargaHoraria))) {
            unset($this->cargaHoraria);
        } else {
            $this->cargaHoraria = $cargaHoraria;
        }
        return $this;
    }
    /**
     * Get codCurso value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getCodCurso()
    {
        return isset($this->codCurso) ? $this->codCurso : null;
    }
    /**
     * Set codCurso value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $codCurso
     * @return \StructType\Cursos
     */
    public function setCodCurso($codCurso = null)
    {
        // validation for constraint: int
        if (!is_null($codCurso) && !(is_int($codCurso) || ctype_digit($codCurso))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($codCurso, true), gettype($codCurso)), __LINE__);
        }
        if (is_null($codCurso) || (is_array($codCurso) && empty($codCurso))) {
            unset($this->codCurso);
        } else {
            $this->codCurso = $codCurso;
        }
        return $this;
    }
    /**
     * Get dataConclusao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataConclusao()
    {
        return isset($this->dataConclusao) ? $this->dataConclusao : null;
    }
    /**
     * Set dataConclusao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataConclusao
     * @return \StructType\Cursos
     */
    public function setDataConclusao($dataConclusao = null)
    {
        // validation for constraint: string
        if (!is_null($dataConclusao) && !is_string($dataConclusao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataConclusao, true), gettype($dataConclusao)), __LINE__);
        }
        if (is_null($dataConclusao) || (is_array($dataConclusao) && empty($dataConclusao))) {
            unset($this->dataConclusao);
        } else {
            $this->dataConclusao = $dataConclusao;
        }
        return $this;
    }
    /**
     * Get instituicao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInstituicao()
    {
        return isset($this->instituicao) ? $this->instituicao : null;
    }
    /**
     * Set instituicao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $instituicao
     * @return \StructType\Cursos
     */
    public function setInstituicao($instituicao = null)
    {
        // validation for constraint: string
        if (!is_null($instituicao) && !is_string($instituicao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($instituicao, true), gettype($instituicao)), __LINE__);
        }
        if (is_null($instituicao) || (is_array($instituicao) && empty($instituicao))) {
            unset($this->instituicao);
        } else {
            $this->instituicao = $instituicao;
        }
        return $this;
    }
    /**
     * Get nomeCurso value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNomeCurso()
    {
        return isset($this->nomeCurso) ? $this->nomeCurso : null;
    }
    /**
     * Set nomeCurso value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nomeCurso
     * @return \StructType\Cursos
     */
    public function setNomeCurso($nomeCurso = null)
    {
        // validation for constraint: string
        if (!is_null($nomeCurso) && !is_string($nomeCurso)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nomeCurso, true), gettype($nomeCurso)), __LINE__);
        }
        if (is_null($nomeCurso) || (is_array($nomeCurso) && empty($nomeCurso))) {
            unset($this->nomeCurso);
        } else {
            $this->nomeCurso = $nomeCurso;
        }
        return $this;
    }
    /**
     * Get tipoEvento value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipoEvento|null
     */
    public function getTipoEvento()
    {
        return isset($this->tipoEvento) ? $this->tipoEvento : null;
    }
    /**
     * Set tipoEvento value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\TipoEvento $tipoEvento
     * @return \StructType\Cursos
     */
    public function setTipoEvento(\StructType\TipoEvento $tipoEvento = null)
    {
        if (is_null($tipoEvento) || (is_array($tipoEvento) && empty($tipoEvento))) {
            unset($this->tipoEvento);
        } else {
            $this->tipoEvento = $tipoEvento;
        }
        return $this;
    }
}
