<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DadosBancarios StructType
 * @subpackage Structs
 */
class DadosBancarios extends AbstractStructBase
{
    /**
     * The agencia
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $agencia;
    /**
     * The agenciaOutrosPagtos
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $agenciaOutrosPagtos;
    /**
     * The banco
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $banco;
    /**
     * The bancoOutrosPagtos
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $bancoOutrosPagtos;
    /**
     * The codOrgao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $codOrgao;
    /**
     * The contaCorrente
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $contaCorrente;
    /**
     * The contaCorrenteOutrosPagtos
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $contaCorrenteOutrosPagtos;
    /**
     * The matricula
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $matricula;
    /**
     * Constructor method for DadosBancarios
     * @uses DadosBancarios::setAgencia()
     * @uses DadosBancarios::setAgenciaOutrosPagtos()
     * @uses DadosBancarios::setBanco()
     * @uses DadosBancarios::setBancoOutrosPagtos()
     * @uses DadosBancarios::setCodOrgao()
     * @uses DadosBancarios::setContaCorrente()
     * @uses DadosBancarios::setContaCorrenteOutrosPagtos()
     * @uses DadosBancarios::setMatricula()
     * @param string $agencia
     * @param string $agenciaOutrosPagtos
     * @param string $banco
     * @param string $bancoOutrosPagtos
     * @param string $codOrgao
     * @param string $contaCorrente
     * @param string $contaCorrenteOutrosPagtos
     * @param string $matricula
     */
    public function __construct($agencia = null, $agenciaOutrosPagtos = null, $banco = null, $bancoOutrosPagtos = null, $codOrgao = null, $contaCorrente = null, $contaCorrenteOutrosPagtos = null, $matricula = null)
    {
        $this
            ->setAgencia($agencia)
            ->setAgenciaOutrosPagtos($agenciaOutrosPagtos)
            ->setBanco($banco)
            ->setBancoOutrosPagtos($bancoOutrosPagtos)
            ->setCodOrgao($codOrgao)
            ->setContaCorrente($contaCorrente)
            ->setContaCorrenteOutrosPagtos($contaCorrenteOutrosPagtos)
            ->setMatricula($matricula);
    }
    /**
     * Get agencia value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAgencia()
    {
        return isset($this->agencia) ? $this->agencia : null;
    }
    /**
     * Set agencia value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $agencia
     * @return \StructType\DadosBancarios
     */
    public function setAgencia($agencia = null)
    {
        // validation for constraint: string
        if (!is_null($agencia) && !is_string($agencia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($agencia, true), gettype($agencia)), __LINE__);
        }
        if (is_null($agencia) || (is_array($agencia) && empty($agencia))) {
            unset($this->agencia);
        } else {
            $this->agencia = $agencia;
        }
        return $this;
    }
    /**
     * Get agenciaOutrosPagtos value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAgenciaOutrosPagtos()
    {
        return isset($this->agenciaOutrosPagtos) ? $this->agenciaOutrosPagtos : null;
    }
    /**
     * Set agenciaOutrosPagtos value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $agenciaOutrosPagtos
     * @return \StructType\DadosBancarios
     */
    public function setAgenciaOutrosPagtos($agenciaOutrosPagtos = null)
    {
        // validation for constraint: string
        if (!is_null($agenciaOutrosPagtos) && !is_string($agenciaOutrosPagtos)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($agenciaOutrosPagtos, true), gettype($agenciaOutrosPagtos)), __LINE__);
        }
        if (is_null($agenciaOutrosPagtos) || (is_array($agenciaOutrosPagtos) && empty($agenciaOutrosPagtos))) {
            unset($this->agenciaOutrosPagtos);
        } else {
            $this->agenciaOutrosPagtos = $agenciaOutrosPagtos;
        }
        return $this;
    }
    /**
     * Get banco value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBanco()
    {
        return isset($this->banco) ? $this->banco : null;
    }
    /**
     * Set banco value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $banco
     * @return \StructType\DadosBancarios
     */
    public function setBanco($banco = null)
    {
        // validation for constraint: string
        if (!is_null($banco) && !is_string($banco)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($banco, true), gettype($banco)), __LINE__);
        }
        if (is_null($banco) || (is_array($banco) && empty($banco))) {
            unset($this->banco);
        } else {
            $this->banco = $banco;
        }
        return $this;
    }
    /**
     * Get bancoOutrosPagtos value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBancoOutrosPagtos()
    {
        return isset($this->bancoOutrosPagtos) ? $this->bancoOutrosPagtos : null;
    }
    /**
     * Set bancoOutrosPagtos value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $bancoOutrosPagtos
     * @return \StructType\DadosBancarios
     */
    public function setBancoOutrosPagtos($bancoOutrosPagtos = null)
    {
        // validation for constraint: string
        if (!is_null($bancoOutrosPagtos) && !is_string($bancoOutrosPagtos)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bancoOutrosPagtos, true), gettype($bancoOutrosPagtos)), __LINE__);
        }
        if (is_null($bancoOutrosPagtos) || (is_array($bancoOutrosPagtos) && empty($bancoOutrosPagtos))) {
            unset($this->bancoOutrosPagtos);
        } else {
            $this->bancoOutrosPagtos = $bancoOutrosPagtos;
        }
        return $this;
    }
    /**
     * Get codOrgao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodOrgao()
    {
        return isset($this->codOrgao) ? $this->codOrgao : null;
    }
    /**
     * Set codOrgao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codOrgao
     * @return \StructType\DadosBancarios
     */
    public function setCodOrgao($codOrgao = null)
    {
        // validation for constraint: string
        if (!is_null($codOrgao) && !is_string($codOrgao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codOrgao, true), gettype($codOrgao)), __LINE__);
        }
        if (is_null($codOrgao) || (is_array($codOrgao) && empty($codOrgao))) {
            unset($this->codOrgao);
        } else {
            $this->codOrgao = $codOrgao;
        }
        return $this;
    }
    /**
     * Get contaCorrente value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getContaCorrente()
    {
        return isset($this->contaCorrente) ? $this->contaCorrente : null;
    }
    /**
     * Set contaCorrente value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $contaCorrente
     * @return \StructType\DadosBancarios
     */
    public function setContaCorrente($contaCorrente = null)
    {
        // validation for constraint: string
        if (!is_null($contaCorrente) && !is_string($contaCorrente)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contaCorrente, true), gettype($contaCorrente)), __LINE__);
        }
        if (is_null($contaCorrente) || (is_array($contaCorrente) && empty($contaCorrente))) {
            unset($this->contaCorrente);
        } else {
            $this->contaCorrente = $contaCorrente;
        }
        return $this;
    }
    /**
     * Get contaCorrenteOutrosPagtos value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getContaCorrenteOutrosPagtos()
    {
        return isset($this->contaCorrenteOutrosPagtos) ? $this->contaCorrenteOutrosPagtos : null;
    }
    /**
     * Set contaCorrenteOutrosPagtos value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $contaCorrenteOutrosPagtos
     * @return \StructType\DadosBancarios
     */
    public function setContaCorrenteOutrosPagtos($contaCorrenteOutrosPagtos = null)
    {
        // validation for constraint: string
        if (!is_null($contaCorrenteOutrosPagtos) && !is_string($contaCorrenteOutrosPagtos)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contaCorrenteOutrosPagtos, true), gettype($contaCorrenteOutrosPagtos)), __LINE__);
        }
        if (is_null($contaCorrenteOutrosPagtos) || (is_array($contaCorrenteOutrosPagtos) && empty($contaCorrenteOutrosPagtos))) {
            unset($this->contaCorrenteOutrosPagtos);
        } else {
            $this->contaCorrenteOutrosPagtos = $contaCorrenteOutrosPagtos;
        }
        return $this;
    }
    /**
     * Get matricula value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMatricula()
    {
        return isset($this->matricula) ? $this->matricula : null;
    }
    /**
     * Set matricula value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $matricula
     * @return \StructType\DadosBancarios
     */
    public function setMatricula($matricula = null)
    {
        // validation for constraint: string
        if (!is_null($matricula) && !is_string($matricula)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($matricula, true), gettype($matricula)), __LINE__);
        }
        if (is_null($matricula) || (is_array($matricula) && empty($matricula))) {
            unset($this->matricula);
        } else {
            $this->matricula = $matricula;
        }
        return $this;
    }
}
