<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DadosCurriculo StructType
 * @subpackage Structs
 */
class DadosCurriculo extends AbstractStructBase
{
    /**
     * The cpf
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cpf;
    /**
     * The identificUnica
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $identificUnica;
    /**
     * The listaCurso
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfCursos
     */
    public $listaCurso;
    /**
     * The listaExperienciaProfissional
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfExperienciaProfissional
     */
    public $listaExperienciaProfissional;
    /**
     * The listaFormacaoAcademica
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfFormacaoAcademica
     */
    public $listaFormacaoAcademica;
    /**
     * The listaIdiomas
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfIdiomas
     */
    public $listaIdiomas;
    /**
     * The listaParticipacaoComissoes
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfParticipacaoComissoes
     */
    public $listaParticipacaoComissoes;
    /**
     * Constructor method for DadosCurriculo
     * @uses DadosCurriculo::setCpf()
     * @uses DadosCurriculo::setIdentificUnica()
     * @uses DadosCurriculo::setListaCurso()
     * @uses DadosCurriculo::setListaExperienciaProfissional()
     * @uses DadosCurriculo::setListaFormacaoAcademica()
     * @uses DadosCurriculo::setListaIdiomas()
     * @uses DadosCurriculo::setListaParticipacaoComissoes()
     * @param string $cpf
     * @param int $identificUnica
     * @param \ArrayType\ArrayOfCursos $listaCurso
     * @param \ArrayType\ArrayOfExperienciaProfissional $listaExperienciaProfissional
     * @param \ArrayType\ArrayOfFormacaoAcademica $listaFormacaoAcademica
     * @param \ArrayType\ArrayOfIdiomas $listaIdiomas
     * @param \ArrayType\ArrayOfParticipacaoComissoes $listaParticipacaoComissoes
     */
    public function __construct($cpf = null, $identificUnica = null, \ArrayType\ArrayOfCursos $listaCurso = null, \ArrayType\ArrayOfExperienciaProfissional $listaExperienciaProfissional = null, \ArrayType\ArrayOfFormacaoAcademica $listaFormacaoAcademica = null, \ArrayType\ArrayOfIdiomas $listaIdiomas = null, \ArrayType\ArrayOfParticipacaoComissoes $listaParticipacaoComissoes = null)
    {
        $this
            ->setCpf($cpf)
            ->setIdentificUnica($identificUnica)
            ->setListaCurso($listaCurso)
            ->setListaExperienciaProfissional($listaExperienciaProfissional)
            ->setListaFormacaoAcademica($listaFormacaoAcademica)
            ->setListaIdiomas($listaIdiomas)
            ->setListaParticipacaoComissoes($listaParticipacaoComissoes);
    }
    /**
     * Get cpf value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCpf()
    {
        return isset($this->cpf) ? $this->cpf : null;
    }
    /**
     * Set cpf value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cpf
     * @return \StructType\DadosCurriculo
     */
    public function setCpf($cpf = null)
    {
        // validation for constraint: string
        if (!is_null($cpf) && !is_string($cpf)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cpf, true), gettype($cpf)), __LINE__);
        }
        if (is_null($cpf) || (is_array($cpf) && empty($cpf))) {
            unset($this->cpf);
        } else {
            $this->cpf = $cpf;
        }
        return $this;
    }
    /**
     * Get identificUnica value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getIdentificUnica()
    {
        return isset($this->identificUnica) ? $this->identificUnica : null;
    }
    /**
     * Set identificUnica value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $identificUnica
     * @return \StructType\DadosCurriculo
     */
    public function setIdentificUnica($identificUnica = null)
    {
        // validation for constraint: int
        if (!is_null($identificUnica) && !(is_int($identificUnica) || ctype_digit($identificUnica))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($identificUnica, true), gettype($identificUnica)), __LINE__);
        }
        if (is_null($identificUnica) || (is_array($identificUnica) && empty($identificUnica))) {
            unset($this->identificUnica);
        } else {
            $this->identificUnica = $identificUnica;
        }
        return $this;
    }
    /**
     * Get listaCurso value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfCursos|null
     */
    public function getListaCurso()
    {
        return isset($this->listaCurso) ? $this->listaCurso : null;
    }
    /**
     * Set listaCurso value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfCursos $listaCurso
     * @return \StructType\DadosCurriculo
     */
    public function setListaCurso(\ArrayType\ArrayOfCursos $listaCurso = null)
    {
        if (is_null($listaCurso) || (is_array($listaCurso) && empty($listaCurso))) {
            unset($this->listaCurso);
        } else {
            $this->listaCurso = $listaCurso;
        }
        return $this;
    }
    /**
     * Get listaExperienciaProfissional value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfExperienciaProfissional|null
     */
    public function getListaExperienciaProfissional()
    {
        return isset($this->listaExperienciaProfissional) ? $this->listaExperienciaProfissional : null;
    }
    /**
     * Set listaExperienciaProfissional value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfExperienciaProfissional $listaExperienciaProfissional
     * @return \StructType\DadosCurriculo
     */
    public function setListaExperienciaProfissional(\ArrayType\ArrayOfExperienciaProfissional $listaExperienciaProfissional = null)
    {
        if (is_null($listaExperienciaProfissional) || (is_array($listaExperienciaProfissional) && empty($listaExperienciaProfissional))) {
            unset($this->listaExperienciaProfissional);
        } else {
            $this->listaExperienciaProfissional = $listaExperienciaProfissional;
        }
        return $this;
    }
    /**
     * Get listaFormacaoAcademica value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfFormacaoAcademica|null
     */
    public function getListaFormacaoAcademica()
    {
        return isset($this->listaFormacaoAcademica) ? $this->listaFormacaoAcademica : null;
    }
    /**
     * Set listaFormacaoAcademica value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfFormacaoAcademica $listaFormacaoAcademica
     * @return \StructType\DadosCurriculo
     */
    public function setListaFormacaoAcademica(\ArrayType\ArrayOfFormacaoAcademica $listaFormacaoAcademica = null)
    {
        if (is_null($listaFormacaoAcademica) || (is_array($listaFormacaoAcademica) && empty($listaFormacaoAcademica))) {
            unset($this->listaFormacaoAcademica);
        } else {
            $this->listaFormacaoAcademica = $listaFormacaoAcademica;
        }
        return $this;
    }
    /**
     * Get listaIdiomas value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfIdiomas|null
     */
    public function getListaIdiomas()
    {
        return isset($this->listaIdiomas) ? $this->listaIdiomas : null;
    }
    /**
     * Set listaIdiomas value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfIdiomas $listaIdiomas
     * @return \StructType\DadosCurriculo
     */
    public function setListaIdiomas(\ArrayType\ArrayOfIdiomas $listaIdiomas = null)
    {
        if (is_null($listaIdiomas) || (is_array($listaIdiomas) && empty($listaIdiomas))) {
            unset($this->listaIdiomas);
        } else {
            $this->listaIdiomas = $listaIdiomas;
        }
        return $this;
    }
    /**
     * Get listaParticipacaoComissoes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfParticipacaoComissoes|null
     */
    public function getListaParticipacaoComissoes()
    {
        return isset($this->listaParticipacaoComissoes) ? $this->listaParticipacaoComissoes : null;
    }
    /**
     * Set listaParticipacaoComissoes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfParticipacaoComissoes $listaParticipacaoComissoes
     * @return \StructType\DadosCurriculo
     */
    public function setListaParticipacaoComissoes(\ArrayType\ArrayOfParticipacaoComissoes $listaParticipacaoComissoes = null)
    {
        if (is_null($listaParticipacaoComissoes) || (is_array($listaParticipacaoComissoes) && empty($listaParticipacaoComissoes))) {
            unset($this->listaParticipacaoComissoes);
        } else {
            $this->listaParticipacaoComissoes = $listaParticipacaoComissoes;
        }
        return $this;
    }
}
