<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DadosDependentes StructType
 * @subpackage Structs
 */
class DadosDependentes extends AbstractStructBase
{
    /**
     * The arrayBeneficios
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfBeneficio
     */
    public $arrayBeneficios;
    /**
     * The codCondicao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $codCondicao;
    /**
     * The codGrauParentesco
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $codGrauParentesco;
    /**
     * The codOrgao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $codOrgao;
    /**
     * The cpf
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cpf;
    /**
     * The matricula
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $matricula;
    /**
     * The nome
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nome;
    /**
     * The nomeCondicao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nomeCondicao;
    /**
     * The nomeGrauParentesco
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nomeGrauParentesco;
    /**
     * Constructor method for DadosDependentes
     * @uses DadosDependentes::setArrayBeneficios()
     * @uses DadosDependentes::setCodCondicao()
     * @uses DadosDependentes::setCodGrauParentesco()
     * @uses DadosDependentes::setCodOrgao()
     * @uses DadosDependentes::setCpf()
     * @uses DadosDependentes::setMatricula()
     * @uses DadosDependentes::setNome()
     * @uses DadosDependentes::setNomeCondicao()
     * @uses DadosDependentes::setNomeGrauParentesco()
     * @param \ArrayType\ArrayOfBeneficio $arrayBeneficios
     * @param string $codCondicao
     * @param string $codGrauParentesco
     * @param string $codOrgao
     * @param string $cpf
     * @param string $matricula
     * @param string $nome
     * @param string $nomeCondicao
     * @param string $nomeGrauParentesco
     */
    public function __construct(\ArrayType\ArrayOfBeneficio $arrayBeneficios = null, $codCondicao = null, $codGrauParentesco = null, $codOrgao = null, $cpf = null, $matricula = null, $nome = null, $nomeCondicao = null, $nomeGrauParentesco = null)
    {
        $this
            ->setArrayBeneficios($arrayBeneficios)
            ->setCodCondicao($codCondicao)
            ->setCodGrauParentesco($codGrauParentesco)
            ->setCodOrgao($codOrgao)
            ->setCpf($cpf)
            ->setMatricula($matricula)
            ->setNome($nome)
            ->setNomeCondicao($nomeCondicao)
            ->setNomeGrauParentesco($nomeGrauParentesco);
    }
    /**
     * Get arrayBeneficios value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfBeneficio|null
     */
    public function getArrayBeneficios()
    {
        return isset($this->arrayBeneficios) ? $this->arrayBeneficios : null;
    }
    /**
     * Set arrayBeneficios value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfBeneficio $arrayBeneficios
     * @return \StructType\DadosDependentes
     */
    public function setArrayBeneficios(\ArrayType\ArrayOfBeneficio $arrayBeneficios = null)
    {
        if (is_null($arrayBeneficios) || (is_array($arrayBeneficios) && empty($arrayBeneficios))) {
            unset($this->arrayBeneficios);
        } else {
            $this->arrayBeneficios = $arrayBeneficios;
        }
        return $this;
    }
    /**
     * Get codCondicao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodCondicao()
    {
        return isset($this->codCondicao) ? $this->codCondicao : null;
    }
    /**
     * Set codCondicao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codCondicao
     * @return \StructType\DadosDependentes
     */
    public function setCodCondicao($codCondicao = null)
    {
        // validation for constraint: string
        if (!is_null($codCondicao) && !is_string($codCondicao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codCondicao, true), gettype($codCondicao)), __LINE__);
        }
        if (is_null($codCondicao) || (is_array($codCondicao) && empty($codCondicao))) {
            unset($this->codCondicao);
        } else {
            $this->codCondicao = $codCondicao;
        }
        return $this;
    }
    /**
     * Get codGrauParentesco value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodGrauParentesco()
    {
        return isset($this->codGrauParentesco) ? $this->codGrauParentesco : null;
    }
    /**
     * Set codGrauParentesco value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codGrauParentesco
     * @return \StructType\DadosDependentes
     */
    public function setCodGrauParentesco($codGrauParentesco = null)
    {
        // validation for constraint: string
        if (!is_null($codGrauParentesco) && !is_string($codGrauParentesco)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codGrauParentesco, true), gettype($codGrauParentesco)), __LINE__);
        }
        if (is_null($codGrauParentesco) || (is_array($codGrauParentesco) && empty($codGrauParentesco))) {
            unset($this->codGrauParentesco);
        } else {
            $this->codGrauParentesco = $codGrauParentesco;
        }
        return $this;
    }
    /**
     * Get codOrgao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodOrgao()
    {
        return isset($this->codOrgao) ? $this->codOrgao : null;
    }
    /**
     * Set codOrgao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codOrgao
     * @return \StructType\DadosDependentes
     */
    public function setCodOrgao($codOrgao = null)
    {
        // validation for constraint: string
        if (!is_null($codOrgao) && !is_string($codOrgao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codOrgao, true), gettype($codOrgao)), __LINE__);
        }
        if (is_null($codOrgao) || (is_array($codOrgao) && empty($codOrgao))) {
            unset($this->codOrgao);
        } else {
            $this->codOrgao = $codOrgao;
        }
        return $this;
    }
    /**
     * Get cpf value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCpf()
    {
        return isset($this->cpf) ? $this->cpf : null;
    }
    /**
     * Set cpf value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cpf
     * @return \StructType\DadosDependentes
     */
    public function setCpf($cpf = null)
    {
        // validation for constraint: string
        if (!is_null($cpf) && !is_string($cpf)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cpf, true), gettype($cpf)), __LINE__);
        }
        if (is_null($cpf) || (is_array($cpf) && empty($cpf))) {
            unset($this->cpf);
        } else {
            $this->cpf = $cpf;
        }
        return $this;
    }
    /**
     * Get matricula value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMatricula()
    {
        return isset($this->matricula) ? $this->matricula : null;
    }
    /**
     * Set matricula value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $matricula
     * @return \StructType\DadosDependentes
     */
    public function setMatricula($matricula = null)
    {
        // validation for constraint: string
        if (!is_null($matricula) && !is_string($matricula)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($matricula, true), gettype($matricula)), __LINE__);
        }
        if (is_null($matricula) || (is_array($matricula) && empty($matricula))) {
            unset($this->matricula);
        } else {
            $this->matricula = $matricula;
        }
        return $this;
    }
    /**
     * Get nome value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNome()
    {
        return isset($this->nome) ? $this->nome : null;
    }
    /**
     * Set nome value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nome
     * @return \StructType\DadosDependentes
     */
    public function setNome($nome = null)
    {
        // validation for constraint: string
        if (!is_null($nome) && !is_string($nome)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nome, true), gettype($nome)), __LINE__);
        }
        if (is_null($nome) || (is_array($nome) && empty($nome))) {
            unset($this->nome);
        } else {
            $this->nome = $nome;
        }
        return $this;
    }
    /**
     * Get nomeCondicao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNomeCondicao()
    {
        return isset($this->nomeCondicao) ? $this->nomeCondicao : null;
    }
    /**
     * Set nomeCondicao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nomeCondicao
     * @return \StructType\DadosDependentes
     */
    public function setNomeCondicao($nomeCondicao = null)
    {
        // validation for constraint: string
        if (!is_null($nomeCondicao) && !is_string($nomeCondicao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nomeCondicao, true), gettype($nomeCondicao)), __LINE__);
        }
        if (is_null($nomeCondicao) || (is_array($nomeCondicao) && empty($nomeCondicao))) {
            unset($this->nomeCondicao);
        } else {
            $this->nomeCondicao = $nomeCondicao;
        }
        return $this;
    }
    /**
     * Get nomeGrauParentesco value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNomeGrauParentesco()
    {
        return isset($this->nomeGrauParentesco) ? $this->nomeGrauParentesco : null;
    }
    /**
     * Set nomeGrauParentesco value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nomeGrauParentesco
     * @return \StructType\DadosDependentes
     */
    public function setNomeGrauParentesco($nomeGrauParentesco = null)
    {
        // validation for constraint: string
        if (!is_null($nomeGrauParentesco) && !is_string($nomeGrauParentesco)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nomeGrauParentesco, true), gettype($nomeGrauParentesco)), __LINE__);
        }
        if (is_null($nomeGrauParentesco) || (is_array($nomeGrauParentesco) && empty($nomeGrauParentesco))) {
            unset($this->nomeGrauParentesco);
        } else {
            $this->nomeGrauParentesco = $nomeGrauParentesco;
        }
        return $this;
    }
}
