<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DadosEscolares StructType
 * @subpackage Structs
 */
class DadosEscolares extends AbstractStructBase
{
    /**
     * The arrayCursos
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfDadosCurso
     */
    public $arrayCursos;
    /**
     * The arrayTitulacao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfDadosTitulacao
     */
    public $arrayTitulacao;
    /**
     * The codEscolaridade
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $codEscolaridade;
    /**
     * The nomeEscolaridade
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nomeEscolaridade;
    /**
     * Constructor method for DadosEscolares
     * @uses DadosEscolares::setArrayCursos()
     * @uses DadosEscolares::setArrayTitulacao()
     * @uses DadosEscolares::setCodEscolaridade()
     * @uses DadosEscolares::setNomeEscolaridade()
     * @param \ArrayType\ArrayOfDadosCurso $arrayCursos
     * @param \ArrayType\ArrayOfDadosTitulacao $arrayTitulacao
     * @param string $codEscolaridade
     * @param string $nomeEscolaridade
     */
    public function __construct(\ArrayType\ArrayOfDadosCurso $arrayCursos = null, \ArrayType\ArrayOfDadosTitulacao $arrayTitulacao = null, $codEscolaridade = null, $nomeEscolaridade = null)
    {
        $this
            ->setArrayCursos($arrayCursos)
            ->setArrayTitulacao($arrayTitulacao)
            ->setCodEscolaridade($codEscolaridade)
            ->setNomeEscolaridade($nomeEscolaridade);
    }
    /**
     * Get arrayCursos value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfDadosCurso|null
     */
    public function getArrayCursos()
    {
        return isset($this->arrayCursos) ? $this->arrayCursos : null;
    }
    /**
     * Set arrayCursos value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfDadosCurso $arrayCursos
     * @return \StructType\DadosEscolares
     */
    public function setArrayCursos(\ArrayType\ArrayOfDadosCurso $arrayCursos = null)
    {
        if (is_null($arrayCursos) || (is_array($arrayCursos) && empty($arrayCursos))) {
            unset($this->arrayCursos);
        } else {
            $this->arrayCursos = $arrayCursos;
        }
        return $this;
    }
    /**
     * Get arrayTitulacao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfDadosTitulacao|null
     */
    public function getArrayTitulacao()
    {
        return isset($this->arrayTitulacao) ? $this->arrayTitulacao : null;
    }
    /**
     * Set arrayTitulacao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfDadosTitulacao $arrayTitulacao
     * @return \StructType\DadosEscolares
     */
    public function setArrayTitulacao(\ArrayType\ArrayOfDadosTitulacao $arrayTitulacao = null)
    {
        if (is_null($arrayTitulacao) || (is_array($arrayTitulacao) && empty($arrayTitulacao))) {
            unset($this->arrayTitulacao);
        } else {
            $this->arrayTitulacao = $arrayTitulacao;
        }
        return $this;
    }
    /**
     * Get codEscolaridade value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodEscolaridade()
    {
        return isset($this->codEscolaridade) ? $this->codEscolaridade : null;
    }
    /**
     * Set codEscolaridade value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codEscolaridade
     * @return \StructType\DadosEscolares
     */
    public function setCodEscolaridade($codEscolaridade = null)
    {
        // validation for constraint: string
        if (!is_null($codEscolaridade) && !is_string($codEscolaridade)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codEscolaridade, true), gettype($codEscolaridade)), __LINE__);
        }
        if (is_null($codEscolaridade) || (is_array($codEscolaridade) && empty($codEscolaridade))) {
            unset($this->codEscolaridade);
        } else {
            $this->codEscolaridade = $codEscolaridade;
        }
        return $this;
    }
    /**
     * Get nomeEscolaridade value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNomeEscolaridade()
    {
        return isset($this->nomeEscolaridade) ? $this->nomeEscolaridade : null;
    }
    /**
     * Set nomeEscolaridade value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nomeEscolaridade
     * @return \StructType\DadosEscolares
     */
    public function setNomeEscolaridade($nomeEscolaridade = null)
    {
        // validation for constraint: string
        if (!is_null($nomeEscolaridade) && !is_string($nomeEscolaridade)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nomeEscolaridade, true), gettype($nomeEscolaridade)), __LINE__);
        }
        if (is_null($nomeEscolaridade) || (is_array($nomeEscolaridade) && empty($nomeEscolaridade))) {
            unset($this->nomeEscolaridade);
        } else {
            $this->nomeEscolaridade = $nomeEscolaridade;
        }
        return $this;
    }
}
