<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DadosFinanceiros StructType
 * @subpackage Structs
 */
class DadosFinanceiros extends AbstractStructBase
{
    /**
     * The codRubrica
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $codRubrica;
    /**
     * The dataAnoMesRubrica
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dataAnoMesRubrica;
    /**
     * The indicadorMovSupl
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $indicadorMovSupl;
    /**
     * The indicadorRD
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $indicadorRD;
    /**
     * The nomeRubrica
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nomeRubrica;
    /**
     * The numeroSeq
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $numeroSeq;
    /**
     * The peRubrica
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $peRubrica;
    /**
     * The pzRubrica
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $pzRubrica;
    /**
     * The valorRubrica
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $valorRubrica;
    /**
     * Constructor method for DadosFinanceiros
     * @uses DadosFinanceiros::setCodRubrica()
     * @uses DadosFinanceiros::setDataAnoMesRubrica()
     * @uses DadosFinanceiros::setIndicadorMovSupl()
     * @uses DadosFinanceiros::setIndicadorRD()
     * @uses DadosFinanceiros::setNomeRubrica()
     * @uses DadosFinanceiros::setNumeroSeq()
     * @uses DadosFinanceiros::setPeRubrica()
     * @uses DadosFinanceiros::setPzRubrica()
     * @uses DadosFinanceiros::setValorRubrica()
     * @param string $codRubrica
     * @param string $dataAnoMesRubrica
     * @param string $indicadorMovSupl
     * @param string $indicadorRD
     * @param string $nomeRubrica
     * @param string $numeroSeq
     * @param string $peRubrica
     * @param string $pzRubrica
     * @param string $valorRubrica
     */
    public function __construct($codRubrica = null, $dataAnoMesRubrica = null, $indicadorMovSupl = null, $indicadorRD = null, $nomeRubrica = null, $numeroSeq = null, $peRubrica = null, $pzRubrica = null, $valorRubrica = null)
    {
        $this
            ->setCodRubrica($codRubrica)
            ->setDataAnoMesRubrica($dataAnoMesRubrica)
            ->setIndicadorMovSupl($indicadorMovSupl)
            ->setIndicadorRD($indicadorRD)
            ->setNomeRubrica($nomeRubrica)
            ->setNumeroSeq($numeroSeq)
            ->setPeRubrica($peRubrica)
            ->setPzRubrica($pzRubrica)
            ->setValorRubrica($valorRubrica);
    }
    /**
     * Get codRubrica value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodRubrica()
    {
        return isset($this->codRubrica) ? $this->codRubrica : null;
    }
    /**
     * Set codRubrica value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codRubrica
     * @return \StructType\DadosFinanceiros
     */
    public function setCodRubrica($codRubrica = null)
    {
        // validation for constraint: string
        if (!is_null($codRubrica) && !is_string($codRubrica)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codRubrica, true), gettype($codRubrica)), __LINE__);
        }
        if (is_null($codRubrica) || (is_array($codRubrica) && empty($codRubrica))) {
            unset($this->codRubrica);
        } else {
            $this->codRubrica = $codRubrica;
        }
        return $this;
    }
    /**
     * Get dataAnoMesRubrica value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataAnoMesRubrica()
    {
        return isset($this->dataAnoMesRubrica) ? $this->dataAnoMesRubrica : null;
    }
    /**
     * Set dataAnoMesRubrica value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataAnoMesRubrica
     * @return \StructType\DadosFinanceiros
     */
    public function setDataAnoMesRubrica($dataAnoMesRubrica = null)
    {
        // validation for constraint: string
        if (!is_null($dataAnoMesRubrica) && !is_string($dataAnoMesRubrica)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataAnoMesRubrica, true), gettype($dataAnoMesRubrica)), __LINE__);
        }
        if (is_null($dataAnoMesRubrica) || (is_array($dataAnoMesRubrica) && empty($dataAnoMesRubrica))) {
            unset($this->dataAnoMesRubrica);
        } else {
            $this->dataAnoMesRubrica = $dataAnoMesRubrica;
        }
        return $this;
    }
    /**
     * Get indicadorMovSupl value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIndicadorMovSupl()
    {
        return isset($this->indicadorMovSupl) ? $this->indicadorMovSupl : null;
    }
    /**
     * Set indicadorMovSupl value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $indicadorMovSupl
     * @return \StructType\DadosFinanceiros
     */
    public function setIndicadorMovSupl($indicadorMovSupl = null)
    {
        // validation for constraint: string
        if (!is_null($indicadorMovSupl) && !is_string($indicadorMovSupl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($indicadorMovSupl, true), gettype($indicadorMovSupl)), __LINE__);
        }
        if (is_null($indicadorMovSupl) || (is_array($indicadorMovSupl) && empty($indicadorMovSupl))) {
            unset($this->indicadorMovSupl);
        } else {
            $this->indicadorMovSupl = $indicadorMovSupl;
        }
        return $this;
    }
    /**
     * Get indicadorRD value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIndicadorRD()
    {
        return isset($this->indicadorRD) ? $this->indicadorRD : null;
    }
    /**
     * Set indicadorRD value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $indicadorRD
     * @return \StructType\DadosFinanceiros
     */
    public function setIndicadorRD($indicadorRD = null)
    {
        // validation for constraint: string
        if (!is_null($indicadorRD) && !is_string($indicadorRD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($indicadorRD, true), gettype($indicadorRD)), __LINE__);
        }
        if (is_null($indicadorRD) || (is_array($indicadorRD) && empty($indicadorRD))) {
            unset($this->indicadorRD);
        } else {
            $this->indicadorRD = $indicadorRD;
        }
        return $this;
    }
    /**
     * Get nomeRubrica value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNomeRubrica()
    {
        return isset($this->nomeRubrica) ? $this->nomeRubrica : null;
    }
    /**
     * Set nomeRubrica value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nomeRubrica
     * @return \StructType\DadosFinanceiros
     */
    public function setNomeRubrica($nomeRubrica = null)
    {
        // validation for constraint: string
        if (!is_null($nomeRubrica) && !is_string($nomeRubrica)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nomeRubrica, true), gettype($nomeRubrica)), __LINE__);
        }
        if (is_null($nomeRubrica) || (is_array($nomeRubrica) && empty($nomeRubrica))) {
            unset($this->nomeRubrica);
        } else {
            $this->nomeRubrica = $nomeRubrica;
        }
        return $this;
    }
    /**
     * Get numeroSeq value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNumeroSeq()
    {
        return isset($this->numeroSeq) ? $this->numeroSeq : null;
    }
    /**
     * Set numeroSeq value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $numeroSeq
     * @return \StructType\DadosFinanceiros
     */
    public function setNumeroSeq($numeroSeq = null)
    {
        // validation for constraint: string
        if (!is_null($numeroSeq) && !is_string($numeroSeq)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($numeroSeq, true), gettype($numeroSeq)), __LINE__);
        }
        if (is_null($numeroSeq) || (is_array($numeroSeq) && empty($numeroSeq))) {
            unset($this->numeroSeq);
        } else {
            $this->numeroSeq = $numeroSeq;
        }
        return $this;
    }
    /**
     * Get peRubrica value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPeRubrica()
    {
        return isset($this->peRubrica) ? $this->peRubrica : null;
    }
    /**
     * Set peRubrica value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $peRubrica
     * @return \StructType\DadosFinanceiros
     */
    public function setPeRubrica($peRubrica = null)
    {
        // validation for constraint: string
        if (!is_null($peRubrica) && !is_string($peRubrica)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($peRubrica, true), gettype($peRubrica)), __LINE__);
        }
        if (is_null($peRubrica) || (is_array($peRubrica) && empty($peRubrica))) {
            unset($this->peRubrica);
        } else {
            $this->peRubrica = $peRubrica;
        }
        return $this;
    }
    /**
     * Get pzRubrica value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPzRubrica()
    {
        return isset($this->pzRubrica) ? $this->pzRubrica : null;
    }
    /**
     * Set pzRubrica value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $pzRubrica
     * @return \StructType\DadosFinanceiros
     */
    public function setPzRubrica($pzRubrica = null)
    {
        // validation for constraint: string
        if (!is_null($pzRubrica) && !is_string($pzRubrica)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pzRubrica, true), gettype($pzRubrica)), __LINE__);
        }
        if (is_null($pzRubrica) || (is_array($pzRubrica) && empty($pzRubrica))) {
            unset($this->pzRubrica);
        } else {
            $this->pzRubrica = $pzRubrica;
        }
        return $this;
    }
    /**
     * Get valorRubrica value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getValorRubrica()
    {
        return isset($this->valorRubrica) ? $this->valorRubrica : null;
    }
    /**
     * Set valorRubrica value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $valorRubrica
     * @return \StructType\DadosFinanceiros
     */
    public function setValorRubrica($valorRubrica = null)
    {
        // validation for constraint: string
        if (!is_null($valorRubrica) && !is_string($valorRubrica)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($valorRubrica, true), gettype($valorRubrica)), __LINE__);
        }
        if (is_null($valorRubrica) || (is_array($valorRubrica) && empty($valorRubrica))) {
            unset($this->valorRubrica);
        } else {
            $this->valorRubrica = $valorRubrica;
        }
        return $this;
    }
}
