<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DadosPA StructType
 * @subpackage Structs
 */
class DadosPA extends AbstractStructBase
{
    /**
     * The agenciaBeneficiario
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $agenciaBeneficiario;
    /**
     * The arrayAlimentadosPA
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfAlimentadosPA
     */
    public $arrayAlimentadosPA;
    /**
     * The bancoBeneficiario
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $bancoBeneficiario;
    /**
     * The codOrgao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $codOrgao;
    /**
     * The contaBeneficiario
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $contaBeneficiario;
    /**
     * The cpfBeneficiario
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cpfBeneficiario;
    /**
     * The matricula
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $matricula;
    /**
     * The nomeBeneficiario
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nomeBeneficiario;
    /**
     * The valorUltimaPensao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $valorUltimaPensao;
    /**
     * Constructor method for DadosPA
     * @uses DadosPA::setAgenciaBeneficiario()
     * @uses DadosPA::setArrayAlimentadosPA()
     * @uses DadosPA::setBancoBeneficiario()
     * @uses DadosPA::setCodOrgao()
     * @uses DadosPA::setContaBeneficiario()
     * @uses DadosPA::setCpfBeneficiario()
     * @uses DadosPA::setMatricula()
     * @uses DadosPA::setNomeBeneficiario()
     * @uses DadosPA::setValorUltimaPensao()
     * @param string $agenciaBeneficiario
     * @param \ArrayType\ArrayOfAlimentadosPA $arrayAlimentadosPA
     * @param string $bancoBeneficiario
     * @param string $codOrgao
     * @param string $contaBeneficiario
     * @param string $cpfBeneficiario
     * @param string $matricula
     * @param string $nomeBeneficiario
     * @param string $valorUltimaPensao
     */
    public function __construct($agenciaBeneficiario = null, \ArrayType\ArrayOfAlimentadosPA $arrayAlimentadosPA = null, $bancoBeneficiario = null, $codOrgao = null, $contaBeneficiario = null, $cpfBeneficiario = null, $matricula = null, $nomeBeneficiario = null, $valorUltimaPensao = null)
    {
        $this
            ->setAgenciaBeneficiario($agenciaBeneficiario)
            ->setArrayAlimentadosPA($arrayAlimentadosPA)
            ->setBancoBeneficiario($bancoBeneficiario)
            ->setCodOrgao($codOrgao)
            ->setContaBeneficiario($contaBeneficiario)
            ->setCpfBeneficiario($cpfBeneficiario)
            ->setMatricula($matricula)
            ->setNomeBeneficiario($nomeBeneficiario)
            ->setValorUltimaPensao($valorUltimaPensao);
    }
    /**
     * Get agenciaBeneficiario value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAgenciaBeneficiario()
    {
        return isset($this->agenciaBeneficiario) ? $this->agenciaBeneficiario : null;
    }
    /**
     * Set agenciaBeneficiario value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $agenciaBeneficiario
     * @return \StructType\DadosPA
     */
    public function setAgenciaBeneficiario($agenciaBeneficiario = null)
    {
        // validation for constraint: string
        if (!is_null($agenciaBeneficiario) && !is_string($agenciaBeneficiario)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($agenciaBeneficiario, true), gettype($agenciaBeneficiario)), __LINE__);
        }
        if (is_null($agenciaBeneficiario) || (is_array($agenciaBeneficiario) && empty($agenciaBeneficiario))) {
            unset($this->agenciaBeneficiario);
        } else {
            $this->agenciaBeneficiario = $agenciaBeneficiario;
        }
        return $this;
    }
    /**
     * Get arrayAlimentadosPA value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfAlimentadosPA|null
     */
    public function getArrayAlimentadosPA()
    {
        return isset($this->arrayAlimentadosPA) ? $this->arrayAlimentadosPA : null;
    }
    /**
     * Set arrayAlimentadosPA value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfAlimentadosPA $arrayAlimentadosPA
     * @return \StructType\DadosPA
     */
    public function setArrayAlimentadosPA(\ArrayType\ArrayOfAlimentadosPA $arrayAlimentadosPA = null)
    {
        if (is_null($arrayAlimentadosPA) || (is_array($arrayAlimentadosPA) && empty($arrayAlimentadosPA))) {
            unset($this->arrayAlimentadosPA);
        } else {
            $this->arrayAlimentadosPA = $arrayAlimentadosPA;
        }
        return $this;
    }
    /**
     * Get bancoBeneficiario value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBancoBeneficiario()
    {
        return isset($this->bancoBeneficiario) ? $this->bancoBeneficiario : null;
    }
    /**
     * Set bancoBeneficiario value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $bancoBeneficiario
     * @return \StructType\DadosPA
     */
    public function setBancoBeneficiario($bancoBeneficiario = null)
    {
        // validation for constraint: string
        if (!is_null($bancoBeneficiario) && !is_string($bancoBeneficiario)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bancoBeneficiario, true), gettype($bancoBeneficiario)), __LINE__);
        }
        if (is_null($bancoBeneficiario) || (is_array($bancoBeneficiario) && empty($bancoBeneficiario))) {
            unset($this->bancoBeneficiario);
        } else {
            $this->bancoBeneficiario = $bancoBeneficiario;
        }
        return $this;
    }
    /**
     * Get codOrgao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodOrgao()
    {
        return isset($this->codOrgao) ? $this->codOrgao : null;
    }
    /**
     * Set codOrgao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codOrgao
     * @return \StructType\DadosPA
     */
    public function setCodOrgao($codOrgao = null)
    {
        // validation for constraint: string
        if (!is_null($codOrgao) && !is_string($codOrgao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codOrgao, true), gettype($codOrgao)), __LINE__);
        }
        if (is_null($codOrgao) || (is_array($codOrgao) && empty($codOrgao))) {
            unset($this->codOrgao);
        } else {
            $this->codOrgao = $codOrgao;
        }
        return $this;
    }
    /**
     * Get contaBeneficiario value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getContaBeneficiario()
    {
        return isset($this->contaBeneficiario) ? $this->contaBeneficiario : null;
    }
    /**
     * Set contaBeneficiario value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $contaBeneficiario
     * @return \StructType\DadosPA
     */
    public function setContaBeneficiario($contaBeneficiario = null)
    {
        // validation for constraint: string
        if (!is_null($contaBeneficiario) && !is_string($contaBeneficiario)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contaBeneficiario, true), gettype($contaBeneficiario)), __LINE__);
        }
        if (is_null($contaBeneficiario) || (is_array($contaBeneficiario) && empty($contaBeneficiario))) {
            unset($this->contaBeneficiario);
        } else {
            $this->contaBeneficiario = $contaBeneficiario;
        }
        return $this;
    }
    /**
     * Get cpfBeneficiario value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCpfBeneficiario()
    {
        return isset($this->cpfBeneficiario) ? $this->cpfBeneficiario : null;
    }
    /**
     * Set cpfBeneficiario value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cpfBeneficiario
     * @return \StructType\DadosPA
     */
    public function setCpfBeneficiario($cpfBeneficiario = null)
    {
        // validation for constraint: string
        if (!is_null($cpfBeneficiario) && !is_string($cpfBeneficiario)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cpfBeneficiario, true), gettype($cpfBeneficiario)), __LINE__);
        }
        if (is_null($cpfBeneficiario) || (is_array($cpfBeneficiario) && empty($cpfBeneficiario))) {
            unset($this->cpfBeneficiario);
        } else {
            $this->cpfBeneficiario = $cpfBeneficiario;
        }
        return $this;
    }
    /**
     * Get matricula value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMatricula()
    {
        return isset($this->matricula) ? $this->matricula : null;
    }
    /**
     * Set matricula value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $matricula
     * @return \StructType\DadosPA
     */
    public function setMatricula($matricula = null)
    {
        // validation for constraint: string
        if (!is_null($matricula) && !is_string($matricula)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($matricula, true), gettype($matricula)), __LINE__);
        }
        if (is_null($matricula) || (is_array($matricula) && empty($matricula))) {
            unset($this->matricula);
        } else {
            $this->matricula = $matricula;
        }
        return $this;
    }
    /**
     * Get nomeBeneficiario value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNomeBeneficiario()
    {
        return isset($this->nomeBeneficiario) ? $this->nomeBeneficiario : null;
    }
    /**
     * Set nomeBeneficiario value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nomeBeneficiario
     * @return \StructType\DadosPA
     */
    public function setNomeBeneficiario($nomeBeneficiario = null)
    {
        // validation for constraint: string
        if (!is_null($nomeBeneficiario) && !is_string($nomeBeneficiario)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nomeBeneficiario, true), gettype($nomeBeneficiario)), __LINE__);
        }
        if (is_null($nomeBeneficiario) || (is_array($nomeBeneficiario) && empty($nomeBeneficiario))) {
            unset($this->nomeBeneficiario);
        } else {
            $this->nomeBeneficiario = $nomeBeneficiario;
        }
        return $this;
    }
    /**
     * Get valorUltimaPensao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getValorUltimaPensao()
    {
        return isset($this->valorUltimaPensao) ? $this->valorUltimaPensao : null;
    }
    /**
     * Set valorUltimaPensao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $valorUltimaPensao
     * @return \StructType\DadosPA
     */
    public function setValorUltimaPensao($valorUltimaPensao = null)
    {
        // validation for constraint: string
        if (!is_null($valorUltimaPensao) && !is_string($valorUltimaPensao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($valorUltimaPensao, true), gettype($valorUltimaPensao)), __LINE__);
        }
        if (is_null($valorUltimaPensao) || (is_array($valorUltimaPensao) && empty($valorUltimaPensao))) {
            unset($this->valorUltimaPensao);
        } else {
            $this->valorUltimaPensao = $valorUltimaPensao;
        }
        return $this;
    }
}
