<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DadosRepresentanteLegal StructType
 * @subpackage Structs
 */
class DadosRepresentanteLegal extends AbstractStructBase
{
    /**
     * The agencia
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $agencia;
    /**
     * The banco
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $banco;
    /**
     * The codOrgao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $codOrgao;
    /**
     * The contaCorrente
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $contaCorrente;
    /**
     * The cpf
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cpf;
    /**
     * The matricula
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $matricula;
    /**
     * The nome
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nome;
    /**
     * Constructor method for DadosRepresentanteLegal
     * @uses DadosRepresentanteLegal::setAgencia()
     * @uses DadosRepresentanteLegal::setBanco()
     * @uses DadosRepresentanteLegal::setCodOrgao()
     * @uses DadosRepresentanteLegal::setContaCorrente()
     * @uses DadosRepresentanteLegal::setCpf()
     * @uses DadosRepresentanteLegal::setMatricula()
     * @uses DadosRepresentanteLegal::setNome()
     * @param string $agencia
     * @param string $banco
     * @param string $codOrgao
     * @param string $contaCorrente
     * @param string $cpf
     * @param string $matricula
     * @param string $nome
     */
    public function __construct($agencia = null, $banco = null, $codOrgao = null, $contaCorrente = null, $cpf = null, $matricula = null, $nome = null)
    {
        $this
            ->setAgencia($agencia)
            ->setBanco($banco)
            ->setCodOrgao($codOrgao)
            ->setContaCorrente($contaCorrente)
            ->setCpf($cpf)
            ->setMatricula($matricula)
            ->setNome($nome);
    }
    /**
     * Get agencia value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAgencia()
    {
        return isset($this->agencia) ? $this->agencia : null;
    }
    /**
     * Set agencia value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $agencia
     * @return \StructType\DadosRepresentanteLegal
     */
    public function setAgencia($agencia = null)
    {
        // validation for constraint: string
        if (!is_null($agencia) && !is_string($agencia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($agencia, true), gettype($agencia)), __LINE__);
        }
        if (is_null($agencia) || (is_array($agencia) && empty($agencia))) {
            unset($this->agencia);
        } else {
            $this->agencia = $agencia;
        }
        return $this;
    }
    /**
     * Get banco value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBanco()
    {
        return isset($this->banco) ? $this->banco : null;
    }
    /**
     * Set banco value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $banco
     * @return \StructType\DadosRepresentanteLegal
     */
    public function setBanco($banco = null)
    {
        // validation for constraint: string
        if (!is_null($banco) && !is_string($banco)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($banco, true), gettype($banco)), __LINE__);
        }
        if (is_null($banco) || (is_array($banco) && empty($banco))) {
            unset($this->banco);
        } else {
            $this->banco = $banco;
        }
        return $this;
    }
    /**
     * Get codOrgao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodOrgao()
    {
        return isset($this->codOrgao) ? $this->codOrgao : null;
    }
    /**
     * Set codOrgao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codOrgao
     * @return \StructType\DadosRepresentanteLegal
     */
    public function setCodOrgao($codOrgao = null)
    {
        // validation for constraint: string
        if (!is_null($codOrgao) && !is_string($codOrgao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codOrgao, true), gettype($codOrgao)), __LINE__);
        }
        if (is_null($codOrgao) || (is_array($codOrgao) && empty($codOrgao))) {
            unset($this->codOrgao);
        } else {
            $this->codOrgao = $codOrgao;
        }
        return $this;
    }
    /**
     * Get contaCorrente value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getContaCorrente()
    {
        return isset($this->contaCorrente) ? $this->contaCorrente : null;
    }
    /**
     * Set contaCorrente value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $contaCorrente
     * @return \StructType\DadosRepresentanteLegal
     */
    public function setContaCorrente($contaCorrente = null)
    {
        // validation for constraint: string
        if (!is_null($contaCorrente) && !is_string($contaCorrente)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contaCorrente, true), gettype($contaCorrente)), __LINE__);
        }
        if (is_null($contaCorrente) || (is_array($contaCorrente) && empty($contaCorrente))) {
            unset($this->contaCorrente);
        } else {
            $this->contaCorrente = $contaCorrente;
        }
        return $this;
    }
    /**
     * Get cpf value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCpf()
    {
        return isset($this->cpf) ? $this->cpf : null;
    }
    /**
     * Set cpf value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cpf
     * @return \StructType\DadosRepresentanteLegal
     */
    public function setCpf($cpf = null)
    {
        // validation for constraint: string
        if (!is_null($cpf) && !is_string($cpf)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cpf, true), gettype($cpf)), __LINE__);
        }
        if (is_null($cpf) || (is_array($cpf) && empty($cpf))) {
            unset($this->cpf);
        } else {
            $this->cpf = $cpf;
        }
        return $this;
    }
    /**
     * Get matricula value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMatricula()
    {
        return isset($this->matricula) ? $this->matricula : null;
    }
    /**
     * Set matricula value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $matricula
     * @return \StructType\DadosRepresentanteLegal
     */
    public function setMatricula($matricula = null)
    {
        // validation for constraint: string
        if (!is_null($matricula) && !is_string($matricula)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($matricula, true), gettype($matricula)), __LINE__);
        }
        if (is_null($matricula) || (is_array($matricula) && empty($matricula))) {
            unset($this->matricula);
        } else {
            $this->matricula = $matricula;
        }
        return $this;
    }
    /**
     * Get nome value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNome()
    {
        return isset($this->nome) ? $this->nome : null;
    }
    /**
     * Set nome value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nome
     * @return \StructType\DadosRepresentanteLegal
     */
    public function setNome($nome = null)
    {
        // validation for constraint: string
        if (!is_null($nome) && !is_string($nome)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nome, true), gettype($nome)), __LINE__);
        }
        if (is_null($nome) || (is_array($nome) && empty($nome))) {
            unset($this->nome);
        } else {
            $this->nome = $nome;
        }
        return $this;
    }
}
