<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DadosTitulacao StructType
 * @subpackage Structs
 */
class DadosTitulacao extends AbstractStructBase
{
    /**
     * The codMatricula
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $codMatricula;
    /**
     * The codOrgao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $codOrgao;
    /**
     * The codTitulacao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $codTitulacao;
    /**
     * The nomeTitulacao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nomeTitulacao;
    /**
     * Constructor method for DadosTitulacao
     * @uses DadosTitulacao::setCodMatricula()
     * @uses DadosTitulacao::setCodOrgao()
     * @uses DadosTitulacao::setCodTitulacao()
     * @uses DadosTitulacao::setNomeTitulacao()
     * @param string $codMatricula
     * @param string $codOrgao
     * @param string $codTitulacao
     * @param string $nomeTitulacao
     */
    public function __construct($codMatricula = null, $codOrgao = null, $codTitulacao = null, $nomeTitulacao = null)
    {
        $this
            ->setCodMatricula($codMatricula)
            ->setCodOrgao($codOrgao)
            ->setCodTitulacao($codTitulacao)
            ->setNomeTitulacao($nomeTitulacao);
    }
    /**
     * Get codMatricula value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodMatricula()
    {
        return isset($this->codMatricula) ? $this->codMatricula : null;
    }
    /**
     * Set codMatricula value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codMatricula
     * @return \StructType\DadosTitulacao
     */
    public function setCodMatricula($codMatricula = null)
    {
        // validation for constraint: string
        if (!is_null($codMatricula) && !is_string($codMatricula)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codMatricula, true), gettype($codMatricula)), __LINE__);
        }
        if (is_null($codMatricula) || (is_array($codMatricula) && empty($codMatricula))) {
            unset($this->codMatricula);
        } else {
            $this->codMatricula = $codMatricula;
        }
        return $this;
    }
    /**
     * Get codOrgao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodOrgao()
    {
        return isset($this->codOrgao) ? $this->codOrgao : null;
    }
    /**
     * Set codOrgao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codOrgao
     * @return \StructType\DadosTitulacao
     */
    public function setCodOrgao($codOrgao = null)
    {
        // validation for constraint: string
        if (!is_null($codOrgao) && !is_string($codOrgao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codOrgao, true), gettype($codOrgao)), __LINE__);
        }
        if (is_null($codOrgao) || (is_array($codOrgao) && empty($codOrgao))) {
            unset($this->codOrgao);
        } else {
            $this->codOrgao = $codOrgao;
        }
        return $this;
    }
    /**
     * Get codTitulacao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodTitulacao()
    {
        return isset($this->codTitulacao) ? $this->codTitulacao : null;
    }
    /**
     * Set codTitulacao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codTitulacao
     * @return \StructType\DadosTitulacao
     */
    public function setCodTitulacao($codTitulacao = null)
    {
        // validation for constraint: string
        if (!is_null($codTitulacao) && !is_string($codTitulacao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codTitulacao, true), gettype($codTitulacao)), __LINE__);
        }
        if (is_null($codTitulacao) || (is_array($codTitulacao) && empty($codTitulacao))) {
            unset($this->codTitulacao);
        } else {
            $this->codTitulacao = $codTitulacao;
        }
        return $this;
    }
    /**
     * Get nomeTitulacao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNomeTitulacao()
    {
        return isset($this->nomeTitulacao) ? $this->nomeTitulacao : null;
    }
    /**
     * Set nomeTitulacao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nomeTitulacao
     * @return \StructType\DadosTitulacao
     */
    public function setNomeTitulacao($nomeTitulacao = null)
    {
        // validation for constraint: string
        if (!is_null($nomeTitulacao) && !is_string($nomeTitulacao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nomeTitulacao, true), gettype($nomeTitulacao)), __LINE__);
        }
        if (is_null($nomeTitulacao) || (is_array($nomeTitulacao) && empty($nomeTitulacao))) {
            unset($this->nomeTitulacao);
        } else {
            $this->nomeTitulacao = $nomeTitulacao;
        }
        return $this;
    }
}
