<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ExperienciaProfissional StructType
 * @subpackage Structs
 */
class ExperienciaProfissional extends AbstractStructBase
{
    /**
     * The area
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Area
     */
    public $area;
    /**
     * The cargo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cargo;
    /**
     * The codigo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $codigo;
    /**
     * The dataFim
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dataFim;
    /**
     * The dataInicio
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dataInicio;
    /**
     * The identificUnica
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $identificUnica;
    /**
     * The nomeOrgaoEmpresa
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nomeOrgaoEmpresa;
    /**
     * The projeto
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $projeto;
    /**
     * The tipoAtuacao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipoAtuacao
     */
    public $tipoAtuacao;
    /**
     * Constructor method for ExperienciaProfissional
     * @uses ExperienciaProfissional::setArea()
     * @uses ExperienciaProfissional::setCargo()
     * @uses ExperienciaProfissional::setCodigo()
     * @uses ExperienciaProfissional::setDataFim()
     * @uses ExperienciaProfissional::setDataInicio()
     * @uses ExperienciaProfissional::setIdentificUnica()
     * @uses ExperienciaProfissional::setNomeOrgaoEmpresa()
     * @uses ExperienciaProfissional::setProjeto()
     * @uses ExperienciaProfissional::setTipoAtuacao()
     * @param \StructType\Area $area
     * @param string $cargo
     * @param int $codigo
     * @param string $dataFim
     * @param string $dataInicio
     * @param string $identificUnica
     * @param string $nomeOrgaoEmpresa
     * @param string $projeto
     * @param \StructType\TipoAtuacao $tipoAtuacao
     */
    public function __construct(\StructType\Area $area = null, $cargo = null, $codigo = null, $dataFim = null, $dataInicio = null, $identificUnica = null, $nomeOrgaoEmpresa = null, $projeto = null, \StructType\TipoAtuacao $tipoAtuacao = null)
    {
        $this
            ->setArea($area)
            ->setCargo($cargo)
            ->setCodigo($codigo)
            ->setDataFim($dataFim)
            ->setDataInicio($dataInicio)
            ->setIdentificUnica($identificUnica)
            ->setNomeOrgaoEmpresa($nomeOrgaoEmpresa)
            ->setProjeto($projeto)
            ->setTipoAtuacao($tipoAtuacao);
    }
    /**
     * Get area value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Area|null
     */
    public function getArea()
    {
        return isset($this->area) ? $this->area : null;
    }
    /**
     * Set area value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Area $area
     * @return \StructType\ExperienciaProfissional
     */
    public function setArea(\StructType\Area $area = null)
    {
        if (is_null($area) || (is_array($area) && empty($area))) {
            unset($this->area);
        } else {
            $this->area = $area;
        }
        return $this;
    }
    /**
     * Get cargo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCargo()
    {
        return isset($this->cargo) ? $this->cargo : null;
    }
    /**
     * Set cargo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cargo
     * @return \StructType\ExperienciaProfissional
     */
    public function setCargo($cargo = null)
    {
        // validation for constraint: string
        if (!is_null($cargo) && !is_string($cargo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cargo, true), gettype($cargo)), __LINE__);
        }
        if (is_null($cargo) || (is_array($cargo) && empty($cargo))) {
            unset($this->cargo);
        } else {
            $this->cargo = $cargo;
        }
        return $this;
    }
    /**
     * Get codigo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getCodigo()
    {
        return isset($this->codigo) ? $this->codigo : null;
    }
    /**
     * Set codigo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $codigo
     * @return \StructType\ExperienciaProfissional
     */
    public function setCodigo($codigo = null)
    {
        // validation for constraint: int
        if (!is_null($codigo) && !(is_int($codigo) || ctype_digit($codigo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($codigo, true), gettype($codigo)), __LINE__);
        }
        if (is_null($codigo) || (is_array($codigo) && empty($codigo))) {
            unset($this->codigo);
        } else {
            $this->codigo = $codigo;
        }
        return $this;
    }
    /**
     * Get dataFim value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataFim()
    {
        return isset($this->dataFim) ? $this->dataFim : null;
    }
    /**
     * Set dataFim value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataFim
     * @return \StructType\ExperienciaProfissional
     */
    public function setDataFim($dataFim = null)
    {
        // validation for constraint: string
        if (!is_null($dataFim) && !is_string($dataFim)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataFim, true), gettype($dataFim)), __LINE__);
        }
        if (is_null($dataFim) || (is_array($dataFim) && empty($dataFim))) {
            unset($this->dataFim);
        } else {
            $this->dataFim = $dataFim;
        }
        return $this;
    }
    /**
     * Get dataInicio value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataInicio()
    {
        return isset($this->dataInicio) ? $this->dataInicio : null;
    }
    /**
     * Set dataInicio value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataInicio
     * @return \StructType\ExperienciaProfissional
     */
    public function setDataInicio($dataInicio = null)
    {
        // validation for constraint: string
        if (!is_null($dataInicio) && !is_string($dataInicio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataInicio, true), gettype($dataInicio)), __LINE__);
        }
        if (is_null($dataInicio) || (is_array($dataInicio) && empty($dataInicio))) {
            unset($this->dataInicio);
        } else {
            $this->dataInicio = $dataInicio;
        }
        return $this;
    }
    /**
     * Get identificUnica value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdentificUnica()
    {
        return isset($this->identificUnica) ? $this->identificUnica : null;
    }
    /**
     * Set identificUnica value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $identificUnica
     * @return \StructType\ExperienciaProfissional
     */
    public function setIdentificUnica($identificUnica = null)
    {
        // validation for constraint: string
        if (!is_null($identificUnica) && !is_string($identificUnica)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificUnica, true), gettype($identificUnica)), __LINE__);
        }
        if (is_null($identificUnica) || (is_array($identificUnica) && empty($identificUnica))) {
            unset($this->identificUnica);
        } else {
            $this->identificUnica = $identificUnica;
        }
        return $this;
    }
    /**
     * Get nomeOrgaoEmpresa value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNomeOrgaoEmpresa()
    {
        return isset($this->nomeOrgaoEmpresa) ? $this->nomeOrgaoEmpresa : null;
    }
    /**
     * Set nomeOrgaoEmpresa value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nomeOrgaoEmpresa
     * @return \StructType\ExperienciaProfissional
     */
    public function setNomeOrgaoEmpresa($nomeOrgaoEmpresa = null)
    {
        // validation for constraint: string
        if (!is_null($nomeOrgaoEmpresa) && !is_string($nomeOrgaoEmpresa)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nomeOrgaoEmpresa, true), gettype($nomeOrgaoEmpresa)), __LINE__);
        }
        if (is_null($nomeOrgaoEmpresa) || (is_array($nomeOrgaoEmpresa) && empty($nomeOrgaoEmpresa))) {
            unset($this->nomeOrgaoEmpresa);
        } else {
            $this->nomeOrgaoEmpresa = $nomeOrgaoEmpresa;
        }
        return $this;
    }
    /**
     * Get projeto value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getProjeto()
    {
        return isset($this->projeto) ? $this->projeto : null;
    }
    /**
     * Set projeto value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $projeto
     * @return \StructType\ExperienciaProfissional
     */
    public function setProjeto($projeto = null)
    {
        // validation for constraint: string
        if (!is_null($projeto) && !is_string($projeto)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($projeto, true), gettype($projeto)), __LINE__);
        }
        if (is_null($projeto) || (is_array($projeto) && empty($projeto))) {
            unset($this->projeto);
        } else {
            $this->projeto = $projeto;
        }
        return $this;
    }
    /**
     * Get tipoAtuacao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipoAtuacao|null
     */
    public function getTipoAtuacao()
    {
        return isset($this->tipoAtuacao) ? $this->tipoAtuacao : null;
    }
    /**
     * Set tipoAtuacao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\TipoAtuacao $tipoAtuacao
     * @return \StructType\ExperienciaProfissional
     */
    public function setTipoAtuacao(\StructType\TipoAtuacao $tipoAtuacao = null)
    {
        if (is_null($tipoAtuacao) || (is_array($tipoAtuacao) && empty($tipoAtuacao))) {
            unset($this->tipoAtuacao);
        } else {
            $this->tipoAtuacao = $tipoAtuacao;
        }
        return $this;
    }
}
