<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FormacaoAcademica StructType
 * @subpackage Structs
 */
class FormacaoAcademica extends AbstractStructBase
{
    /**
     * The codigo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $codigo;
    /**
     * The curso
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Curso
     */
    public $curso;
    /**
     * The dataConclusao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dataConclusao;
    /**
     * The identificUnica
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $identificUnica;
    /**
     * The instituicao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $instituicao;
    /**
     * The nivelEscolaridade
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\NivelEscolaridade
     */
    public $nivelEscolaridade;
    /**
     * The situacao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Situacao
     */
    public $situacao;
    /**
     * Constructor method for FormacaoAcademica
     * @uses FormacaoAcademica::setCodigo()
     * @uses FormacaoAcademica::setCurso()
     * @uses FormacaoAcademica::setDataConclusao()
     * @uses FormacaoAcademica::setIdentificUnica()
     * @uses FormacaoAcademica::setInstituicao()
     * @uses FormacaoAcademica::setNivelEscolaridade()
     * @uses FormacaoAcademica::setSituacao()
     * @param int $codigo
     * @param \StructType\Curso $curso
     * @param string $dataConclusao
     * @param string $identificUnica
     * @param string $instituicao
     * @param \StructType\NivelEscolaridade $nivelEscolaridade
     * @param \StructType\Situacao $situacao
     */
    public function __construct($codigo = null, \StructType\Curso $curso = null, $dataConclusao = null, $identificUnica = null, $instituicao = null, \StructType\NivelEscolaridade $nivelEscolaridade = null, \StructType\Situacao $situacao = null)
    {
        $this
            ->setCodigo($codigo)
            ->setCurso($curso)
            ->setDataConclusao($dataConclusao)
            ->setIdentificUnica($identificUnica)
            ->setInstituicao($instituicao)
            ->setNivelEscolaridade($nivelEscolaridade)
            ->setSituacao($situacao);
    }
    /**
     * Get codigo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getCodigo()
    {
        return isset($this->codigo) ? $this->codigo : null;
    }
    /**
     * Set codigo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $codigo
     * @return \StructType\FormacaoAcademica
     */
    public function setCodigo($codigo = null)
    {
        // validation for constraint: int
        if (!is_null($codigo) && !(is_int($codigo) || ctype_digit($codigo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($codigo, true), gettype($codigo)), __LINE__);
        }
        if (is_null($codigo) || (is_array($codigo) && empty($codigo))) {
            unset($this->codigo);
        } else {
            $this->codigo = $codigo;
        }
        return $this;
    }
    /**
     * Get curso value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Curso|null
     */
    public function getCurso()
    {
        return isset($this->curso) ? $this->curso : null;
    }
    /**
     * Set curso value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Curso $curso
     * @return \StructType\FormacaoAcademica
     */
    public function setCurso(\StructType\Curso $curso = null)
    {
        if (is_null($curso) || (is_array($curso) && empty($curso))) {
            unset($this->curso);
        } else {
            $this->curso = $curso;
        }
        return $this;
    }
    /**
     * Get dataConclusao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataConclusao()
    {
        return isset($this->dataConclusao) ? $this->dataConclusao : null;
    }
    /**
     * Set dataConclusao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataConclusao
     * @return \StructType\FormacaoAcademica
     */
    public function setDataConclusao($dataConclusao = null)
    {
        // validation for constraint: string
        if (!is_null($dataConclusao) && !is_string($dataConclusao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataConclusao, true), gettype($dataConclusao)), __LINE__);
        }
        if (is_null($dataConclusao) || (is_array($dataConclusao) && empty($dataConclusao))) {
            unset($this->dataConclusao);
        } else {
            $this->dataConclusao = $dataConclusao;
        }
        return $this;
    }
    /**
     * Get identificUnica value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdentificUnica()
    {
        return isset($this->identificUnica) ? $this->identificUnica : null;
    }
    /**
     * Set identificUnica value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $identificUnica
     * @return \StructType\FormacaoAcademica
     */
    public function setIdentificUnica($identificUnica = null)
    {
        // validation for constraint: string
        if (!is_null($identificUnica) && !is_string($identificUnica)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificUnica, true), gettype($identificUnica)), __LINE__);
        }
        if (is_null($identificUnica) || (is_array($identificUnica) && empty($identificUnica))) {
            unset($this->identificUnica);
        } else {
            $this->identificUnica = $identificUnica;
        }
        return $this;
    }
    /**
     * Get instituicao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInstituicao()
    {
        return isset($this->instituicao) ? $this->instituicao : null;
    }
    /**
     * Set instituicao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $instituicao
     * @return \StructType\FormacaoAcademica
     */
    public function setInstituicao($instituicao = null)
    {
        // validation for constraint: string
        if (!is_null($instituicao) && !is_string($instituicao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($instituicao, true), gettype($instituicao)), __LINE__);
        }
        if (is_null($instituicao) || (is_array($instituicao) && empty($instituicao))) {
            unset($this->instituicao);
        } else {
            $this->instituicao = $instituicao;
        }
        return $this;
    }
    /**
     * Get nivelEscolaridade value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\NivelEscolaridade|null
     */
    public function getNivelEscolaridade()
    {
        return isset($this->nivelEscolaridade) ? $this->nivelEscolaridade : null;
    }
    /**
     * Set nivelEscolaridade value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\NivelEscolaridade $nivelEscolaridade
     * @return \StructType\FormacaoAcademica
     */
    public function setNivelEscolaridade(\StructType\NivelEscolaridade $nivelEscolaridade = null)
    {
        if (is_null($nivelEscolaridade) || (is_array($nivelEscolaridade) && empty($nivelEscolaridade))) {
            unset($this->nivelEscolaridade);
        } else {
            $this->nivelEscolaridade = $nivelEscolaridade;
        }
        return $this;
    }
    /**
     * Get situacao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Situacao|null
     */
    public function getSituacao()
    {
        return isset($this->situacao) ? $this->situacao : null;
    }
    /**
     * Set situacao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Situacao $situacao
     * @return \StructType\FormacaoAcademica
     */
    public function setSituacao(\StructType\Situacao $situacao = null)
    {
        if (is_null($situacao) || (is_array($situacao) && empty($situacao))) {
            unset($this->situacao);
        } else {
            $this->situacao = $situacao;
        }
        return $this;
    }
}
