<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Idiomas StructType
 * @subpackage Structs
 */
class Idiomas extends AbstractStructBase
{
    /**
     * The codigo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $codigo;
    /**
     * The identificUnica
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $identificUnica;
    /**
     * The idiomasDesc
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IdiomasDesc
     */
    public $idiomasDesc;
    /**
     * The idiomasEscreve
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IdiomasDominio
     */
    public $idiomasEscreve;
    /**
     * The idiomasFala
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IdiomasDominio
     */
    public $idiomasFala;
    /**
     * The idiomasLe
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IdiomasDominio
     */
    public $idiomasLe;
    /**
     * Constructor method for Idiomas
     * @uses Idiomas::setCodigo()
     * @uses Idiomas::setIdentificUnica()
     * @uses Idiomas::setIdiomasDesc()
     * @uses Idiomas::setIdiomasEscreve()
     * @uses Idiomas::setIdiomasFala()
     * @uses Idiomas::setIdiomasLe()
     * @param int $codigo
     * @param string $identificUnica
     * @param \StructType\IdiomasDesc $idiomasDesc
     * @param \StructType\IdiomasDominio $idiomasEscreve
     * @param \StructType\IdiomasDominio $idiomasFala
     * @param \StructType\IdiomasDominio $idiomasLe
     */
    public function __construct($codigo = null, $identificUnica = null, \StructType\IdiomasDesc $idiomasDesc = null, \StructType\IdiomasDominio $idiomasEscreve = null, \StructType\IdiomasDominio $idiomasFala = null, \StructType\IdiomasDominio $idiomasLe = null)
    {
        $this
            ->setCodigo($codigo)
            ->setIdentificUnica($identificUnica)
            ->setIdiomasDesc($idiomasDesc)
            ->setIdiomasEscreve($idiomasEscreve)
            ->setIdiomasFala($idiomasFala)
            ->setIdiomasLe($idiomasLe);
    }
    /**
     * Get codigo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getCodigo()
    {
        return isset($this->codigo) ? $this->codigo : null;
    }
    /**
     * Set codigo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $codigo
     * @return \StructType\Idiomas
     */
    public function setCodigo($codigo = null)
    {
        // validation for constraint: int
        if (!is_null($codigo) && !(is_int($codigo) || ctype_digit($codigo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($codigo, true), gettype($codigo)), __LINE__);
        }
        if (is_null($codigo) || (is_array($codigo) && empty($codigo))) {
            unset($this->codigo);
        } else {
            $this->codigo = $codigo;
        }
        return $this;
    }
    /**
     * Get identificUnica value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdentificUnica()
    {
        return isset($this->identificUnica) ? $this->identificUnica : null;
    }
    /**
     * Set identificUnica value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $identificUnica
     * @return \StructType\Idiomas
     */
    public function setIdentificUnica($identificUnica = null)
    {
        // validation for constraint: string
        if (!is_null($identificUnica) && !is_string($identificUnica)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificUnica, true), gettype($identificUnica)), __LINE__);
        }
        if (is_null($identificUnica) || (is_array($identificUnica) && empty($identificUnica))) {
            unset($this->identificUnica);
        } else {
            $this->identificUnica = $identificUnica;
        }
        return $this;
    }
    /**
     * Get idiomasDesc value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IdiomasDesc|null
     */
    public function getIdiomasDesc()
    {
        return isset($this->idiomasDesc) ? $this->idiomasDesc : null;
    }
    /**
     * Set idiomasDesc value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\IdiomasDesc $idiomasDesc
     * @return \StructType\Idiomas
     */
    public function setIdiomasDesc(\StructType\IdiomasDesc $idiomasDesc = null)
    {
        if (is_null($idiomasDesc) || (is_array($idiomasDesc) && empty($idiomasDesc))) {
            unset($this->idiomasDesc);
        } else {
            $this->idiomasDesc = $idiomasDesc;
        }
        return $this;
    }
    /**
     * Get idiomasEscreve value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IdiomasDominio|null
     */
    public function getIdiomasEscreve()
    {
        return isset($this->idiomasEscreve) ? $this->idiomasEscreve : null;
    }
    /**
     * Set idiomasEscreve value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\IdiomasDominio $idiomasEscreve
     * @return \StructType\Idiomas
     */
    public function setIdiomasEscreve(\StructType\IdiomasDominio $idiomasEscreve = null)
    {
        if (is_null($idiomasEscreve) || (is_array($idiomasEscreve) && empty($idiomasEscreve))) {
            unset($this->idiomasEscreve);
        } else {
            $this->idiomasEscreve = $idiomasEscreve;
        }
        return $this;
    }
    /**
     * Get idiomasFala value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IdiomasDominio|null
     */
    public function getIdiomasFala()
    {
        return isset($this->idiomasFala) ? $this->idiomasFala : null;
    }
    /**
     * Set idiomasFala value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\IdiomasDominio $idiomasFala
     * @return \StructType\Idiomas
     */
    public function setIdiomasFala(\StructType\IdiomasDominio $idiomasFala = null)
    {
        if (is_null($idiomasFala) || (is_array($idiomasFala) && empty($idiomasFala))) {
            unset($this->idiomasFala);
        } else {
            $this->idiomasFala = $idiomasFala;
        }
        return $this;
    }
    /**
     * Get idiomasLe value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IdiomasDominio|null
     */
    public function getIdiomasLe()
    {
        return isset($this->idiomasLe) ? $this->idiomasLe : null;
    }
    /**
     * Set idiomasLe value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\IdiomasDominio $idiomasLe
     * @return \StructType\Idiomas
     */
    public function setIdiomasLe(\StructType\IdiomasDominio $idiomasLe = null)
    {
        if (is_null($idiomasLe) || (is_array($idiomasLe) && empty($idiomasLe))) {
            unset($this->idiomasLe);
        } else {
            $this->idiomasLe = $idiomasLe;
        }
        return $this;
    }
}
