<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InformacoesAposentadoria StructType
 * @subpackage Structs
 */
class InformacoesAposentadoria extends AbstractStructBase
{
    /**
     * The dataAposentadoria
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dataAposentadoria;
    /**
     * The orgaoAposentadoria
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $orgaoAposentadoria;
    /**
     * The orgaoAtual
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $orgaoAtual;
    /**
     * The orgaoTcuAposentadoria
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $orgaoTcuAposentadoria;
    /**
     * The orgaoTcuAtual
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $orgaoTcuAtual;
    /**
     * Constructor method for InformacoesAposentadoria
     * @uses InformacoesAposentadoria::setDataAposentadoria()
     * @uses InformacoesAposentadoria::setOrgaoAposentadoria()
     * @uses InformacoesAposentadoria::setOrgaoAtual()
     * @uses InformacoesAposentadoria::setOrgaoTcuAposentadoria()
     * @uses InformacoesAposentadoria::setOrgaoTcuAtual()
     * @param string $dataAposentadoria
     * @param string $orgaoAposentadoria
     * @param string $orgaoAtual
     * @param string $orgaoTcuAposentadoria
     * @param string $orgaoTcuAtual
     */
    public function __construct($dataAposentadoria = null, $orgaoAposentadoria = null, $orgaoAtual = null, $orgaoTcuAposentadoria = null, $orgaoTcuAtual = null)
    {
        $this
            ->setDataAposentadoria($dataAposentadoria)
            ->setOrgaoAposentadoria($orgaoAposentadoria)
            ->setOrgaoAtual($orgaoAtual)
            ->setOrgaoTcuAposentadoria($orgaoTcuAposentadoria)
            ->setOrgaoTcuAtual($orgaoTcuAtual);
    }
    /**
     * Get dataAposentadoria value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataAposentadoria()
    {
        return isset($this->dataAposentadoria) ? $this->dataAposentadoria : null;
    }
    /**
     * Set dataAposentadoria value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataAposentadoria
     * @return \StructType\InformacoesAposentadoria
     */
    public function setDataAposentadoria($dataAposentadoria = null)
    {
        // validation for constraint: string
        if (!is_null($dataAposentadoria) && !is_string($dataAposentadoria)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataAposentadoria, true), gettype($dataAposentadoria)), __LINE__);
        }
        if (is_null($dataAposentadoria) || (is_array($dataAposentadoria) && empty($dataAposentadoria))) {
            unset($this->dataAposentadoria);
        } else {
            $this->dataAposentadoria = $dataAposentadoria;
        }
        return $this;
    }
    /**
     * Get orgaoAposentadoria value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOrgaoAposentadoria()
    {
        return isset($this->orgaoAposentadoria) ? $this->orgaoAposentadoria : null;
    }
    /**
     * Set orgaoAposentadoria value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $orgaoAposentadoria
     * @return \StructType\InformacoesAposentadoria
     */
    public function setOrgaoAposentadoria($orgaoAposentadoria = null)
    {
        // validation for constraint: string
        if (!is_null($orgaoAposentadoria) && !is_string($orgaoAposentadoria)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($orgaoAposentadoria, true), gettype($orgaoAposentadoria)), __LINE__);
        }
        if (is_null($orgaoAposentadoria) || (is_array($orgaoAposentadoria) && empty($orgaoAposentadoria))) {
            unset($this->orgaoAposentadoria);
        } else {
            $this->orgaoAposentadoria = $orgaoAposentadoria;
        }
        return $this;
    }
    /**
     * Get orgaoAtual value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOrgaoAtual()
    {
        return isset($this->orgaoAtual) ? $this->orgaoAtual : null;
    }
    /**
     * Set orgaoAtual value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $orgaoAtual
     * @return \StructType\InformacoesAposentadoria
     */
    public function setOrgaoAtual($orgaoAtual = null)
    {
        // validation for constraint: string
        if (!is_null($orgaoAtual) && !is_string($orgaoAtual)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($orgaoAtual, true), gettype($orgaoAtual)), __LINE__);
        }
        if (is_null($orgaoAtual) || (is_array($orgaoAtual) && empty($orgaoAtual))) {
            unset($this->orgaoAtual);
        } else {
            $this->orgaoAtual = $orgaoAtual;
        }
        return $this;
    }
    /**
     * Get orgaoTcuAposentadoria value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOrgaoTcuAposentadoria()
    {
        return isset($this->orgaoTcuAposentadoria) ? $this->orgaoTcuAposentadoria : null;
    }
    /**
     * Set orgaoTcuAposentadoria value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $orgaoTcuAposentadoria
     * @return \StructType\InformacoesAposentadoria
     */
    public function setOrgaoTcuAposentadoria($orgaoTcuAposentadoria = null)
    {
        // validation for constraint: string
        if (!is_null($orgaoTcuAposentadoria) && !is_string($orgaoTcuAposentadoria)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($orgaoTcuAposentadoria, true), gettype($orgaoTcuAposentadoria)), __LINE__);
        }
        if (is_null($orgaoTcuAposentadoria) || (is_array($orgaoTcuAposentadoria) && empty($orgaoTcuAposentadoria))) {
            unset($this->orgaoTcuAposentadoria);
        } else {
            $this->orgaoTcuAposentadoria = $orgaoTcuAposentadoria;
        }
        return $this;
    }
    /**
     * Get orgaoTcuAtual value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOrgaoTcuAtual()
    {
        return isset($this->orgaoTcuAtual) ? $this->orgaoTcuAtual : null;
    }
    /**
     * Set orgaoTcuAtual value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $orgaoTcuAtual
     * @return \StructType\InformacoesAposentadoria
     */
    public function setOrgaoTcuAtual($orgaoTcuAtual = null)
    {
        // validation for constraint: string
        if (!is_null($orgaoTcuAtual) && !is_string($orgaoTcuAtual)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($orgaoTcuAtual, true), gettype($orgaoTcuAtual)), __LINE__);
        }
        if (is_null($orgaoTcuAtual) || (is_array($orgaoTcuAtual) && empty($orgaoTcuAtual))) {
            unset($this->orgaoTcuAtual);
        } else {
            $this->orgaoTcuAtual = $orgaoTcuAtual;
        }
        return $this;
    }
}
