<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ParticipacaoComissoes StructType
 * @subpackage Structs
 */
class ParticipacaoComissoes extends AbstractStructBase
{
    /**
     * The codigo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $codigo;
    /**
     * The dataFim
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dataFim;
    /**
     * The dataInicio
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dataInicio;
    /**
     * The identificUnica
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $identificUnica;
    /**
     * The infoAdicionais
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $infoAdicionais;
    /**
     * The tipoDesc
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $tipoDesc;
    /**
     * The tipoParticipacaoComissoes
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TipoParticipacaoComissoes
     */
    public $tipoParticipacaoComissoes;
    /**
     * Constructor method for ParticipacaoComissoes
     * @uses ParticipacaoComissoes::setCodigo()
     * @uses ParticipacaoComissoes::setDataFim()
     * @uses ParticipacaoComissoes::setDataInicio()
     * @uses ParticipacaoComissoes::setIdentificUnica()
     * @uses ParticipacaoComissoes::setInfoAdicionais()
     * @uses ParticipacaoComissoes::setTipoDesc()
     * @uses ParticipacaoComissoes::setTipoParticipacaoComissoes()
     * @param int $codigo
     * @param string $dataFim
     * @param string $dataInicio
     * @param string $identificUnica
     * @param string $infoAdicionais
     * @param string $tipoDesc
     * @param \StructType\TipoParticipacaoComissoes $tipoParticipacaoComissoes
     */
    public function __construct($codigo = null, $dataFim = null, $dataInicio = null, $identificUnica = null, $infoAdicionais = null, $tipoDesc = null, \StructType\TipoParticipacaoComissoes $tipoParticipacaoComissoes = null)
    {
        $this
            ->setCodigo($codigo)
            ->setDataFim($dataFim)
            ->setDataInicio($dataInicio)
            ->setIdentificUnica($identificUnica)
            ->setInfoAdicionais($infoAdicionais)
            ->setTipoDesc($tipoDesc)
            ->setTipoParticipacaoComissoes($tipoParticipacaoComissoes);
    }
    /**
     * Get codigo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getCodigo()
    {
        return isset($this->codigo) ? $this->codigo : null;
    }
    /**
     * Set codigo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $codigo
     * @return \StructType\ParticipacaoComissoes
     */
    public function setCodigo($codigo = null)
    {
        // validation for constraint: int
        if (!is_null($codigo) && !(is_int($codigo) || ctype_digit($codigo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($codigo, true), gettype($codigo)), __LINE__);
        }
        if (is_null($codigo) || (is_array($codigo) && empty($codigo))) {
            unset($this->codigo);
        } else {
            $this->codigo = $codigo;
        }
        return $this;
    }
    /**
     * Get dataFim value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataFim()
    {
        return isset($this->dataFim) ? $this->dataFim : null;
    }
    /**
     * Set dataFim value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataFim
     * @return \StructType\ParticipacaoComissoes
     */
    public function setDataFim($dataFim = null)
    {
        // validation for constraint: string
        if (!is_null($dataFim) && !is_string($dataFim)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataFim, true), gettype($dataFim)), __LINE__);
        }
        if (is_null($dataFim) || (is_array($dataFim) && empty($dataFim))) {
            unset($this->dataFim);
        } else {
            $this->dataFim = $dataFim;
        }
        return $this;
    }
    /**
     * Get dataInicio value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataInicio()
    {
        return isset($this->dataInicio) ? $this->dataInicio : null;
    }
    /**
     * Set dataInicio value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataInicio
     * @return \StructType\ParticipacaoComissoes
     */
    public function setDataInicio($dataInicio = null)
    {
        // validation for constraint: string
        if (!is_null($dataInicio) && !is_string($dataInicio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataInicio, true), gettype($dataInicio)), __LINE__);
        }
        if (is_null($dataInicio) || (is_array($dataInicio) && empty($dataInicio))) {
            unset($this->dataInicio);
        } else {
            $this->dataInicio = $dataInicio;
        }
        return $this;
    }
    /**
     * Get identificUnica value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdentificUnica()
    {
        return isset($this->identificUnica) ? $this->identificUnica : null;
    }
    /**
     * Set identificUnica value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $identificUnica
     * @return \StructType\ParticipacaoComissoes
     */
    public function setIdentificUnica($identificUnica = null)
    {
        // validation for constraint: string
        if (!is_null($identificUnica) && !is_string($identificUnica)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificUnica, true), gettype($identificUnica)), __LINE__);
        }
        if (is_null($identificUnica) || (is_array($identificUnica) && empty($identificUnica))) {
            unset($this->identificUnica);
        } else {
            $this->identificUnica = $identificUnica;
        }
        return $this;
    }
    /**
     * Get infoAdicionais value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInfoAdicionais()
    {
        return isset($this->infoAdicionais) ? $this->infoAdicionais : null;
    }
    /**
     * Set infoAdicionais value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $infoAdicionais
     * @return \StructType\ParticipacaoComissoes
     */
    public function setInfoAdicionais($infoAdicionais = null)
    {
        // validation for constraint: string
        if (!is_null($infoAdicionais) && !is_string($infoAdicionais)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($infoAdicionais, true), gettype($infoAdicionais)), __LINE__);
        }
        if (is_null($infoAdicionais) || (is_array($infoAdicionais) && empty($infoAdicionais))) {
            unset($this->infoAdicionais);
        } else {
            $this->infoAdicionais = $infoAdicionais;
        }
        return $this;
    }
    /**
     * Get tipoDesc value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTipoDesc()
    {
        return isset($this->tipoDesc) ? $this->tipoDesc : null;
    }
    /**
     * Set tipoDesc value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tipoDesc
     * @return \StructType\ParticipacaoComissoes
     */
    public function setTipoDesc($tipoDesc = null)
    {
        // validation for constraint: string
        if (!is_null($tipoDesc) && !is_string($tipoDesc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tipoDesc, true), gettype($tipoDesc)), __LINE__);
        }
        if (is_null($tipoDesc) || (is_array($tipoDesc) && empty($tipoDesc))) {
            unset($this->tipoDesc);
        } else {
            $this->tipoDesc = $tipoDesc;
        }
        return $this;
    }
    /**
     * Get tipoParticipacaoComissoes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TipoParticipacaoComissoes|null
     */
    public function getTipoParticipacaoComissoes()
    {
        return isset($this->tipoParticipacaoComissoes) ? $this->tipoParticipacaoComissoes : null;
    }
    /**
     * Set tipoParticipacaoComissoes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\TipoParticipacaoComissoes $tipoParticipacaoComissoes
     * @return \StructType\ParticipacaoComissoes
     */
    public function setTipoParticipacaoComissoes(\StructType\TipoParticipacaoComissoes $tipoParticipacaoComissoes = null)
    {
        if (is_null($tipoParticipacaoComissoes) || (is_array($tipoParticipacaoComissoes) && empty($tipoParticipacaoComissoes))) {
            unset($this->tipoParticipacaoComissoes);
        } else {
            $this->tipoParticipacaoComissoes = $tipoParticipacaoComissoes;
        }
        return $this;
    }
}
