<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Pensionista StructType
 * @subpackage Structs
 */
class Pensionista extends AbstractStructBase
{
    /**
     * The bairro
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $bairro;
    /**
     * The cep
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cep;
    /**
     * The cidade
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cidade;
    /**
     * The faixaEtaria
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $faixaEtaria;
    /**
     * The logradouro
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $logradouro;
    /**
     * The matriculaBeneficiario
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $matriculaBeneficiario;
    /**
     * The nome
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nome;
    /**
     * The numero
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $numero;
    /**
     * The orgao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfString
     */
    public $orgao;
    /**
     * The sexo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $sexo;
    /**
     * The uf
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $uf;
    /**
     * The upag
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfString
     */
    public $upag;
    /**
     * Constructor method for Pensionista
     * @uses Pensionista::setBairro()
     * @uses Pensionista::setCep()
     * @uses Pensionista::setCidade()
     * @uses Pensionista::setFaixaEtaria()
     * @uses Pensionista::setLogradouro()
     * @uses Pensionista::setMatriculaBeneficiario()
     * @uses Pensionista::setNome()
     * @uses Pensionista::setNumero()
     * @uses Pensionista::setOrgao()
     * @uses Pensionista::setSexo()
     * @uses Pensionista::setUf()
     * @uses Pensionista::setUpag()
     * @param string $bairro
     * @param string $cep
     * @param string $cidade
     * @param string $faixaEtaria
     * @param string $logradouro
     * @param string $matriculaBeneficiario
     * @param string $nome
     * @param string $numero
     * @param \ArrayType\ArrayOfString $orgao
     * @param string $sexo
     * @param string $uf
     * @param \ArrayType\ArrayOfString $upag
     */
    public function __construct($bairro = null, $cep = null, $cidade = null, $faixaEtaria = null, $logradouro = null, $matriculaBeneficiario = null, $nome = null, $numero = null, \ArrayType\ArrayOfString $orgao = null, $sexo = null, $uf = null, \ArrayType\ArrayOfString $upag = null)
    {
        $this
            ->setBairro($bairro)
            ->setCep($cep)
            ->setCidade($cidade)
            ->setFaixaEtaria($faixaEtaria)
            ->setLogradouro($logradouro)
            ->setMatriculaBeneficiario($matriculaBeneficiario)
            ->setNome($nome)
            ->setNumero($numero)
            ->setOrgao($orgao)
            ->setSexo($sexo)
            ->setUf($uf)
            ->setUpag($upag);
    }
    /**
     * Get bairro value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBairro()
    {
        return isset($this->bairro) ? $this->bairro : null;
    }
    /**
     * Set bairro value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $bairro
     * @return \StructType\Pensionista
     */
    public function setBairro($bairro = null)
    {
        // validation for constraint: string
        if (!is_null($bairro) && !is_string($bairro)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bairro, true), gettype($bairro)), __LINE__);
        }
        if (is_null($bairro) || (is_array($bairro) && empty($bairro))) {
            unset($this->bairro);
        } else {
            $this->bairro = $bairro;
        }
        return $this;
    }
    /**
     * Get cep value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCep()
    {
        return isset($this->cep) ? $this->cep : null;
    }
    /**
     * Set cep value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cep
     * @return \StructType\Pensionista
     */
    public function setCep($cep = null)
    {
        // validation for constraint: string
        if (!is_null($cep) && !is_string($cep)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cep, true), gettype($cep)), __LINE__);
        }
        if (is_null($cep) || (is_array($cep) && empty($cep))) {
            unset($this->cep);
        } else {
            $this->cep = $cep;
        }
        return $this;
    }
    /**
     * Get cidade value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCidade()
    {
        return isset($this->cidade) ? $this->cidade : null;
    }
    /**
     * Set cidade value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cidade
     * @return \StructType\Pensionista
     */
    public function setCidade($cidade = null)
    {
        // validation for constraint: string
        if (!is_null($cidade) && !is_string($cidade)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cidade, true), gettype($cidade)), __LINE__);
        }
        if (is_null($cidade) || (is_array($cidade) && empty($cidade))) {
            unset($this->cidade);
        } else {
            $this->cidade = $cidade;
        }
        return $this;
    }
    /**
     * Get faixaEtaria value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFaixaEtaria()
    {
        return isset($this->faixaEtaria) ? $this->faixaEtaria : null;
    }
    /**
     * Set faixaEtaria value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $faixaEtaria
     * @return \StructType\Pensionista
     */
    public function setFaixaEtaria($faixaEtaria = null)
    {
        // validation for constraint: string
        if (!is_null($faixaEtaria) && !is_string($faixaEtaria)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($faixaEtaria, true), gettype($faixaEtaria)), __LINE__);
        }
        if (is_null($faixaEtaria) || (is_array($faixaEtaria) && empty($faixaEtaria))) {
            unset($this->faixaEtaria);
        } else {
            $this->faixaEtaria = $faixaEtaria;
        }
        return $this;
    }
    /**
     * Get logradouro value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLogradouro()
    {
        return isset($this->logradouro) ? $this->logradouro : null;
    }
    /**
     * Set logradouro value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $logradouro
     * @return \StructType\Pensionista
     */
    public function setLogradouro($logradouro = null)
    {
        // validation for constraint: string
        if (!is_null($logradouro) && !is_string($logradouro)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($logradouro, true), gettype($logradouro)), __LINE__);
        }
        if (is_null($logradouro) || (is_array($logradouro) && empty($logradouro))) {
            unset($this->logradouro);
        } else {
            $this->logradouro = $logradouro;
        }
        return $this;
    }
    /**
     * Get matriculaBeneficiario value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMatriculaBeneficiario()
    {
        return isset($this->matriculaBeneficiario) ? $this->matriculaBeneficiario : null;
    }
    /**
     * Set matriculaBeneficiario value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $matriculaBeneficiario
     * @return \StructType\Pensionista
     */
    public function setMatriculaBeneficiario($matriculaBeneficiario = null)
    {
        // validation for constraint: string
        if (!is_null($matriculaBeneficiario) && !is_string($matriculaBeneficiario)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($matriculaBeneficiario, true), gettype($matriculaBeneficiario)), __LINE__);
        }
        if (is_null($matriculaBeneficiario) || (is_array($matriculaBeneficiario) && empty($matriculaBeneficiario))) {
            unset($this->matriculaBeneficiario);
        } else {
            $this->matriculaBeneficiario = $matriculaBeneficiario;
        }
        return $this;
    }
    /**
     * Get nome value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNome()
    {
        return isset($this->nome) ? $this->nome : null;
    }
    /**
     * Set nome value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nome
     * @return \StructType\Pensionista
     */
    public function setNome($nome = null)
    {
        // validation for constraint: string
        if (!is_null($nome) && !is_string($nome)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nome, true), gettype($nome)), __LINE__);
        }
        if (is_null($nome) || (is_array($nome) && empty($nome))) {
            unset($this->nome);
        } else {
            $this->nome = $nome;
        }
        return $this;
    }
    /**
     * Get numero value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNumero()
    {
        return isset($this->numero) ? $this->numero : null;
    }
    /**
     * Set numero value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $numero
     * @return \StructType\Pensionista
     */
    public function setNumero($numero = null)
    {
        // validation for constraint: string
        if (!is_null($numero) && !is_string($numero)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($numero, true), gettype($numero)), __LINE__);
        }
        if (is_null($numero) || (is_array($numero) && empty($numero))) {
            unset($this->numero);
        } else {
            $this->numero = $numero;
        }
        return $this;
    }
    /**
     * Get orgao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfString|null
     */
    public function getOrgao()
    {
        return isset($this->orgao) ? $this->orgao : null;
    }
    /**
     * Set orgao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfString $orgao
     * @return \StructType\Pensionista
     */
    public function setOrgao(\ArrayType\ArrayOfString $orgao = null)
    {
        if (is_null($orgao) || (is_array($orgao) && empty($orgao))) {
            unset($this->orgao);
        } else {
            $this->orgao = $orgao;
        }
        return $this;
    }
    /**
     * Get sexo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSexo()
    {
        return isset($this->sexo) ? $this->sexo : null;
    }
    /**
     * Set sexo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sexo
     * @return \StructType\Pensionista
     */
    public function setSexo($sexo = null)
    {
        // validation for constraint: string
        if (!is_null($sexo) && !is_string($sexo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sexo, true), gettype($sexo)), __LINE__);
        }
        if (is_null($sexo) || (is_array($sexo) && empty($sexo))) {
            unset($this->sexo);
        } else {
            $this->sexo = $sexo;
        }
        return $this;
    }
    /**
     * Get uf value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUf()
    {
        return isset($this->uf) ? $this->uf : null;
    }
    /**
     * Set uf value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $uf
     * @return \StructType\Pensionista
     */
    public function setUf($uf = null)
    {
        // validation for constraint: string
        if (!is_null($uf) && !is_string($uf)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uf, true), gettype($uf)), __LINE__);
        }
        if (is_null($uf) || (is_array($uf) && empty($uf))) {
            unset($this->uf);
        } else {
            $this->uf = $uf;
        }
        return $this;
    }
    /**
     * Get upag value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfString|null
     */
    public function getUpag()
    {
        return isset($this->upag) ? $this->upag : null;
    }
    /**
     * Set upag value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfString $upag
     * @return \StructType\Pensionista
     */
    public function setUpag(\ArrayType\ArrayOfString $upag = null)
    {
        if (is_null($upag) || (is_array($upag) && empty($upag))) {
            unset($this->upag);
        } else {
            $this->upag = $upag;
        }
        return $this;
    }
}
