<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Servidor StructType
 * @subpackage Structs
 */
class Servidor extends AbstractStructBase
{
    /**
     * The cpf
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cpf;
    /**
     * The dataUltimaTransacao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dataUltimaTransacao;
    /**
     * Constructor method for Servidor
     * @uses Servidor::setCpf()
     * @uses Servidor::setDataUltimaTransacao()
     * @param string $cpf
     * @param string $dataUltimaTransacao
     */
    public function __construct($cpf = null, $dataUltimaTransacao = null)
    {
        $this
            ->setCpf($cpf)
            ->setDataUltimaTransacao($dataUltimaTransacao);
    }
    /**
     * Get cpf value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCpf()
    {
        return isset($this->cpf) ? $this->cpf : null;
    }
    /**
     * Set cpf value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cpf
     * @return \StructType\Servidor
     */
    public function setCpf($cpf = null)
    {
        // validation for constraint: string
        if (!is_null($cpf) && !is_string($cpf)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cpf, true), gettype($cpf)), __LINE__);
        }
        if (is_null($cpf) || (is_array($cpf) && empty($cpf))) {
            unset($this->cpf);
        } else {
            $this->cpf = $cpf;
        }
        return $this;
    }
    /**
     * Get dataUltimaTransacao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataUltimaTransacao()
    {
        return isset($this->dataUltimaTransacao) ? $this->dataUltimaTransacao : null;
    }
    /**
     * Set dataUltimaTransacao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataUltimaTransacao
     * @return \StructType\Servidor
     */
    public function setDataUltimaTransacao($dataUltimaTransacao = null)
    {
        // validation for constraint: string
        if (!is_null($dataUltimaTransacao) && !is_string($dataUltimaTransacao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataUltimaTransacao, true), gettype($dataUltimaTransacao)), __LINE__);
        }
        if (is_null($dataUltimaTransacao) || (is_array($dataUltimaTransacao) && empty($dataUltimaTransacao))) {
            unset($this->dataUltimaTransacao);
        } else {
            $this->dataUltimaTransacao = $dataUltimaTransacao;
        }
        return $this;
    }
}
