<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServidorIndicadorAutorizacaoIRPF StructType
 * @subpackage Structs
 */
class ServidorIndicadorAutorizacaoIRPF extends AbstractStructBase
{
    /**
     * The cpf
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cpf;
    /**
     * The indicadorAutorizacao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $indicadorAutorizacao;
    /**
     * Constructor method for ServidorIndicadorAutorizacaoIRPF
     * @uses ServidorIndicadorAutorizacaoIRPF::setCpf()
     * @uses ServidorIndicadorAutorizacaoIRPF::setIndicadorAutorizacao()
     * @param string $cpf
     * @param string $indicadorAutorizacao
     */
    public function __construct($cpf = null, $indicadorAutorizacao = null)
    {
        $this
            ->setCpf($cpf)
            ->setIndicadorAutorizacao($indicadorAutorizacao);
    }
    /**
     * Get cpf value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCpf()
    {
        return isset($this->cpf) ? $this->cpf : null;
    }
    /**
     * Set cpf value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cpf
     * @return \StructType\ServidorIndicadorAutorizacaoIRPF
     */
    public function setCpf($cpf = null)
    {
        // validation for constraint: string
        if (!is_null($cpf) && !is_string($cpf)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cpf, true), gettype($cpf)), __LINE__);
        }
        if (is_null($cpf) || (is_array($cpf) && empty($cpf))) {
            unset($this->cpf);
        } else {
            $this->cpf = $cpf;
        }
        return $this;
    }
    /**
     * Get indicadorAutorizacao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIndicadorAutorizacao()
    {
        return isset($this->indicadorAutorizacao) ? $this->indicadorAutorizacao : null;
    }
    /**
     * Set indicadorAutorizacao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $indicadorAutorizacao
     * @return \StructType\ServidorIndicadorAutorizacaoIRPF
     */
    public function setIndicadorAutorizacao($indicadorAutorizacao = null)
    {
        // validation for constraint: string
        if (!is_null($indicadorAutorizacao) && !is_string($indicadorAutorizacao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($indicadorAutorizacao, true), gettype($indicadorAutorizacao)), __LINE__);
        }
        if (is_null($indicadorAutorizacao) || (is_array($indicadorAutorizacao) && empty($indicadorAutorizacao))) {
            unset($this->indicadorAutorizacao);
        } else {
            $this->indicadorAutorizacao = $indicadorAutorizacao;
        }
        return $this;
    }
}
