<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TotalVagasOrgao StructType
 * @subpackage Structs
 */
class TotalVagasOrgao extends AbstractStructBase
{
    /**
     * The codNatJuridica
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $codNatJuridica;
    /**
     * The nomeNatJuridica
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nomeNatJuridica;
    /**
     * The vagasPorOrgao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfVagasOrgao
     */
    public $vagasPorOrgao;
    /**
     * Constructor method for TotalVagasOrgao
     * @uses TotalVagasOrgao::setCodNatJuridica()
     * @uses TotalVagasOrgao::setNomeNatJuridica()
     * @uses TotalVagasOrgao::setVagasPorOrgao()
     * @param string $codNatJuridica
     * @param string $nomeNatJuridica
     * @param \ArrayType\ArrayOfVagasOrgao $vagasPorOrgao
     */
    public function __construct($codNatJuridica = null, $nomeNatJuridica = null, \ArrayType\ArrayOfVagasOrgao $vagasPorOrgao = null)
    {
        $this
            ->setCodNatJuridica($codNatJuridica)
            ->setNomeNatJuridica($nomeNatJuridica)
            ->setVagasPorOrgao($vagasPorOrgao);
    }
    /**
     * Get codNatJuridica value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodNatJuridica()
    {
        return isset($this->codNatJuridica) ? $this->codNatJuridica : null;
    }
    /**
     * Set codNatJuridica value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codNatJuridica
     * @return \StructType\TotalVagasOrgao
     */
    public function setCodNatJuridica($codNatJuridica = null)
    {
        // validation for constraint: string
        if (!is_null($codNatJuridica) && !is_string($codNatJuridica)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codNatJuridica, true), gettype($codNatJuridica)), __LINE__);
        }
        if (is_null($codNatJuridica) || (is_array($codNatJuridica) && empty($codNatJuridica))) {
            unset($this->codNatJuridica);
        } else {
            $this->codNatJuridica = $codNatJuridica;
        }
        return $this;
    }
    /**
     * Get nomeNatJuridica value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNomeNatJuridica()
    {
        return isset($this->nomeNatJuridica) ? $this->nomeNatJuridica : null;
    }
    /**
     * Set nomeNatJuridica value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nomeNatJuridica
     * @return \StructType\TotalVagasOrgao
     */
    public function setNomeNatJuridica($nomeNatJuridica = null)
    {
        // validation for constraint: string
        if (!is_null($nomeNatJuridica) && !is_string($nomeNatJuridica)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nomeNatJuridica, true), gettype($nomeNatJuridica)), __LINE__);
        }
        if (is_null($nomeNatJuridica) || (is_array($nomeNatJuridica) && empty($nomeNatJuridica))) {
            unset($this->nomeNatJuridica);
        } else {
            $this->nomeNatJuridica = $nomeNatJuridica;
        }
        return $this;
    }
    /**
     * Get vagasPorOrgao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfVagasOrgao|null
     */
    public function getVagasPorOrgao()
    {
        return isset($this->vagasPorOrgao) ? $this->vagasPorOrgao : null;
    }
    /**
     * Set vagasPorOrgao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfVagasOrgao $vagasPorOrgao
     * @return \StructType\TotalVagasOrgao
     */
    public function setVagasPorOrgao(\ArrayType\ArrayOfVagasOrgao $vagasPorOrgao = null)
    {
        if (is_null($vagasPorOrgao) || (is_array($vagasPorOrgao) && empty($vagasPorOrgao))) {
            unset($this->vagasPorOrgao);
        } else {
            $this->vagasPorOrgao = $vagasPorOrgao;
        }
        return $this;
    }
}
