<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Upag StructType
 * @subpackage Structs
 */
class Upag extends AbstractStructBase
{
    /**
     * The codigo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $codigo;
    /**
     * The dataUltimaTransacao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dataUltimaTransacao;
    /**
     * The nome
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nome;
    /**
     * Constructor method for Upag
     * @uses Upag::setCodigo()
     * @uses Upag::setDataUltimaTransacao()
     * @uses Upag::setNome()
     * @param string $codigo
     * @param string $dataUltimaTransacao
     * @param string $nome
     */
    public function __construct($codigo = null, $dataUltimaTransacao = null, $nome = null)
    {
        $this
            ->setCodigo($codigo)
            ->setDataUltimaTransacao($dataUltimaTransacao)
            ->setNome($nome);
    }
    /**
     * Get codigo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodigo()
    {
        return isset($this->codigo) ? $this->codigo : null;
    }
    /**
     * Set codigo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codigo
     * @return \StructType\Upag
     */
    public function setCodigo($codigo = null)
    {
        // validation for constraint: string
        if (!is_null($codigo) && !is_string($codigo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codigo, true), gettype($codigo)), __LINE__);
        }
        if (is_null($codigo) || (is_array($codigo) && empty($codigo))) {
            unset($this->codigo);
        } else {
            $this->codigo = $codigo;
        }
        return $this;
    }
    /**
     * Get dataUltimaTransacao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataUltimaTransacao()
    {
        return isset($this->dataUltimaTransacao) ? $this->dataUltimaTransacao : null;
    }
    /**
     * Set dataUltimaTransacao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataUltimaTransacao
     * @return \StructType\Upag
     */
    public function setDataUltimaTransacao($dataUltimaTransacao = null)
    {
        // validation for constraint: string
        if (!is_null($dataUltimaTransacao) && !is_string($dataUltimaTransacao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataUltimaTransacao, true), gettype($dataUltimaTransacao)), __LINE__);
        }
        if (is_null($dataUltimaTransacao) || (is_array($dataUltimaTransacao) && empty($dataUltimaTransacao))) {
            unset($this->dataUltimaTransacao);
        } else {
            $this->dataUltimaTransacao = $dataUltimaTransacao;
        }
        return $this;
    }
    /**
     * Get nome value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNome()
    {
        return isset($this->nome) ? $this->nome : null;
    }
    /**
     * Set nome value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nome
     * @return \StructType\Upag
     */
    public function setNome($nome = null)
    {
        // validation for constraint: string
        if (!is_null($nome) && !is_string($nome)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nome, true), gettype($nome)), __LINE__);
        }
        if (is_null($nome) || (is_array($nome) && empty($nome))) {
            unset($this->nome);
        } else {
            $this->nome = $nome;
        }
        return $this;
    }
}
