<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VagasOrgao StructType
 * @subpackage Structs
 */
class VagasOrgao extends AbstractStructBase
{
    /**
     * The funcoesOrgao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $funcoesOrgao;
    /**
     * The quantVagaFuncaoLivre
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $quantVagaFuncaoLivre;
    /**
     * The quantVagaFuncaoOcupada
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $quantVagaFuncaoOcupada;
    /**
     * Constructor method for VagasOrgao
     * @uses VagasOrgao::setFuncoesOrgao()
     * @uses VagasOrgao::setQuantVagaFuncaoLivre()
     * @uses VagasOrgao::setQuantVagaFuncaoOcupada()
     * @param string $funcoesOrgao
     * @param string $quantVagaFuncaoLivre
     * @param string $quantVagaFuncaoOcupada
     */
    public function __construct($funcoesOrgao = null, $quantVagaFuncaoLivre = null, $quantVagaFuncaoOcupada = null)
    {
        $this
            ->setFuncoesOrgao($funcoesOrgao)
            ->setQuantVagaFuncaoLivre($quantVagaFuncaoLivre)
            ->setQuantVagaFuncaoOcupada($quantVagaFuncaoOcupada);
    }
    /**
     * Get funcoesOrgao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFuncoesOrgao()
    {
        return isset($this->funcoesOrgao) ? $this->funcoesOrgao : null;
    }
    /**
     * Set funcoesOrgao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $funcoesOrgao
     * @return \StructType\VagasOrgao
     */
    public function setFuncoesOrgao($funcoesOrgao = null)
    {
        // validation for constraint: string
        if (!is_null($funcoesOrgao) && !is_string($funcoesOrgao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($funcoesOrgao, true), gettype($funcoesOrgao)), __LINE__);
        }
        if (is_null($funcoesOrgao) || (is_array($funcoesOrgao) && empty($funcoesOrgao))) {
            unset($this->funcoesOrgao);
        } else {
            $this->funcoesOrgao = $funcoesOrgao;
        }
        return $this;
    }
    /**
     * Get quantVagaFuncaoLivre value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getQuantVagaFuncaoLivre()
    {
        return isset($this->quantVagaFuncaoLivre) ? $this->quantVagaFuncaoLivre : null;
    }
    /**
     * Set quantVagaFuncaoLivre value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $quantVagaFuncaoLivre
     * @return \StructType\VagasOrgao
     */
    public function setQuantVagaFuncaoLivre($quantVagaFuncaoLivre = null)
    {
        // validation for constraint: string
        if (!is_null($quantVagaFuncaoLivre) && !is_string($quantVagaFuncaoLivre)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($quantVagaFuncaoLivre, true), gettype($quantVagaFuncaoLivre)), __LINE__);
        }
        if (is_null($quantVagaFuncaoLivre) || (is_array($quantVagaFuncaoLivre) && empty($quantVagaFuncaoLivre))) {
            unset($this->quantVagaFuncaoLivre);
        } else {
            $this->quantVagaFuncaoLivre = $quantVagaFuncaoLivre;
        }
        return $this;
    }
    /**
     * Get quantVagaFuncaoOcupada value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getQuantVagaFuncaoOcupada()
    {
        return isset($this->quantVagaFuncaoOcupada) ? $this->quantVagaFuncaoOcupada : null;
    }
    /**
     * Set quantVagaFuncaoOcupada value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $quantVagaFuncaoOcupada
     * @return \StructType\VagasOrgao
     */
    public function setQuantVagaFuncaoOcupada($quantVagaFuncaoOcupada = null)
    {
        // validation for constraint: string
        if (!is_null($quantVagaFuncaoOcupada) && !is_string($quantVagaFuncaoOcupada)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($quantVagaFuncaoOcupada, true), gettype($quantVagaFuncaoOcupada)), __LINE__);
        }
        if (is_null($quantVagaFuncaoOcupada) || (is_array($quantVagaFuncaoOcupada) && empty($quantVagaFuncaoOcupada))) {
            unset($this->quantVagaFuncaoOcupada);
        } else {
            $this->quantVagaFuncaoOcupada = $quantVagaFuncaoOcupada;
        }
        return $this;
    }
}
