<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Vinculo StructType
 * @subpackage Structs
 */
class Vinculo extends AbstractStructBase
{
    /**
     * The dataFimBeneficio
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dataFimBeneficio;
    /**
     * The dataInicioBeneficio
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dataInicioBeneficio;
    /**
     * The dataOcorrAposentadoria
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dataOcorrAposentadoria;
    /**
     * The dataOcorrExclusao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dataOcorrExclusao;
    /**
     * The dataOcorrIngressoOrgao
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dataOcorrIngressoOrgao;
    /**
     * The dataOcorrIngressoServPublico
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $dataOcorrIngressoServPublico;
    /**
     * The nomeRegimeJuridico
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nomeRegimeJuridico;
    /**
     * The nomeSitFuncional
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nomeSitFuncional;
    /**
     * Constructor method for Vinculo
     * @uses Vinculo::setDataFimBeneficio()
     * @uses Vinculo::setDataInicioBeneficio()
     * @uses Vinculo::setDataOcorrAposentadoria()
     * @uses Vinculo::setDataOcorrExclusao()
     * @uses Vinculo::setDataOcorrIngressoOrgao()
     * @uses Vinculo::setDataOcorrIngressoServPublico()
     * @uses Vinculo::setNomeRegimeJuridico()
     * @uses Vinculo::setNomeSitFuncional()
     * @param string $dataFimBeneficio
     * @param string $dataInicioBeneficio
     * @param string $dataOcorrAposentadoria
     * @param string $dataOcorrExclusao
     * @param string $dataOcorrIngressoOrgao
     * @param string $dataOcorrIngressoServPublico
     * @param string $nomeRegimeJuridico
     * @param string $nomeSitFuncional
     */
    public function __construct($dataFimBeneficio = null, $dataInicioBeneficio = null, $dataOcorrAposentadoria = null, $dataOcorrExclusao = null, $dataOcorrIngressoOrgao = null, $dataOcorrIngressoServPublico = null, $nomeRegimeJuridico = null, $nomeSitFuncional = null)
    {
        $this
            ->setDataFimBeneficio($dataFimBeneficio)
            ->setDataInicioBeneficio($dataInicioBeneficio)
            ->setDataOcorrAposentadoria($dataOcorrAposentadoria)
            ->setDataOcorrExclusao($dataOcorrExclusao)
            ->setDataOcorrIngressoOrgao($dataOcorrIngressoOrgao)
            ->setDataOcorrIngressoServPublico($dataOcorrIngressoServPublico)
            ->setNomeRegimeJuridico($nomeRegimeJuridico)
            ->setNomeSitFuncional($nomeSitFuncional);
    }
    /**
     * Get dataFimBeneficio value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataFimBeneficio()
    {
        return isset($this->dataFimBeneficio) ? $this->dataFimBeneficio : null;
    }
    /**
     * Set dataFimBeneficio value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataFimBeneficio
     * @return \StructType\Vinculo
     */
    public function setDataFimBeneficio($dataFimBeneficio = null)
    {
        // validation for constraint: string
        if (!is_null($dataFimBeneficio) && !is_string($dataFimBeneficio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataFimBeneficio, true), gettype($dataFimBeneficio)), __LINE__);
        }
        if (is_null($dataFimBeneficio) || (is_array($dataFimBeneficio) && empty($dataFimBeneficio))) {
            unset($this->dataFimBeneficio);
        } else {
            $this->dataFimBeneficio = $dataFimBeneficio;
        }
        return $this;
    }
    /**
     * Get dataInicioBeneficio value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataInicioBeneficio()
    {
        return isset($this->dataInicioBeneficio) ? $this->dataInicioBeneficio : null;
    }
    /**
     * Set dataInicioBeneficio value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataInicioBeneficio
     * @return \StructType\Vinculo
     */
    public function setDataInicioBeneficio($dataInicioBeneficio = null)
    {
        // validation for constraint: string
        if (!is_null($dataInicioBeneficio) && !is_string($dataInicioBeneficio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataInicioBeneficio, true), gettype($dataInicioBeneficio)), __LINE__);
        }
        if (is_null($dataInicioBeneficio) || (is_array($dataInicioBeneficio) && empty($dataInicioBeneficio))) {
            unset($this->dataInicioBeneficio);
        } else {
            $this->dataInicioBeneficio = $dataInicioBeneficio;
        }
        return $this;
    }
    /**
     * Get dataOcorrAposentadoria value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataOcorrAposentadoria()
    {
        return isset($this->dataOcorrAposentadoria) ? $this->dataOcorrAposentadoria : null;
    }
    /**
     * Set dataOcorrAposentadoria value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataOcorrAposentadoria
     * @return \StructType\Vinculo
     */
    public function setDataOcorrAposentadoria($dataOcorrAposentadoria = null)
    {
        // validation for constraint: string
        if (!is_null($dataOcorrAposentadoria) && !is_string($dataOcorrAposentadoria)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataOcorrAposentadoria, true), gettype($dataOcorrAposentadoria)), __LINE__);
        }
        if (is_null($dataOcorrAposentadoria) || (is_array($dataOcorrAposentadoria) && empty($dataOcorrAposentadoria))) {
            unset($this->dataOcorrAposentadoria);
        } else {
            $this->dataOcorrAposentadoria = $dataOcorrAposentadoria;
        }
        return $this;
    }
    /**
     * Get dataOcorrExclusao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataOcorrExclusao()
    {
        return isset($this->dataOcorrExclusao) ? $this->dataOcorrExclusao : null;
    }
    /**
     * Set dataOcorrExclusao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataOcorrExclusao
     * @return \StructType\Vinculo
     */
    public function setDataOcorrExclusao($dataOcorrExclusao = null)
    {
        // validation for constraint: string
        if (!is_null($dataOcorrExclusao) && !is_string($dataOcorrExclusao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataOcorrExclusao, true), gettype($dataOcorrExclusao)), __LINE__);
        }
        if (is_null($dataOcorrExclusao) || (is_array($dataOcorrExclusao) && empty($dataOcorrExclusao))) {
            unset($this->dataOcorrExclusao);
        } else {
            $this->dataOcorrExclusao = $dataOcorrExclusao;
        }
        return $this;
    }
    /**
     * Get dataOcorrIngressoOrgao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataOcorrIngressoOrgao()
    {
        return isset($this->dataOcorrIngressoOrgao) ? $this->dataOcorrIngressoOrgao : null;
    }
    /**
     * Set dataOcorrIngressoOrgao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataOcorrIngressoOrgao
     * @return \StructType\Vinculo
     */
    public function setDataOcorrIngressoOrgao($dataOcorrIngressoOrgao = null)
    {
        // validation for constraint: string
        if (!is_null($dataOcorrIngressoOrgao) && !is_string($dataOcorrIngressoOrgao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataOcorrIngressoOrgao, true), gettype($dataOcorrIngressoOrgao)), __LINE__);
        }
        if (is_null($dataOcorrIngressoOrgao) || (is_array($dataOcorrIngressoOrgao) && empty($dataOcorrIngressoOrgao))) {
            unset($this->dataOcorrIngressoOrgao);
        } else {
            $this->dataOcorrIngressoOrgao = $dataOcorrIngressoOrgao;
        }
        return $this;
    }
    /**
     * Get dataOcorrIngressoServPublico value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataOcorrIngressoServPublico()
    {
        return isset($this->dataOcorrIngressoServPublico) ? $this->dataOcorrIngressoServPublico : null;
    }
    /**
     * Set dataOcorrIngressoServPublico value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataOcorrIngressoServPublico
     * @return \StructType\Vinculo
     */
    public function setDataOcorrIngressoServPublico($dataOcorrIngressoServPublico = null)
    {
        // validation for constraint: string
        if (!is_null($dataOcorrIngressoServPublico) && !is_string($dataOcorrIngressoServPublico)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataOcorrIngressoServPublico, true), gettype($dataOcorrIngressoServPublico)), __LINE__);
        }
        if (is_null($dataOcorrIngressoServPublico) || (is_array($dataOcorrIngressoServPublico) && empty($dataOcorrIngressoServPublico))) {
            unset($this->dataOcorrIngressoServPublico);
        } else {
            $this->dataOcorrIngressoServPublico = $dataOcorrIngressoServPublico;
        }
        return $this;
    }
    /**
     * Get nomeRegimeJuridico value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNomeRegimeJuridico()
    {
        return isset($this->nomeRegimeJuridico) ? $this->nomeRegimeJuridico : null;
    }
    /**
     * Set nomeRegimeJuridico value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nomeRegimeJuridico
     * @return \StructType\Vinculo
     */
    public function setNomeRegimeJuridico($nomeRegimeJuridico = null)
    {
        // validation for constraint: string
        if (!is_null($nomeRegimeJuridico) && !is_string($nomeRegimeJuridico)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nomeRegimeJuridico, true), gettype($nomeRegimeJuridico)), __LINE__);
        }
        if (is_null($nomeRegimeJuridico) || (is_array($nomeRegimeJuridico) && empty($nomeRegimeJuridico))) {
            unset($this->nomeRegimeJuridico);
        } else {
            $this->nomeRegimeJuridico = $nomeRegimeJuridico;
        }
        return $this;
    }
    /**
     * Get nomeSitFuncional value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNomeSitFuncional()
    {
        return isset($this->nomeSitFuncional) ? $this->nomeSitFuncional : null;
    }
    /**
     * Set nomeSitFuncional value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nomeSitFuncional
     * @return \StructType\Vinculo
     */
    public function setNomeSitFuncional($nomeSitFuncional = null)
    {
        // validation for constraint: string
        if (!is_null($nomeSitFuncional) && !is_string($nomeSitFuncional)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nomeSitFuncional, true), gettype($nomeSitFuncional)), __LINE__);
        }
        if (is_null($nomeSitFuncional) || (is_array($nomeSitFuncional) && empty($nomeSitFuncional))) {
            unset($this->nomeSitFuncional);
        } else {
            $this->nomeSitFuncional = $nomeSitFuncional;
        }
        return $this;
    }
}
